Package: ribosomeProfilingQC
Type: Package
Title: Ribosome Profiling Quality Control
Version: 1.25.0
Authors@R: c(person(given="Jianhong", family="Ou", email="jou@morgridge.org", 
        role=c("aut", "cre"), comment=c(ORCID="0000-0002-8652-2488")),
        person(given="Mariah", family="Hoye", email="mariah.hoye@duke.edu",
        role=c("aut")))
Description: Ribo-Seq (also named ribosome profiling or footprinting) 
        measures translatome (unlike RNA-Seq, which sequences the transcriptome)
        by direct quantification of the ribosome-protected fragments (RPFs). 
        This package provides the tools for quality assessment of ribosome 
        profiling. In addition, it can preprocess Ribo-Seq data for subsequent
        differential analysis. 
License: GPL (>=3) + file LICENSE
Encoding: UTF-8
biocViews: RiboSeq, Sequencing, GeneRegulation, QualityControl,
        Visualization, Coverage
VignetteBuilder: knitr
RoxygenNote: 7.3.2
Depends: R (>= 4.0), GenomicRanges
Imports: AnnotationDbi, BiocGenerics, Biostrings, BSgenome, EDASeq,
        GenomicAlignments, GenomicFeatures, Seqinfo, GenomeInfoDb,
        IRanges, methods, motifStack, rtracklayer, Rsamtools, RUVSeq,
        Rsubread, S4Vectors, XVector, ggplot2, ggfittext, scales,
        ggrepel, utils, cluster, stats, graphics, grid, txdbmaker,
        ggExtra
Suggests: RUnit, BiocStyle, knitr, BSgenome.Drerio.UCSC.danRer10,
        GenomeInfoDbData, edgeR, DESeq2, limma, ashr, testthat,
        rmarkdown, vsn, Biobase
git_url: https://git.bioconductor.org/packages/ribosomeProfilingQC
git_branch: devel
git_last_commit: a19b5ff
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:44:10 UTC; biocbuild
Author: Jianhong Ou [aut, cre] (ORCID: <https://orcid.org/0000-0002-8652-2488>),
  Mariah Hoye [aut]
Maintainer: Jianhong Ou <jou@morgridge.org>

# ribosomeProfilingQC
An R package for quality assessment of ribosome profiling

## Installation

To install this package, start R and enter:

```r
library(BiocManager)
BiocManager::install("jianhong/ribosomeProfilingQC")
```

## Documentation

To view documentation of ribosomeProfilingQC, start R and enter:
```r
browseVignettes("ribosomeProfilingQC")
```

#' Normalize the TE by Loess
#' @description
#' Fitting the translational efficiency values with the mRNA value by \link[stats]{loess}.
#' @param TE output of \link{translationalEfficiency}.
#' @param log2 logical(1L). Do log2 transform for TE or not. If TE value is not
#' log2 transformed, please set it as TRUE.
#' @param pseudocount The number will be add to sum of reads count to avoid X/0.
#' @param span,family.loess Parameters will be passed to \link[stats]{loess}
#' @return A list with RPFs, mRNA levels and TE as a matrix with
#' log2 transformed translational efficiency.
#' @importFrom stats loess predict
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' cnts <- readRDS(file.path(path, "cnts.rds"))
#' fpkm <- getFPKM(cnts)
#' te <- translationalEfficiency(fpkm)
#' te1 <- normalizeTEbyLoess(te)
#' plotTE(te)
#' plotTE(te1, log2=FALSE)
normalizeTEbyLoess <- function(TE, log2=TRUE,
                               pseudocount=1e-3, span=2/3,
                               family.loess="symmetric"){
  if(!is.list(TE)){
    stop("TE must be output of translationalEfficiency.")
  }
  if(!any(c("RPFs", "mRNA", "TE") %in% names(TE))){
    stop("TE must be output of translationalEfficiency.")
  }
  stopifnot(is.logical(log2))
  log2 <- log2[1]
  for(j in seq.int(ncol(TE[["TE"]]))){
    x <- TE[['mRNA']][, j, drop=TRUE]
    y <- TE[["TE"]][, j, drop=TRUE]
    x <- log2(x+pseudocount)
    if(log2){
      y <- log2(y+pseudocount)
    }
    index <- order(x)
    xx <- x[index]
    yy <- y[index]
    aux <- loess(as.formula('yy ~ xx'), span=span,
                 degree=1, family=family.loess)
    aux <- predict(aux, data.frame(xx=x))
    TE[["TE"]][, j] <- y-aux
  }
  TE
}

#' Calculate ORFscore
#' @description  To calculate the ORFscore, reads were counnted at each position
#' within the ORF.
#' \deqn{ORFscore = log_2((\sum_{n=1}^{3}\frac{(F_i-\bar{F})^2}{\bar{F}}) + 1)}
#' where \eqn{F_n} is the number of reads in reading frame n,
#' \eqn{\bar{F}} is the total number of reads across all three frames
#' divided by 3.
#' If \eqn{F_1} is smaller than \eqn{F_2} or \eqn{F_3},
#' \eqn{ORFscore = -1 X ORFscore}.
#' @references
#' 1: Bazzini AA, Johnstone TG, Christiano R, Mackowiak SD, Obermayer B,
#' Fleming ES, Vejnar CE, Lee MT, Rajewsky N, Walther TC, Giraldez AJ.
#' Identification of small ORFs in vertebrates using ribosome footprinting and
#' evolutionary conservation.
#' EMBO J. 2014 May 2;33(9):981-93.
#' doi: 10.1002/embj.201488411. Epub 2014 Apr 4.
#' PubMed PMID: 24705786; PubMed Central PMCID: PMC4193932.
#' @param reads Output of \link{getPsiteCoordinates}
#' @return A numeric vector with ORFscore.
#' @importFrom methods as is
#' @export
#' @examples
#' pcs <- readRDS(system.file("extdata", "samplePc.rds",
#'                package="ribosomeProfilingQC"))
#' ORFscore <- getORFscore(pcs)
getORFscore <- function(reads){
  stopifnot(is(reads, "GRanges"))
  if(length(reads$tx_name)!=length(reads)){
    stop("reads must be a result of getReadingFrame")
  }
  Fs <- split(reads$readingFrame, reads$tx_name)
  Fs <- lapply(Fs, table)
  ORFscore <- lapply(Fs, function(.ele){
    .ele <- .ele[c("0", "1", "2")]
    .ele[is.na(.ele)] <- 0
    names(.ele) <- c("0", "1", "2")
    m <- mean(.ele)
    s <- .ele["0"] < .ele["1"] || .ele["0"] < .ele["2"]
    log2(sum((.ele-m)^2/m)+1) * ifelse(s, -1, 1)
  })
  unlist(ORFscore)
}

#' Get P site coordinates
#' @description Extract P site coordinates from a bam file to a GRanges object.
#' @param bamfile A BamFile object.
#' @param bestpsite P site postion. See \link{estimatePsite}
#' @param anchor 5end or 3end. Default is 5end.
#' @param param A ScanBamParam object. Please note the 'qwidth' is required.
#' @return A GRanges object with qwidth metadata which indicates the width
#' of reads.
#' @import GenomicRanges
#' @importFrom Rsamtools ScanBamParam scanBamFlag bamWhat
#' @importFrom GenomicAlignments readGAlignments cigar cigarNarrow
#' cigarQNarrow GAlignments qwidth cigarWidthAlongReferenceSpace
#' @importFrom methods as is
#' @importFrom S4Vectors metadata<-
#' @importClassesFrom Rsamtools BamFile
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' pc <- getPsiteCoordinates(bamfile, bestpsite=13)
getPsiteCoordinates <- function(
    bamfile, bestpsite, anchor='5end',
    param = ScanBamParam(what=c("qwidth"),
                         tag=character(0),
                         flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                          isUnmappedQuery=FALSE,
                                          isNotPassingQualityControls = FALSE,
                                          isSupplementaryAlignment = FALSE))){
  stopifnot(is(bamfile, "BamFile"))
  stopifnot('qwidth' %in% bamWhat((param)))
  stopifnot(is.numeric(bestpsite))
  anchor <- match.arg(anchor, choices = c("5end", "3end"))
  offset <- round(bestpsite[1]) - 1

  reads <- GAlignments()
  open(bamfile)
  on.exit(close(bamfile))
  while(length(chunk <- readGAlignments(bamfile, param=param))){
    chunk <- narrow(chunk) ## remove the soft and Hard clips
    chunk <- chunk[njunc(chunk)==0] ## remove the junctions
    reads <- c(reads, shiftReads(chunk, shift = offset, anchor=anchor))
  }
  close(bamfile)
  on.exit()
  reads <- as(reads, "GRanges")
  reads <- promoters(reads, upstream = 0, downstream = 1)
  reads$Psite <- bestpsite
  if(anchor=="3end") reads$Psite <- reads$qwidth - reads$Psite
  metadata(reads) <- list(totalReads=length(reads))
  reads
}


shiftReads <- function(x, shift=12L, anchor="5end"){
  shift <- shift[1]
  stopifnot(round(shift)==shift)
  stopifnot(is(x, "GAlignments"))
  anchor <- match.arg(anchor, choices = c("5end", "3end"))
  x <- x[qwidth(x)>shift & width(x)>shift & 
           cigarWidthAlongReferenceSpace(cigar(x), 
                                         N.regions.removed = TRUE)>shift]
  if(shift==0){
    return(x)
  }
  strds <- as.character(strand(x)) == "-"
  cigars <- cigar(x)
  cigars <- as.character(cigarNarrow(cigars))
  if(anchor=="5end"){
    cigars <- cigarQNarrow(cigars,
                           start=ifelse(strds, 1, shift+1),
                           end=ifelse(strds, -shift-1, -1))
  }else{
    l <- mcols(x)$qwidth
    shift <- l - shift
    cigars <- cigarQNarrow(cigars,
                           start=ifelse(strds, 1, shift),
                           end=ifelse(strds, -shift, -1))
  }

  x@cigar <- as.character(cigars)
  x@start <- x@start + attributes(cigars)$rshift
  x
}

test_that("shiftReads works not correct", {
  gal <- GAlignments(seqnames=Rle("chr1", 6), pos=1:6,
    cigar=c("47M", "50M", "50M", "50M", "50M", "50M"),
    strand=Rle(strand(c("+", "-", "+", "-")), c(1, 2, 2, 1)),
    qname=tail(letters, 6),
    isize=c(180, -180, -265, 265, 185, -185))
  shifted <- ribosomeProfilingQC:::shiftReads(gal, shift = 12L)
  shifted2 <- ribosomeProfilingQC:::shiftReads(gal, shift = 11L)
  ns <- as.character(strand(gal))=="+"
  expect_equal(start(shifted)[ns], start(gal)[ns]+12)
  expect_equal(end(shifted)[!ns], end(gal)[!ns]-12)
  expect_equal(width(shifted), width(gal)-12)
  expect_equal(start(shifted2)[ns], start(gal)[ns]+11)
  expect_equal(end(shifted2)[!ns], end(gal)[!ns]-11)
  expect_equal(width(shifted2), width(gal)-11)
})

test_that("getPsiteCoordinates works not correct", {
  txdb <- makeTxDbFromGFF(system.file("extdata",
                                      "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                      package="ribosomeProfilingQC"),
                          organism = "Danio rerio",
                          chrominfo = seqinfo(Drerio)["chr1"],
                          taxonomyId = 7955)

  CDS <- prepareCDS(txdb)
  tmpbam <- tempdir()
  ## test from 5'end
  simulateRPF(txdb, outPath=tmpbam, genome=Drerio,
              samples="s13", readsPerSample = 1e4,
              psite = 13, readsLen = 28,
              frame0 = 1, frame1 = 0, frame2 = 0)
  bamfile <- BamFile(file.path(tmpbam, "s13.bam"))
  pc <- getPsiteCoordinates(bamfile = bamfile,
                            bestpsite = 13,
                            anchor = "5end")
  pc <- assignReadingFrame(pc, CDS=CDS)
  m <- table(pc$readingFrame)
  expect_equal(unname(m["0"]/sum(m)), 1, tolerance=.01)
  ## test from 3'end
  simulateRPF(txdb, outPath=tmpbam, genome=Drerio,
              samples="s14", readsPerSample = 1e4,
              psite = 14, readsLen = 29,
              frame0 = 1, frame1 = 0, frame2 = 0)
  f <- mergeBam(files = file.path(tmpbam, c("s13.bam", "s14.bam")),
                destination = file.path(tmpbam, "m.bam"),
                overwrite = TRUE)
  indexBam(f)
  bamfile <- BamFile(f)
  pc <- getPsiteCoordinates(bamfile = bamfile,
                            bestpsite = 28-13+1,
                            anchor = "3end")
  pc <- assignReadingFrame(pc, CDS=CDS)
  m <- table(pc$readingFrame)
  expect_equal(unname(m["0"]/sum(m)), 1, tolerance=.01)
})

#' Translational Efficiency
#' @description Calculate Translational Efficiency (TE). TE is defined as
#' the ratios of the absolute level of ribosome occupancy divided by RNA levels
#' for transcripts.
#' @param x Output of \link{getFPKM} or \link{normByRUVs}.
#' if window is set, it must be output of \link{coverageDepth}.
#' @param window numeric(1). window size for maximal counts.
#' @param RPFsampleOrder,mRNAsampleOrder Sample order of RPFs and mRNAs.
#' The parameters are used to make sure that the order of RPFs and mRNAs in
#' cvgs is corresponding samples.
#' @param pseudocount The number will be add to sum of reads count to avoid X/0.
#' @param log2 Do log2 transform or not.
#' @param normByLibSize Normalization by library size or not.
#' If window size is provided and normByLibSize is set to TRUE,
#' the coverage will be normalized by library size.
#' @param shrink Shrink the TE or not.
#' @param ... Parameters will be passed to \code{ash} function from \code{ashr}.
#' @return A list with RPFs, mRNA levels and TE as a matrix with
#' translational efficiency
#' @importFrom IRanges RleList IRanges IRangesList viewSums slidingWindows
#' @export
#' @examples
#' \dontrun{
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' RNAs <- dir(path, "mRNA.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' cnts <- countReads(RPFs, RNAs, gtf, level="gene")
#' fpkm <- getFPKM(cnts)
#' te <- translationalEfficiency(fpkm)
#' }
translationalEfficiency <- function(x, window,
                                    RPFsampleOrder, mRNAsampleOrder,
                                    pseudocount=1, log2=FALSE,
                                    normByLibSize=FALSE,
                                    shrink=FALSE,
                                    ...){
  if(!is.list(x)){
    stop("x must be output of countReads, getFPKM, normByRUVs or coverageDepth.")
  }
  if(!all(c("RPFs", "mRNA") %in% names(x))){
    stop("x must be output of countReads, getFPKM, normByRUVs or
         coverageDepth and must contain RPFs and mRNA.")
  }
  RPFs <- x[["RPFs"]]
  mRNA <- x[["mRNA"]]
  shrinkTE <- function(x, ...){
    RPFs <- if(!is.null(x[["RPFsRawCounts"]])){
      x[["RPFsRawCounts"]]
    }else{
      x[["RPFs"]]
    }
    mRNA <- if(!is.null(x[["mRNARawCounts"]])){
      x[["mRNARawCounts"]]
    }else{
      x[["mRNA"]]
    }
    
    if(!all(RPFs==round(RPFs)) &&
       !all(mRNA==round(mRNA))){
      stop('raw counts is missing.')
    }
    if (!requireNamespace("ashr", quietly=TRUE)) {
      stop("type='ashr' requires installing the CRAN package 'ashr'")
    }
    
    if (!requireNamespace("DESeq2", quietly=TRUE)) {
      stop("method='DESeq2' requires installing the CRAN package 'DESeq2'")
    }
    cd <- data.frame(condition=factor(c(rep('RPFs', ncol(RPFs)), 
                                        rep('mRNA', ncol(mRNA)))))
    design <- as.formula('~condition')
    countData <- cbind(RPFs,
                       mRNA)
    mode(countData) <- 'integer'
    dds <- DESeq2::DESeqDataSetFromMatrix(countData=countData,
                                          colData = cd,
                                          design = design)
    dds <- DESeq2::DESeq(dds)
    res <- DESeq2::results(dds, contrast=c('condition', 'RPFs', 'mRNA'))
    sebetahat <- res$lfcSE
    betahat <- log2(DESeq2::counts(dds, normalized=TRUE) + pseudocount)
    betahat <- betahat[, seq.int(ncol(RPFs)), drop=FALSE] -
      betahat[, -seq.int(ncol(RPFs)), drop=FALSE]
    
    message("using 'ashr' for TE shrinkage. ",
            "If used in published research, ",
            "please cite: ",
            " Stephens, M. (2016) False discovery rates: ",
            "a new deal. Biostatistics, 18:2. ",
            "https://doi.org/10.1093/biostatistics/kxw041")
    stopifnot('TE is not a matrix with 2 dimension. Please report this bug.'=
                length(dim(betahat))==2)
    fit <- apply(betahat, 2, function(.e){
      ashr::ash(.e, sebetahat,
                mixcompdist="normal", method="shrink", ...)},
      simplify = FALSE)
    TE <- lapply(fit, function(.e) .e$result$PosteriorMean)
    x[['TE']] <- do.call(cbind, TE)
    if(!log2) x[['TE']] <- 2^x[['TE']] - pseudocount
    x
  }
  if(missing(window)){
    if(length(dim(RPFs))!=2 | length(dim(mRNA))!=2){
      stop("x must be output of getFPKM or normByRUVs and
           must contain RPFs and mRNA.")
    }
    if(missing(RPFsampleOrder))
      RPFsampleOrder <- seq.int(ncol(x[["RPFs"]]))
    if(missing(mRNAsampleOrder))
      mRNAsampleOrder <- seq.int(ncol(x[["mRNA"]]))
    id <- intersect(rownames(RPFs), rownames(mRNA))
    if(length(id)==0){return(NULL)}
    x[["RPFs"]] <- RPFs[id, RPFsampleOrder, drop=FALSE]
    x[["mRNA"]] <- mRNA[id, mRNAsampleOrder, drop=FALSE]
    if(shrink){
      x <- shrinkTE(x, ...)
    }else{
      if(normByLibSize){
        normByLib <- function(x){
          xLibSize <- colSums(x, na.rm=TRUE)
          xLibFactor <- mean(xLibSize)/xLibSize
          x <- t(t(x)*xLibFactor)
        }
        RPFs_mRNA <- normByLib(cbind(x[["RPFs"]], x[["mRNA"]]))
        x[["RPFs"]] <- RPFs_mRNA[, seq.int(ncol(x[["RPFs"]])), drop=FALSE]
        x[["mRNA"]] <- RPFs_mRNA[, seq.int(ncol(RPFs_mRNA))[
          -seq.int(ncol(x[["RPFs"]]))], drop=FALSE]
        rm(RPFs_mRNA)
      }
      if(log2){
        x[["TE"]] <- log2(x[["RPFs"]]+pseudocount) - log2(x[["mRNA"]]+pseudocount)
      }else{
        x[["TE"]] <- (x[["RPFs"]]+pseudocount)/(x[["mRNA"]]+pseudocount)
      }
    }
  }else{
    if(!is(RPFs, "cvgd") | !is(mRNA, "cvgd")){
      stop("x must be output of coverageDepth and must contain RPFs and mRNA.")
    }
    if(missing(RPFsampleOrder))
      RPFsampleOrder <- seq.int(length(x[["RPFs"]][["coverage"]]))
    if(missing(mRNAsampleOrder))
      mRNAsampleOrder <- seq.int(length(x[["mRNA"]][["coverage"]]))
    RPFs <- RPFs[["coverage"]][RPFsampleOrder]
    mRNA <- mRNA[["coverage"]][mRNAsampleOrder]
    if(length(mRNA)!=length(RPFs)){
      stop("The length of sample of mRNA is not identical to
           the length of RPFs.")
    }
    if(normByLibSize){
      normByLib <- function(x){
        xLibSize <- lapply(x, sum, na.rm=TRUE)
        xLibSize <- vapply(xLibSize, sum, FUN.VALUE = 0.0, na.rm=TRUE)
        xLibFactor <- mean(xLibSize)/xLibSize
        x <- mapply(x, xLibFactor, FUN=`*`, SIMPLIFY = FALSE)
      }
      RPFs_mRNA <- normByLib(c(RPFs, mRNA))
      RPFs <- RPFs_mRNA[seq_along(RPFs)]
      mRNA <- RPFs_mRNA[seq_along(RPFs_mRNA)[-seq_along(RPFs)]]
      rm(RPFs_mRNA)
    }
    window <- window[1]
    if(round(window)!=window | window < 3){
      stop("window must be a integer no less than 3.")
    }
    ## check all feature_id
    features <- lapply(RPFs, names)
    stopifnot(all(lengths(features)==length(features[[1]])))
    for(i in seq_along(features)){
      stopifnot(all(features[[i]]==features[[1]]))
    }
    features <- features[[1]]

    features2 <- lapply(mRNA, names)
    stopifnot(all(lengths(features2)==length(features2[[1]])))
    for(i in seq_along(features2)){
      stopifnot(all(features2[[i]]==features2[[1]]))
    }
    features2 <- features2[[1]]
    stopifnot(all(features==features2))
    rm(features2)

    cvg <- mapply(RPFs, mRNA, FUN = function(a, b){
      la <- lengths(a)
      lb <- lengths(b)
      stopifnot(identical(la, lb))
      ir <- IRanges(1, la, names = names(la))
      ir <- slidingWindows(ir, window, step = 1L)
      vw.a <- Views(a, ir[names(a)])
      vw.b <- Views(b[names(a)], ir[names(a)])
      sum.a <- viewSums(vw.a, na.rm = TRUE)
      sum.b <- viewSums(vw.b, na.rm = TRUE)
      ratios <- mapply(sum.a, sum.b, FUN = function(r, m){
        if(log2){
          log2(r+pseudocount) - log2(m+pseudocount)
        }else{
          (r+pseudocount)/(m+pseudocount)
        }
      }, SIMPLIFY = FALSE)
      ids <- unlist(lapply(ratios, which.max))
      ratios <- mapply(ratios, ids, FUN=function(value, key){
        value[key]
      })
      rpf <- mapply(sum.a, ids, FUN=function(value, key){
        value[key]
      })
      mrna <- mapply(sum.b, ids, FUN=function(value, key){
        value[key]
      })
      list(ratios=ratios, RPFs=rpf, mRNA=mrna)
    }, SIMPLIFY = FALSE)
    x[["RPFs"]] <- do.call(cbind, lapply(cvg, `[[`, i="RPFs"))
    x[["mRNA"]] <- do.call(cbind, lapply(cvg, `[[`, i="mRNA"))
    x[["TE"]] <- do.call(cbind, lapply(cvg, `[[`, i="ratios"))
  }
  return(x)
}

#' barplot by ggplot2
#' @description barplot with number in top.
#' @param height data for plot
#' @param fill,xlab,ylab parameters pass to ggplot.
#' @param draw plot or not
#' @param postfix Postfix of text labled in top of bar.
#' @return ggplot object.
#' @importFrom ggplot2 ggplot geom_bar theme_classic geom_text aes xlab ylab
#' scale_fill_manual
#' @importFrom ggfittext geom_bar_text
#' @examples
#' ribosomeProfilingQC:::ggBar(sample.int(100, 3))
ggBar <- function(height, fill="gray80", draw=TRUE, xlab, ylab, postfix){
  if(length(names(height))!=length(height)){
    n <- seq_along(height)
  }else{
    n <- names(height)
  }
  height <- as.numeric(height)
  label <- formatC(height)
  x <- factor(n, levels = unique(n))
  y <- height
  df <- data.frame(x=x, y=y,
                   label=label, fill=fill)
  if(!missing(postfix)){
    if(!is.logical(postfix)){
      df$label <- paste(as.character(df$label), postfix)
      postfix <- TRUE
    }
  }else{
    postfix <- FALSE
  }
  colValues <- as.character(unique(fill))
  plot <- ggplot(data=df, aes(x=x, y=y, fill=fill)) +
    geom_bar(stat = "identity") +
    scale_fill_manual(values = colValues, breaks = colValues, guide="none") +
    theme_classic()
  if(postfix) suppressWarnings(
    plot <- plot +
      geom_bar_text(aes(label=label), grow = FALSE, contrast = TRUE))
  if(!missing(xlab)) plot <- plot+xlab(xlab)
  if(!missing(ylab)) plot <- plot+ylab(ylab)
  if(draw) {
    print(plot)
  }else{
    plot
  }
}

#' Metaplot of P site distribution
#' @description Metaplot of P site distribution in all the CDS aligned by
#' the start codon or stop codon.
#' @param reads Output of \link{assignReadingFrame}.
#' @param start Plot for start codon or stop codon.
#' @param anchor The maximal xlim or (min, max) position for plot.
#' @param col Colors for different reading frame.
#' @return Invisible height of the barplot.
#' @importFrom methods as is
#' @importFrom graphics barplot axis legend segments
#' @export
#' @examples
#' pcs <- readRDS(system.file("extdata", "samplePc.rds",
#'                package="ribosomeProfilingQC"))
#' plotDistance2Codon(pcs)
#' #plotDistance2Codon(pcs, start=FALSE)
#' #plotDistance2Codon(pcs, anchor=c(-10, 20))
plotDistance2Codon <- function(reads, start=TRUE, anchor=50,
                               col=c("Frame_0" = "#009E73",
                                     "Frame_1" = "#D55E00",
                                     "Frame_2" = "#0072B2")){
  stopifnot(is(reads, "GRanges"))
  stopifnot(is(anchor, "numeric"))
  stopifnot(is.logical(start))
  if(length(reads$tx_name)!=length(reads) ||
     length(reads$position)!=length(reads) ||
     length(reads$posToStop)!=length(reads) ||
     length(reads$readingFrame)!=length(reads) ||
     length(reads$gene_id)!=length(reads)){
    stop("reads must be a result of assignReadingFrame")
  }
  data <- if(start) reads$position else reads$posToStop
  position <- table(data)
  if(length(anchor)==0) {
    stop("Length of anchor must be greater than 0.")
  }
  if(length(anchor)==1){
    anchor <- c(0, anchor)
  }
  idx <- seq(from = anchor[1], to = anchor[2])
  xlim <- range(c(0, length(idx)))
  xlim <- 1.5 * xlim
  if(!start) {
    xlim <- rev(xlim)
    this.col <- col[c(1,3,2)]
  }else{
    this.col <- col
  }
  idx <- as.character(idx)
  position <- position[match(idx, names(position))]
  position[is.na(position)] <- .01
  names(position) <- idx
  barplot(height=position,
          ylab="Frequency",
          xlab=paste("P site relative to", ifelse(start, "start", "stop")),
          col=this.col[abs(as.numeric(names(position)) %% 3) + 1],
          xlim = xlim,
          border=NA, space=.5, xaxt = "n")
  idx <- as.numeric(idx)
  at <- which(idx %% 3 == 0 & idx != 0)
  at <- at
  label <- as.character(idx[at])
  axis(1, at = at*1.5 - .5, labels = label)
  axis(1, at = which(idx==0)*1.5-.5,
       labels = ifelse(start, "START", "STOP"), las = 3)
  if(start){
    at <- which(idx %% 3 == 2) * 1.5 + .25
  }else{
    at <- which(idx %% 3 == 0) * 1.5 + .25
  }
  segments(x0 = at, x1 = at, y0 = 0, y1 = max(position),
           lty = 3, col = 'gray80')
  legend("topleft", legend = names(col),
         fill = col, border = col, bg = NA, box.col = NA)
  return(invisible(position))
}

#' Metagene analysis plot
#' @description Plot the average coverage of UTR5, CDS and UTR3.
#' @param UTR5coverage,CDScoverage,UTR3coverage Coverages of UTR5, CDS, and
#' UTR3 region.
#' Output of \link{coverageDepth}
#' @param sample character(1). Sample name to plot.
#' @param xaxis What to plot for x-axis.
#' @param bins Bins for UTR5, CDS and UTR3.
#' @param ... Parameter pass to plot.
#' @return A list contain the data for plot.
#' @importFrom IRanges viewMeans Views
#' @importFrom graphics plot
#' @export
#' @examples
#'
#' \dontrun{
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' RNAs <- dir(path, "mRNA.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' cvgs <- coverageDepth(RPFs[1], RNAs[1], gtf)
#' cvgs.utr3 <- coverageDepth(RPFs[1], RNAs[1], gtf, region="utr3")
#' cvgs.utr5 <- coverageDepth(RPFs[1], RNAs[1], gtf, region="utr5")
#' metaPlot(cvgs.utr5, cvgs, cvgs.utr3, sample=1)
#' }
metaPlot <- function(UTR5coverage, CDScoverage, UTR3coverage, sample,
                     xaxis=c("RPFs", "mRNA"),
                     bins=c(UTR5=100, CDS=500, UTR3=100),
                     ...){
  xaxis <- match.arg(xaxis)
  if(!is.list(UTR5coverage) ||
     !is.list(UTR3coverage) ||
     !is.list(CDScoverage)){
    stop("UTR5coverage, CDScoverage and UTR3coverage must be
         output of coverageDepth")
  }
  if(!xaxis %in% names(UTR5coverage) ||
     !xaxis %in% names(UTR3coverage) ||
     !xaxis %in% names(CDScoverage)){
    stop("UTR5coverage, CDScoverage and UTR3coverage must be
         output of coverageDepth.",
         "And RPFs or mRNA must be available.")
  }
  if(!is.numeric(sample)){
    sample <- which(names(CDScoverage[[xaxis]]) %in% sample)
  }
  if(length(sample)>1){
    sample <- sample[1]
    message("Only first sample will be plotted.")
  }
  if(!all(c("UTR5", "CDS", "UTR3") %in% names(bins))){
    stop("bins should be a integer vector with names UTR5, CDS and UTR3.")
  }
  regions <- list(UTR5=UTR5coverage[[xaxis]][["coverage"]][[sample]],
                  CDS=CDScoverage[[xaxis]][["coverage"]][[sample]],
                  UTR3=UTR3coverage[[xaxis]][["coverage"]][[sample]])
  bins <- bins[names(regions)]
  regions <- mapply(regions, bins, FUN=function(.ele, .len){
    .ele[lengths(.ele)>=.len]
  }, SIMPLIFY = FALSE)
  ids <- Reduce(intersect, lapply(regions, names))
  regions <- lapply(regions, `[`, i=ids)
  metagene <- mapply(regions, bins, FUN=function(.ele, .len){
    l <- lengths(.ele)
    ir <- IRanges(1, width = l)
    tile <- tile(ir, n = .len)
    names(tile) <- names(.ele)
    vws <- Views(.ele, tile)
    vms <- viewMeans(vws)
    vms <- do.call(rbind, as.list(vms))
    vms <- colMeans(vms)
  }, SIMPLIFY = FALSE)
  v <- unlist(metagene, use.names = TRUE)
  plot(v, type="l", ylab="mean of coverage", xlab="", xaxt="n", ...)
  at <- cumsum(bins)[-3]
  abline(v=at, lty=3, col="gray30")
  labels <- c("START", "STOP")
  axis(1, at = at, labels = labels, las=3)
  at <- cumsum(c(0, bins))[-4]+bins/2
  axis(1, at = at, labels = names(bins), col.ticks = NA)
  return(invisible(metagene))
}

#' Ribosome Release Score (RRS)
#' @description RRS is calculated as the ratio of translational efficiency in
#'  the CDS with RPFs in the 3'UTR.
#' @param cdsTE,utr3TE Translational efficiency of CDS and UTR3 region.
#'  Output of \link{translationalEfficiency}
#' @param CDSsampleOrder,UTR3sampleOrder Sample order of cdsTE and utr3TE.
#'  The parameters are used to make sure that the order of CDS and UTR3 in TE
#'   is corresponding samples.
#' @param pseudocount The number will be add to sum of reads count to avoid X/0.
#' @param log2 Do log2 transform or not.
#' @return A vector of RRS.
#' @export
#' @examples
#'
#' \dontrun{
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' RNAs <- dir(path, "mRNA.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' cvgs <- coverageDepth(RPFs, RNAs, gtf)
#' cvgs.utr3 <- coverageDepth(RPFs, RNAs, gtf, region="utr3")
#' TE90 <- translationalEfficiency(cvgs, window = 90)
#' TE90.utr3 <- translationalEfficiency(cvgs.utr3, window = 90)
#' rrs <- ribosomeReleaseScore(TE90, TE90.utr3)
#'}
#'
ribosomeReleaseScore <- function(cdsTE, utr3TE, CDSsampleOrder, UTR3sampleOrder,
                                 pseudocount=0, log2=FALSE){
  if(!is.list(cdsTE) || !is.list(utr3TE)){
    stop("cdsTE and utr3TE must be output of translationalEfficiency")
  }
  if(!all(c("RPFs", "mRNA", "TE") %in% names(cdsTE)) ||
     !all(c("RPFs", "mRNA", "TE") %in% names(utr3TE))){
    stop("cdsTE and utr3TE must be output of translationalEfficiency And RPFs,
         mRNA and TE must be available.")
  }
  cdsTE <- cdsTE$TE
  utr3TE <- utr3TE$TE
  id <- intersect(rownames(cdsTE), rownames(utr3TE))
  if(missing(CDSsampleOrder)) CDSsampleOrder <- seq.int(ncol(cdsTE))
  if(missing(UTR3sampleOrder)) UTR3sampleOrder <- seq.int(ncol(utr3TE))
  stopifnot(length(CDSsampleOrder)==length(UTR3sampleOrder))
  cdsTE <- cdsTE[id, CDSsampleOrder, drop=FALSE]
  utr3TE <- utr3TE[id, UTR3sampleOrder, drop=FALSE]
  if(log2){
    log2(cdsTE+pseudocount)-log2(utr3TE+pseudocount)
  }else{
    (cdsTE+pseudocount)/(utr3TE+pseudocount)
  }
}

#' Class \code{"cvgd"}
#' @description An object of class \code{"cvgd"}
#' represents output of \code{coverageDepth}.
#' @aliases cvgd
#' @rdname cvgd-class
#' @slot coverage \code{"list"}, list of
#' \link[IRanges:AtomicList-class]{CompressedRleList},
#' specify the coverage of features of each sample.
#' @slot granges \link[GenomicRanges:GRangesList-class]{CompressedGRangesList},
#' specify the features.
#' @import methods
#' @import IRanges
#' @import GenomicRanges
#' @exportClass cvgd
#' @examples
#' cvgd()
setClass(Class = "cvgd",
         representation = representation(
           coverage = "list",
           granges  = "CompressedGRangesList"
         ),
         prototype = prototype(
           coverage = list(RleList(compress = TRUE)),
           granges  = GRangesList(compress = TRUE)
         ),
         validity=function(object){
           lapply(object@coverage, function(.ele){
             if(!is(.ele, "CompressedRleList")){
               return("coverage should be a list of CompressedRleList.")
             }
           })
           n <- lengths(object@coverage)
           n <- unique(n)
           if(length(n)!=1){
             return("Lengths of coverage should be identical for each element.")
           }
           if(n!=length(object@granges)){
             return("Lengths of coverage should be identical to
                    the length of granges.")
           }
           return(TRUE)
         })

#' @rdname cvgd-class
#' @param \dots Each argument in \dots becomes an slot in the new
#' \code{"cvgd"}-class.
#' @return A cvgd object.
#' @export
cvgd <- function(...){
  new("cvgd", ...)
}

#' @rdname cvgd-class
#' @exportMethod `$`
#' @param x cvgd object.
setMethod("$", "cvgd", function(x, name) slot(x, name))
#' @rdname cvgd-class
#' @param name A literal character string or a name (possibly backtick quoted).
#' @param value value to replace.
#' @exportMethod `$<-`
setReplaceMethod("$", "cvgd",
                 function(x, name, value){
                   slot(x, name, check = TRUE) <- value
                   x
                 })


#' @rdname cvgd-class
#' @exportMethod `[[`
#' @param i,j indexes specifying elements to extract or replace.
#' @param exact see \link[base]{Extract}
setMethod("[[", "cvgd", function(x, i, j, ..., exact=TRUE) slot(x, i))
#' @rdname cvgd-class
#' @exportMethod `[[<-`
setReplaceMethod("[[", "cvgd",
                 function(x, i, ..., value){
                   slot(x, i, check = TRUE) <- value
                   x
                 })

#' @rdname cvgd-class
#' @exportMethod show
#' @param object cvgd object.
#' @importFrom utils head
#'
setMethod("show", "cvgd", function(object){
  samples <- names(object@coverage)
  cat("cvgd object")
  cat(paste(length(samples), "samples:",
              paste(samples, collapse = ", ")))
  if(length(samples)>0){
    cat(paste("\nhead of coverage for sample\n", samples[1]))
    head(object@coverage[[samples[1]]])
  }
  cat("\nhead of granges\n")
  head(object@granges)
})

#' Prepare CDS
#' @description Prepare CDS library from a TxDb object.
#' @param txdb A TxDb object.
#' @param withUTR Including UTR information or not.
#' @return A GRanges object with metadata which include:
#' tx_id: transcript id;
#' tx_name: transcript name;
#' gene_id: gene id;
#' isFirstExonInCDS: is first exon in CDS or not;
#' idFirstExonInCDS: the id for the first exon;
#' isLastExonInCDS: is last exon in CDS or not;
#' wid.cumsu: cumulative sums of number of bases in CDS;
#' internalPos: offset position from 1 base;
#' @importClassesFrom GenomicFeatures TxDb
#' @importFrom GenomicFeatures cdsBy fiveUTRsByTranscript
#' @importFrom AnnotationDbi select
#' @importFrom methods as is
#' @import GenomicRanges
#' @export
#' @examples
#' library(GenomicFeatures)
#' txdb_file <- system.file("extdata", "Biomart_Ensembl_sample.sqlite",
#'                          package="GenomicFeatures")
#' txdb <- loadDb(txdb_file)
#' CDS <- prepareCDS(txdb)
#'
prepareCDS <- function(txdb, withUTR = FALSE){
  stopifnot(is(txdb, "TxDb"))
  if(withUTR){
    cds <- cdsBy(txdb, by = "tx", use.names = TRUE)
    utr5 <- fiveUTRsByTranscript(txdb, use.names = TRUE)
    utr3 <- threeUTRsByTranscript(txdb, use.names = TRUE)
    CDS <- unlist(cds)
    CDS$cds_id <- NULL
    CDS$cds_name <- NULL
    CDS$feature <- "CDS"
    CDS$tx_name <- rep(names(cds), lengths(cds))
    utrs <- list(UTR5=utr5, UTR3=utr3)
    utrs <- mapply(utrs, names(utrs), FUN=function(.ele, .name){
      UTR <- unlist(.ele)
      UTR$exon_id <- NULL
      UTR$exon_name <- NULL
      UTR$feature <- .name
      UTR$tx_name <- rep(names(.ele), lengths(.ele))
      UTR
    })
    utrs <- unlist(GRangesList(utrs), use.names = FALSE)

    exons <- c(utrs, CDS)
    exons <- sort(exons)
    exons$tx_id <-
      as.numeric(factor(exons$tx_name, levels = unique(exons$tx_name)))
    exons <-
      exons[order(exons$tx_id, start(exons)*ifelse(strand(exons)=="-", -1, 1))]

    suppressMessages(id_map <-
                       select(txdb, keys=unique(exons$tx_name),
                              columns = c("TXNAME", "GENEID", "TXTYPE"),
                              keytype="TXNAME"))
    exons$gene_id <- id_map[match(exons$tx_name, id_map$TXNAME), "GENEID"]
    exons$tx_type <- id_map[match(exons$tx_name, id_map$TXNAME), "TXTYPE"]
    exons$oid <- paste(exons$tx_name, exons$feature)
    isCDS <- exons$feature == "CDS"
    exons$isFirstExonInCDS <- isCDS & !duplicated(exons$oid)
    exons$idFirstExonInCDS <- ## make sure that table is sorted
      rep(which(exons$isFirstExonInCDS), table(exons$tx_id))
    exons$isLastExonInCDS <- isCDS & rev(!duplicated(rev(exons$oid)))
    exons$isFirstExonInTx <- !duplicated(exons$tx_id)
    exons$idFirstExonInTx <-
      rep(which(exons$isFirstExonInTx), table(exons$tx_id))
    exons$isLastExonInTx <- rev(!duplicated(rev(exons$tx_id)))
    exons.wid <- width(exons)
    isUTR5 <- exons$feature == "UTR5"
    CDS.wid.cumsum <- cumsum(exons.wid[!isUTR5])
    exons$wid.cumsum <- 0
    exons.sub <- exons[!isUTR5]
    idFirstExonInCDS <-
      rep(which(exons.sub$isFirstExonInCDS), table(exons.sub$tx_id))
    exons$wid.cumsum[!isUTR5] <-
      CDS.wid.cumsum - c(0, CDS.wid.cumsum)[idFirstExonInCDS]
    exons$internalPos <- 0
    exons$internalPos[!(isUTR5 | exons$isFirstExonInCDS)] <-
      exons$wid.cumsum[!(isUTR5 | exons$isLastExonInTx)]
    ## for UTR5
    exons.sub <- rev(exons[isUTR5])
    exons.sub$tx_id <-
      as.numeric(factor(exons.sub$tx_name, levels = unique(exons.sub$tx_name)))
    exons.sub$isFirstUTR5 <- !duplicated(exons.sub$oid)
    exons.sub$idFirstUTR5 <-
      rep(which(exons.sub$isFirstUTR5), table(exons.sub$tx_id))
    exons.sub$isLastUTR5 <- rev(!duplicated(rev(exons.sub$oid)))
    exons.sub.wid <- width(exons.sub)
    exons.sub.cumsum <- cumsum(exons.sub.wid)
    exons.sub$wid.cumsum <-
      exons.sub.cumsum - c(0, exons.sub.cumsum)[exons.sub$idFirstUTR5]
    exons.sub$internalPos <- 0
    exons.sub$internalPos[!exons.sub$isFirstUTR5] <-
      exons.sub$wid.cumsum[!exons.sub$isLastUTR5]
    exons$wid.cumsum[isUTR5] <-  -1 * rev(exons.sub$wid.cumsum)
    exons$internalPos[isUTR5] <- -1 * rev(exons.sub$internalPos)
    exons$oid <- NULL
    return(exons)
  }
  cds <- cdsBy(txdb, by="tx", use.names = TRUE)
  CDS <- unlist(cds)
  CDS$cds_name <- NULL
  CDS$tx_id <- rep(seq_along(cds), lengths(cds))
  CDS$tx_name <- rep(names(cds), lengths(cds))
  suppressMessages(id_map <-
                     select(txdb, keys=unique(CDS$tx_name),
                            columns = c("TXNAME", "GENEID", "TXTYPE"),
                            keytype="TXNAME"))
  CDS$gene_id <- id_map[match(CDS$tx_name, id_map$TXNAME), "GENEID"]
  CDS$tx_type <- id_map[match(CDS$tx_name, id_map$TXNAME), "TXTYPE"]
  CDS$isFirstExonInCDS <- !duplicated(CDS$tx_id)
  CDS$idFirstExonInCDS <- rep(which(!duplicated(CDS$tx_id)), lengths(cds))
  CDS$isLastExonInCDS <- rev(!duplicated(rev(CDS$tx_id)))
  CDS.wid <- width(CDS)
  CDS.wid.cumsum <- cumsum(CDS.wid)
  CDS$wid.cumsum <- CDS.wid.cumsum - c(0, CDS.wid.cumsum)[CDS$idFirstExonInCDS]
  CDS$internalPos <- 0
  CDS$internalPos[!CDS$isFirstExonInCDS] <- CDS$wid.cumsum[!CDS$isLastExonInCDS]
  CDS
}

gtf <- system.file("extdata",
                   "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                   package="ribosomeProfilingQC")
txdb <- makeTxDbFromGFF(gtf,
                        organism = "Danio rerio",
                        chrominfo = seqinfo(Drerio)["chr1"],
                        taxonomyId = 7955)
CDS <- prepareCDS(txdb)
tmpbam <- tempdir()
bamfilenames <- character(0)
samples <- character(0)
yieldSize <- 10000000

possiblePsites <- 13 #c(12, 13, 14)
Drerio_chr1 <- getSeq(Drerio, as(seqinfo(Drerio)["chr1"], 'GRanges'))

bamfilename13 <- tempfile(tmpdir = tmpbam, fileext = ".bam")
test_that("simulateRPF works not correct for DNAStringSet", {
  sample <- sub(".bam", "", basename(bamfilename13))
  reads <- simulateRPF(txdb, tmpbam, samples=sample, genome=Drerio_chr1,
                       readsPerSample = 1e4, psite = 13,
                       frame0=.90, frame1=.05, frame2=.05,
                       includeReadsSeq = TRUE)
})
test_that("codonBias works not correct", {
    cb <- codonBias(bamfilename13, gtf=gtf, genome=Drerio_chr1, bestpsite = 13)
    reads.vs.ref <- cb$reads[, -seq.int(3)]/cb$reference[, -seq.int(3)]
    expect_equal(mean(reads.vs.ref), 1, tolerance = 0.01)
    expect_true(sd(reads.vs.ref)<0.05)
    p <- t.test(cb$reads[, 4], cb$reference[, 4])$p.value
    expect_true(p>0.99)
})

for(psite in possiblePsites){
  bamfilename <- tempfile(tmpdir = tmpbam, fileext = ".bam")
  sample <- sub(".bam", "", basename(bamfilename))
  reads <- simulateRPF(txdb, tmpbam, samples=sample, genome=Drerio,
                       readsPerSample = 1e4, psite = psite,
                       frame0=.90, frame1=.05, frame2=.05)
  bamfilenames[psite] <- bamfilename
  samples[psite] <- sample
}

bamfile <- lapply(bamfilenames[possiblePsites], BamFile, yieldSize = yieldSize)
names(bamfile) <- possiblePsites

test_that("estimatePsite works not correct", {
  for(psite in possiblePsites){
    bestpsite <- estimatePsite(bamfile[[as.character(psite)]], CDS, Drerio)
    expect_equal(bestpsite, psite)
    ## test for DNAStringSet
    bestpsite <- estimatePsite(bamfile[[as.character(psite)]], CDS, Drerio_chr1)
    expect_equal(bestpsite, psite)
    ## from 3'end
    bestpsite <- estimatePsite(bamfile[[as.character(psite)]], CDS, Drerio, anchor='3end')
    expect_equal(bestpsite, psite-29)
  }
})

test_that("readsEndPlot works not correct", {
  for(psite in possiblePsites){
    h <- readsEndPlot(bamfile[[as.character(psite)]], CDS, toStartCodon=TRUE)
    h <- h$heights
    dist <- as.numeric(names(h))
    gp <- c(dist[dist<0&dist>-10] %% 3, (dist[dist>0]-1) %% 3)
    gph <- rowsum(h[dist>-10], gp)
    m <- c(13, 12, 14)[which.max(gph)]
    expect_equal(m, psite)
  }
})

pcs <- mapply(getPsiteCoordinates, bamfile, possiblePsites)

test_that("summaryReadsLength works not correct", {
  for(psite in possiblePsites){
    readsLen <- summaryReadsLength(pcs[[as.character(psite)]])
    expect_equal(readsLen, c("28"=1))
  }
})

test_that("strandPlot works not correct", {
  for(psite in possiblePsites){
    sP <- strandPlot(pcs[[as.character(psite)]], CDS = CDS)$data
    sP <- sP[sP$x=="sense", "y"]
    expect_equal(sP, 100, tolerance=.1)
  }
})

pcs <- lapply(pcs, assignReadingFrame, CDS=CDS)

test_that("assignReadingFrame works not correct", {
  for(psite in possiblePsites){
    m <- table(pcs[[as.character(psite)]]$readingFrame)
    expect_gt(m["0"], m["1"])
    expect_gt(m["0"], m["2"])
    m0 <- plotFrameDensity(pcs[[as.character(psite)]])
    m <- round(m0$data$y)
    names(m) <- m0$data$x
    expect_equal(unname(m['0']), 90, tolerance=1)
    expect_equal(unname(m['1']), 5, tolerance=1)
    expect_equal(unname(m['2']), 5, tolerance=1)
  }
})

pcs <- lapply(pcs, readsDistribution, txdb=txdb, plot=FALSE)
test_that("readsDistribution works not correct", {
  for(psite in possiblePsites){
    cs <- mcols(pcs[[as.character(psite)]])[, c("Intron",
                                                "upstream",
                                                "downstream",
                                                "InterGenic")]
    cs <- as.data.frame(cs)
    cs <- colSums(cs)
    expect_true(all(cs==0))
  }
})


test_that("codonUsage works not correct", {
  for(psite in possiblePsites){
    startcodon <- codonUsage(pcs[[as.character(psite)]],
                             start = TRUE, genome = Drerio)
    expect_true(names(startcodon)[1] == "ATG")
    stopcodon <- codonUsage(pcs[[as.character(psite)]],
                            start = FALSE, genome = Drerio)
    expect_true(names(stopcodon)[1] %in% c("TAG", "TAA", "TGA"))
    ## test for DNAStringSet
    startcodon <- codonUsage(pcs[[as.character(psite)]],
                             start = TRUE, genome = Drerio_chr1)
    expect_true(names(startcodon)[1] == "ATG")
    stopcodon <- codonUsage(pcs[[as.character(psite)]],
                            start = FALSE, genome = Drerio_chr1)
    expect_true(names(stopcodon)[1] %in% c("TAG", "TAA", "TGA"))
  }
})

test_that("prepareCDS works not correct", {
  txdb <- makeTxDbFromGFF(system.file("extdata",
                                      "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                      package="ribosomeProfilingQC"),
                          organism = "Danio rerio",
                          chrominfo = seqinfo(Drerio)["chr1"],
                          taxonomyId = 7955)
  cds <- cds(txdb)
  CDS <- prepareCDS(txdb)
  ol <- findOverlaps(cds, CDS, type = "equal")
  expect_true(all(seq_along(cds) %in% queryHits(ol)))
  expect_true(all(seq_along(CDS) %in% subjectHits(ol)))
  ## check isFirstExonInCDS
  cds <- cdsBy(txdb, by = "tx")
  cds <- unlist(range(cds))
  cds_5 <- promoters(cds, upstream = 0, downstream = 1)
  CDS_isFirst <- promoters(CDS[CDS$isFirstExonInCDS],
                           upstream = 0, downstream = 1)
  ol <- findOverlaps(CDS_isFirst, cds_5, type = "equal")
  expect_true(all(seq_along(CDS_isFirst) %in% queryHits(ol)))
  expect_true(all(seq_along(cds_5) %in% subjectHits(ol)))
  ## check isLastExonInCDS
  switchStrand <- function(.ele){
    levels(strand(.ele)) <- c("-", "+", "*")
    .ele
  }
  end3 <- function(.ele){
    promoters(switchStrand(.ele),
              upstream = 0, downstream = 1)
  }
  cds_3 <- end3(cds)
  CDS_isLast <- end3(CDS[CDS$isLastExonInCDS])
  ol <- findOverlaps(CDS_isLast, cds_3, type = "equal")
  expect_true(all(seq_along(CDS_isLast) %in% queryHits(ol)))
  expect_true(all(seq_along(cds_3) %in% subjectHits(ol)))
})

test_that("filterCDS works not correct", {
  txdb <- makeTxDbFromGFF(system.file("extdata",
                                      "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                      package="ribosomeProfilingQC"),
                          organism = "Danio rerio",
                          chrominfo = seqinfo(Drerio)["chr1"],
                          taxonomyId = 7955)
  CDS <- prepareCDS(txdb)
  cds <- filterCDS(CDS, sizeCutoff = 200)
  cds_width <- cds$wid.cumsum[cds$isLastExonInCDS]
  expect_true(all(cds_width>200))
  cds <- filterCDS(CDS, sizeCutoff = 500)
  cds_width <- cds$wid.cumsum[cds$isLastExonInCDS]
  expect_true(all(cds_width>500))
})

test_that("frameCounts works not correct", {
  txdb <- makeTxDbFromGFF(system.file("extdata",
                                      "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                      package="ribosomeProfilingQC"),
                          organism = "Danio rerio",
                          chrominfo = seqinfo(Drerio)["chr1"],
                          taxonomyId = 7955)
  CDS <- prepareCDS(txdb)
  ENSDART00000166393 <- CDS[CDS$tx_name =="ENSDART00000166393"]
  ss <- start(ENSDART00000166393)
  st <- end(ENSDART00000166393)
  a <- unlist(mapply(seq, ss, st, SIMPLIFY = FALSE),
              use.names = FALSE)
  a <- a[(seq_along(a)-1) %% 3 == 0]
  p <- seq(.2, 1, by = .2)
  for(i in p){
    pcs <- GRanges(seqnames = "chr1",
                   ranges = IRanges(sample(a, size=length(a)*i),
                                    width=1),
                   strand = "+")
    pcs <- assignReadingFrame(pcs, CDS)
    fc <- frameCounts(pcs, level = "tx",
                      coverageRate = TRUE, frame0only = TRUE)
    fc <- unname(fc["ENSDART00000166393"])
    expect_equal(fc, i, tolerance=.001)
  }
})

fixSeqlevelsStyle <- function(x, CDS, ignore.seqlevelsStyle=FALSE){
  if(ignore.seqlevelsStyle){
    return(x)
  }
  if(length(intersect(seqlevelsStyle(x), seqlevelsStyle(CDS)))==0){
    try_res <- try({seqlevelsStyle(x) <- seqlevelsStyle(CDS)[1]})
    if(inherits(try_res, "try-error")){
      warning(try_res)
      warning("The seqlevelsStyles of bam file and the CDS are different.")
    }
  }
  return(x)
}

#' Plot translational efficiency
#' @description Scatterplot of RNA/RPFs level compared to the
#' translational efficiency.
#' @param TE Output of \link{translationalEfficiency}
#' @param sample Sample names to plot.
#' @param xaxis What to plot for x-axis.
#' @param removeZero Remove the 0 values from plots.
#' @param log2 Do log2 transform for TE or not.
#' @param theme Theme for ggplot2.
#' @param type,margins,... Parameters pass to ggMarginal
#' @return A ggExtraPlot object.
#' @importFrom ggplot2 ggplot geom_point geom_text .data facet_wrap theme_classic
#' @importFrom ggExtra ggMarginal
#' @importFrom stats as.formula coef na.omit
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' #RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' #RNAs <- dir(path, "mRNA.*?\\.[12].bam$", full.names=TRUE)
#' #gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' #cnts <- countReads(RPFs, RNAs, gtf, level="gene")
#' cnts <- readRDS(file.path(path, "cnts.rds"))
#' fpkm <- getFPKM(cnts)
#' te <- translationalEfficiency(fpkm)
#' plotTE(te, 1)

plotTE <- function(TE, sample, xaxis=c("mRNA", "RPFs"),
                   removeZero=TRUE, log2=TRUE,
                   theme = theme_classic(),
                   type = 'histogram', margins = 'y',
                   ...){
  if(!is.list(TE)){
    stop("TE must be output of translationalEfficiency.")
  }
  if(!any(c("RPFs", "mRNA", "TE") %in% names(TE))){
    stop("TE must be output of translationalEfficiency.")
  }
  stopifnot(is(theme, 'theme'))
  xaxis <- match.arg(xaxis)
  mRNA <- TE$mRNA
  RPFs <- TE$RPFs
  x <- TE[[xaxis]]
  TE <- TE$TE
  if(missing(sample)){
    sample <- colnames(TE)
  }
  if(!is.numeric(sample)){
    sample <- which(colnames(TE) %in% sample)
  }
  single_sample <- length(sample)==1
  df <- lapply(sample, function(.sample){
    data.frame(x = x[, .sample],
               TE = TE[, .sample],
               sample = .sample,
               RPFs = RPFs[, .sample],
               mRNA = mRNA[, .sample])
  })
  
  df <- do.call(rbind, df)
  if(removeZero){
    keep <- df$RPFs>0 & df$mRNA>0
    if(sum(keep)<1){
      stop("No data available for plotting.")
    }
    df <- df[keep, , drop=FALSE]
  }
  df$sample <- colnames(TE)[df$sample]
  xlab <- paste(xaxis, "level")
  ylab <- "Translational Efficiency"
  df$x <- log2(df$x)
  xlab <- paste('log2 transformed', xlab)
  if(log2){
    df$TE <- log2(df$TE)
    ylab <- paste('log2 transformed', ylab)
  }

  lm_eqn <- function(df){
    df <- df[!is.infinite(df$x) & !is.infinite(df$TE), , drop=FALSE]
    df <- split(df, df$sample)
    out <- lapply(df, function(.df){
      m <- lm(as.formula("TE ~ x"), .df, na.action = na.omit)
      eq <- substitute(italic("TE") == a + b %.% italic(x)*","~~italic("r")^2~"="~r2, 
                       list(a = format(unname(coef(m)[1]), digits = 2),
                            b = format(unname(coef(m)[2]), digits = 2),
                            r2 = format(summary(m)$r.squared, digits = 3),
                            x = xaxis))
      as.character(as.expression(eq))
    })
    out <- data.frame(sample=names(out), label=unlist(out))
  }
  p <- ggplot(df, aes(.data$x, .data$TE)) + geom_point() + 
    xlab(xlab) + ylab(ylab) +
    geom_smooth(method="lm", formula=as.formula('y ~ x'), se=TRUE) + theme
  p <- p + geom_text(data=lm_eqn(df),
                     aes(x=-Inf, y = Inf, label=.data$label),
                     hjust = 0, vjust = 1,
                     parse = TRUE)
  if(single_sample){
    p <- ggMarginal(p, type=type, margins=margins, ...)
  }else{
    p <- p +
      facet_wrap(facets = as.formula('~sample'))
  }
  p
}

#' Extract counts for RPFs and RNAs
#' @description Calculate the reads counts for gene level or transcript level.
#' @param RPFs Bam file names of RPFs.
#' @param RNAs Bam file names of RNAseq.
#' @param gtf GTF file name for annotation.
#' @param level Transcript or gene level.
#' @param bestpsite numeric(1). P site postion.
#' @param readsLen numeric(1). reads length to keep.
#' @param anchor 5end or 3end. Default is 5end.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @param ... Parameters pass to \link[Rsubread:featureCounts]{featureCounts} 
#' except isGTFAnnotationFile, GTF.attrType, and annot.ext.
#' @return A list with reads counts.
#' @importFrom txdbmaker makeTxDb
#' @importFrom methods as is
#' @importFrom Rsubread featureCounts
#' @importFrom txdbmaker makeTxDbFromGFF
#' @importFrom Rsamtools BamFile
#' @importFrom S4Vectors DataFrame
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' RNAs <- dir(path, "mRNA.*?.[12].bam$", full.names = TRUE)
#' cnts <- countReads(RPFs[1], gtf=gtf, level="gene", readsLen=29)
#' #cnts <- countReads(RPFs[1], RNAs[1], gtf=gtf, level="gene", readsLen=29)

countReads <- function(RPFs, RNAs, gtf, level=c("tx", "gene"),
                       bestpsite=13, readsLen=c(28,29), anchor="5end",
                       ignore.seqlevelsStyle=FALSE,
                       ...){
  stopifnot(is.character(gtf))
  level <- match.arg(level)
  anchor <- match.arg(anchor, choices = c("5end", "3end"))
  gtf <- gtf[1]
  counts <- list()
  if(!missing(RPFs)){
    stopifnot(is.character(RPFs))
    stopifnot(is.numeric(readsLen))
    stopifnot(is.numeric(bestpsite))
    suppressWarnings(suppressMessages(txdb <- makeTxDbFromGFF(gtf)))
    counts[["RPFs"]] <- RPFsCounts(files = RPFs,
                                   txdb = txdb, level = level,
                                   bestpsite = bestpsite,
                                   readsLen = readsLen,
                                   anchor = anchor,
                                   ignore.seqlevelsStyle=ignore.seqlevelsStyle)
  }
  if(!missing(RNAs)){
    stopifnot(is.character(RNAs))
    suppressMessages(
      cnts.RNAs <- featureCounts(files = RNAs,
                                 annot.ext = gtf,
                                 GTF.attrType=ifelse(level=="gene",
                                                     "gene_id",
                                                     "transcript_id"),
                                 isGTFAnnotationFile = TRUE,
                                 ...)
    )
    counts[["mRNA"]] <- cnts.RNAs$counts
    counts[["annotation"]] <- cnts.RNAs$annotation
  }else{
    if(missing(RPFs)){
      stop("RNAs or RPFs is required.")
    }
    counts[["annotation"]] <- getFeatureLen(txdb, level)
  }
  if(!missing(RPFs) && !missing(RNAs)){
    ids <- intersect(rownames(counts[["RPFs"]]), rownames(counts[["mRNA"]]))
    counts[["RPFs"]] <- 
      counts[["RPFs"]][match(ids, rownames(counts[["RPFs"]])), , drop=FALSE]
    counts[["mRNA"]] <- 
      counts[["mRNA"]][match(ids, rownames(counts[["mRNA"]])), , drop=FALSE]
    counts[["annotation"]] <- 
      counts[["annotation"]][match(ids, counts[["annotation"]][, 1]), , 
                             drop=FALSE]
  }
  counts
}

RPFsCounts <- function(files, txdb, level, bestpsite,
                       readsLen, anchor,
                       ignore.seqlevelsStyle=FALSE){
  yieldSize <- 10000000
  cnts <- lapply(files, function(f){
    bamfile <- BamFile(file = f, yieldSize = yieldSize)
    pc <- getPsiteCoordinates(bamfile, bestpsite=bestpsite,
                              anchor = anchor)
    pc.sub <- pc[pc$qwidth %in% readsLen]
    pc.sub <- shiftReadsByFrame(pc.sub, txdb,
                                ignore.seqlevelsStyle=ignore.seqlevelsStyle)
    frameCounts(pc.sub, level=level)
  })
  genes <- unique(unlist(lapply(cnts, names)))
  cnts <- lapply(cnts, `[`, i=genes)
  names(cnts) <- basename(files)
  cnts <- do.call(cbind, cnts)
  rownames(cnts) <- genes
  cnts[is.na(cnts)] <- 0
  cnts
}

getFeatureLen <- function(txdb, level=c("gene", "tx")){
  stopifnot(is(txdb, "TxDb"))
  level <- match.arg(level)
  features <- exons(txdb, columns=c("gene_id", "tx_name"))
  features <-
    switch(level,
           gene={
             f <- rep(features, lengths(features$gene_id))
             mcols(f) <-
               DataFrame(feature_id=unlist(features$gene_id))
             f[!is.na(f$feature_id)]
           },
           tx={
             f <- rep(features, lengths(features$tx_name))
             mcols(f) <- DataFrame(unlist(features$tx_name))
             f[!is.na(f$feature_id)]
           })
  f <- as.data.frame(features)
  f <- split(f, f$feature_id)
  GeneID <- names(f)
  foo <- function(.ele, n){
    paste(as.character(.ele[, n]), collapse = ";")
  }
  Chr <- unlist(lapply(f, foo, n="seqnames"))
  Start <- unlist(lapply(f, foo, n="start"))
  End <- unlist(lapply(f, foo, "end"))
  Strand <- unlist(lapply(f, foo, "strand"))
  Length <- unlist(lapply(f, function(.ele) sum(.ele$width)))
  data.frame(GeneID=GeneID, Chr=Chr, Start=Start, End=End,
             Strand=Strand, Length=Length,
             stringsAsFactors = FALSE)
}

#' Extract coverage depth for gene level or transcript level
#' @description Calculate the coverage depth for gene level or transcript level.
#' Coverage for RPFs will be the best P site coverage.
#' Coverage for RNAs will be the coverage for 5'end of reads.
#' @param RPFs Bam file names of RPFs.
#' @param RNAs Bam file names of RNAseq.
#' @param gtf GTF file name for annotation or a TxDb object.
#' @param level Transcript or gene level.
#' @param bestpsite P site postion.
#' @param readsLen Reads length to keep.
#' @param anchor 5end or 3end. Default is 5end.
#' @param region Annotation region. It could be "cds", "utr5", "utr3",
#' "exon", "transcripts", "feature with extension".
#' @param ext Extesion region for "feature with extension".
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @param ... Parameters pass to
#' \link[txdbmaker:makeTxDbFromGFF]{makeTxDbFromGFF}
#' @return A cvgd object with coverage depth.
#' @importFrom txdbmaker makeTxDb
#' @importFrom methods as is
#' @importFrom txdbmaker makeTxDbFromGFF
#' @importFrom GenomicFeatures coverageByTranscript transcripts
#' @importFrom Rsamtools BamFile
#' @importFrom S4Vectors DataFrame Rle
#' @importFrom Seqinfo seqnames seqlevels seqlevels<-
#' @importFrom IRanges disjoin
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' cvgs <- coverageDepth(RPFs[1], gtf=gtf, level="gene")

coverageDepth <- function(RPFs, RNAs, gtf, level=c("tx", "gene"),
                          bestpsite=13, readsLen=c(28,29), anchor="5end",
                          region="cds",
                          ext=5000,
                          ignore.seqlevelsStyle=FALSE,
                          ...){
  stopifnot(is.character(gtf)||is(gtf, "TxDb"))
  level <- match.arg(level)
  anchor <- match.arg(anchor, choices = c("5end", "3end"))
  region <- region[1]
  if(!region %in% c("cds", "utr5", "utr3", "exon",
                    "transcripts", "feature with extension")){
    stop("region must be cds, utr5, utr3, exon,
         transcripts, feature with extension")
  }
  cvgs <- list()
  txdb <- prepareTxDb(gtf, 'gtf', ...)
  if(!missing(RPFs)){
    stopifnot(is.character(RPFs))
    stopifnot(is.numeric(readsLen))
    stopifnot(is.numeric(bestpsite))
    cd <- getCvgs(files = RPFs,
                  txdb = txdb, level = level,
                  bestpsite = bestpsite,
                  readsLen = readsLen,
                  anchor = anchor,
                  region = region,
                  ext = ext,
                  ignore.seqlevelsStyle=ignore.seqlevelsStyle)
    cvgs[["RPFs"]] <- cd
  }
  if(!missing(RNAs)){
    stopifnot(is.character(RNAs))
    cd <- getCvgs(files = RNAs,
                  txdb = txdb, level = level,
                  region = region,
                  ext = ext,
                  ignore.seqlevelsStyle=ignore.seqlevelsStyle)
    cvgs[["mRNA"]] <- cd
  }
  cvgs
}

getCvgs <- function(files, txdb, level,
                    bestpsite, readsLen, anchor,
                    region, ext,
                    ignore.seqlevelsStyle=FALSE){
  yieldSize <- 10000000
  if(!missing(bestpsite)){##RPFs
    ignore.strand <- FALSE
    reads <- lapply(files, function(f){
      bamfile <- BamFile(file = f, yieldSize = yieldSize)
      pc <- getPsiteCoordinates(bamfile, bestpsite=bestpsite,
                                anchor = anchor)
      pc.sub <- pc[pc$qwidth %in% readsLen]
      pc.sub <- shiftReadsByFrame(pc.sub, txdb,
                                  ignore.seqlevelsStyle=ignore.seqlevelsStyle)
    })
  }else{##mRNA
    ignore.strand <- TRUE
    reads <- lapply(files, function(f){
      bamfile <- BamFile(file = f, yieldSize = yieldSize)
      pc <- getPsiteCoordinates(bamfile, bestpsite=1)
      pc <- fixSeqlevelsStyle(pc, txdb,
                              ignore.seqlevelsStyle=ignore.seqlevelsStyle)
    })
  }
  names(reads) <- basename(sub(".bam", "", files,
                               ignore.case = TRUE))
  features <- switch(region,
    cds=cds(txdb, columns=c("gene_id", "tx_name")),
    utr5={
      f <- fiveUTRsByTranscript(txdb, use.name=TRUE)
      fs <- unlist(f)
      mcols(fs) <- DataFrame(tx_name=rep(names(f), lengths(f)))
      suppressMessages(id_map <-
                         select(txdb, keys=unique(fs$tx_name),
                                columns = c("TXNAME", "GENEID"),
                                keytype="TXNAME"))
      fs$gene_id <-
        id_map[match(fs$tx_name, id_map$TXNAME), "GENEID"]
      fs
    },
    utr3={
      f <- threeUTRsByTranscript(txdb, use.name=TRUE)
      fs <- unlist(f)
      mcols(fs) <- DataFrame(tx_name=rep(names(f), lengths(f)))
      suppressMessages(id_map <-
                         select(txdb, keys=unique(fs$tx_name),
                                columns = c("TXNAME", "GENEID"),
                                keytype="TXNAME"))
      fs$gene_id <-
        id_map[match(fs$tx_name, id_map$TXNAME), "GENEID"]
      fs
    },
    exon=exons(txdb, columns=c("gene_id", "tx_name")),
    transcripts=transcripts(txdb, columns=c("gene_id", "tx_name")),
    "feature with extension"={
      f <- transcripts(txdb, columns=c("gene_id", "tx_name"))
      e <- exons(txdb, columns=c("gene_id", "tx_name"))
      tx_name <- e$tx_name
      e <- rep(e, lengths(tx_name))
      e$tx_name <- unlist(tx_name)
      CDS <- cds(txdb, columns=c("gene_id", "tx_name"))
      tx_name <- CDS$tx_name
      CDS <- rep(CDS, lengths(tx_name))
      CDS$tx_name <- unlist(tx_name)
      ## avoid overlaps of extension region with feature region
      getExt <- function(ext, f, e, start=TRUE){
        exts <- flank(f, ext, start=start)
        diffs <- setdiff(exts, f)
        ols <- findOverlaps(diffs, exts, type = "within")
        es <- diffs[queryHits(ols)]
        mcols(es) <- mcols(exts[subjectHits(ols)])
        dists <- distance(es, f[match(es$tx_name, f$tx_name)])
        es <- es[dists==0]
        ## merge to exon
        ol <- findOverlaps(es, e, maxgap = 1)
        ol <- ol[es[queryHits(ol)]$tx_name == e[subjectHits(ol)]$tx_name]
        es <- es[queryHits(ol)]
        e1 <- e[subjectHits(ol)]
        dist <- distance(es, e1)
        es <- es[dist==0]
        e1 <- e1[dist==0]
        ol <- ol[dist==0]
        start(es) <- ifelse(start(es)<start(e1), start(es), start(e1))
        end(es) <- ifelse(end(es)<end(e1), end(e1), end(es))
        e[subjectHits(ol)] <- es
        e
      }
      exStart <- getExt(ext, f, e, start=TRUE)
      exEnd <- getExt(ext, f, e, start=FALSE)
      f_ex <- c(f, CDS, exStart, exEnd)
      f_ex <- split(f_ex, f_ex$tx_name)
      f_ex <- disjoin(f_ex)
      f_ex <- unlist(f_ex)
      mcols(f_ex) <- mcols(f)[match(names(f_ex), f$tx_name), ]
      f_ex
    }
  )
  features <- switch(level,
                     gene={
                       f <- rep(features, lengths(features$gene_id))
                       mcols(f) <-
                         DataFrame(feature_id=unlist(features$gene_id))
                       f[!is.na(f$feature_id)]
                     },
                     tx={
                       f <- rep(features, lengths(features$tx_name))
                       mcols(f) <-
                         DataFrame(feature_id=unlist(features$tx_name))
                       f[!is.na(f$feature_id)]
                     })
  cvgs <- lapply(reads, coverage)
  seqs <- lapply(cvgs, function(.ele)
    names(.ele)[vapply(.ele, sum, FUN.VALUE = 0)>0])
  seqs <- unique(unlist(seqs))
  seqs <- intersect(seqlevels(features), seqs)
  features <- features[as.character(seqnames(features)) %in% seqs]
  seqlevels(features) <- seqlevels(features)[seqlevels(features) %in% seqs]
  features1 <- disjoin(features, with.revmap=TRUE)
  f <- rep(features1, lengths(features1$revmap))
  f$feature_id <- features$feature_id[unlist(features1$revmap)]
  f$revmap <- NULL
  f <- f[!duplicated(f) | !duplicated(f$feature_id)]
  ## make sure that all features are sorted by start position.
  f <- f[order(f$feature_id, as.character(seqnames(f)),
               ifelse(as.character(strand(f))=="-", -1, 1)*start(f))]
  f <- split(f, f$feature_id)
  coverages <- lapply(reads, coverageByTranscript, transcripts=f,
                      ignore.strand=ignore.strand)
  cd <- cvgd(coverage=coverages, granges=f)
  return(cd)
}

#' Plot splice event
#' @description Plot the splice event
#' @param se Output of \link{spliceEvent}
#' @param tx_name Transcript name.
#' @param coverage Coverages of feature region with extensions.
#' Output of \link{coverageDepth}
#' @param group1,group2 The sample names of group 1 and group 2
#' @param cutoffFDR Cutoff of FDR
#' @param resetIntronWidth logical(1). If set to true,
#' reset the region with no read to minimal width.
#' @importFrom ggplot2 geom_segment geom_rect theme element_blank
#' @export
#' @return A ggplot object.
#' @examples
#' \dontrun{
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' coverage <- coverageDepth(RPFs, gtf=gtf, level="gene",
#'                           region="feature with extension")
#' group1 <- c("RPF.KD1.1", "RPF.KD1.2")
#' group2 <- c("RPF.WT.1", "RPF.WT.2")
#' se <- spliceEvent(coverage, group1, group2)
#' plotSpliceEvent(se, se$feature[1], coverage, group1, group2)
#' }

plotSpliceEvent <- function(se, tx_name, coverage, group1, group2,
                            cutoffFDR=0.05, resetIntronWidth=TRUE){
  stopifnot(length(tx_name)==1)
  if(!is(se, "GRanges") || length(se$feature)==0){
    stop("se must be output of spliceEvent")
  }
  if(!is.list(coverage)){
    stop("coverage must be output of coverageDepth")
  }
  if(!"RPFs" %in% names(coverage)){
    stop("coverage must be output of coverageDepth.",
         "And RPFs must be available.")
  }
  if(missing(group1) || missing(group2)){
    stop("group1 or group2 does not have default value")
  }
  cvg <- coverage[["RPFs"]][["coverage"]]
  gr <- coverage[["RPFs"]][["granges"]]
  se.s <- se[se$feature %in% tx_name]
  se.s <- se.s[se.s$FDR<cutoffFDR]
  cvg.s <- lapply(cvg, function(.ele) .ele[[tx_name]])
  cvg.s <- cvg.s[c(group1, group2)]
  gr <- gr[[tx_name]]
  cvg.s <- lapply(cvg.s, as.numeric)
  cvg.s <- do.call(cbind, cvg.s)
  wid <- width(gr)
  id <- rep(seq_along(wid), wid)
  cvg.s <- rowsum(cvg.s, id)
  if(resetIntronWidth){
    cvg.s0 <- rowSums(cvg.s) == 0
    wid[cvg.s0] <- min(wid)
  }
  ol <- findOverlaps(se.s, gr)
  x0 <- cumsum(c(0, wid))
  x <- rep(x0[-length(x0)], ncol(cvg.s))
  xend <- rep(x0[-1], ncol(cvg.s))
  height <- group <- xmax <- xmin <- ymax <- ymin <- NULL
  df <- data.frame(height=log2(as.numeric(cvg.s)+1),
                   sample = rep(colnames(cvg.s), each = nrow(cvg.s)),
                   group = ifelse(rep(colnames(cvg.s),
                                      each = nrow(cvg.s)) %in% group1,
                                  "group1", "group2"),
                   x = x,
                   xend = xend)
  p <- ggplot(data = df, aes(x=x, xend=xend, y=height, yend=height,
                             color = group, fill = sample)) +
    geom_segment() +
    xlab("") + ylab("log2 transformed reads count") +
    theme_classic() +
    theme(axis.title.x=element_blank(),
          axis.text.x=element_blank(),
          axis.ticks.x=element_blank())
  if(length(ol)>0) p <- p +
    geom_rect(data = data.frame(xmin = x[subjectHits(ol)],
                                ymin = -.05,
                                xmax = xend[subjectHits(ol)],
                                ymax = max(df$height)*1.05),
              aes(xmin=xmin, ymin=ymin, xmax=xmax, ymax=ymax),
              fill = "#33333333", inherit.aes = FALSE)
  p
}

#' Get splicing events
#' @description Get differentical usage of alternative
#' Translation Initiation Sites,
#' alternative Polyadenylation Sites or
#' alternative splicing sites
#' @param coverage Coverages of feature region with extensions.
#' Output of \link{coverageDepth}
#' @param group1,group2 The sample names of group 1 and group 2
#' @importFrom cluster silhouette
#' @importFrom stats fisher.test dist kmeans p.adjust
#' @export
#' @return A GRanges object of splice events.
#' @examples
#' \dontrun{
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' coverage <- coverageDepth(RPFs, gtf=gtf,
#'                   level="gene", region="feature with extension")
#' group1 <- c("RPF.KD1.1", "RPF.KD1.2")
#' group2 <- c("RPF.WT.1", "RPF.WT.2")
#' se <- spliceEvent(coverage, group1, group2)
#' }
spliceEvent <- function(coverage, group1, group2){
  if(!is.list(coverage)){
    stop("coverage must be output of coverageDepth")
  }
  if(!"RPFs" %in% names(coverage)){
    stop("coverage must be output of coverageDepth.",
         "And RPFs must be available.")
  }
  if(missing(group1) || missing(group2)){
    stop("group1 or group2 does not have default value")
  }
  cvg <- coverage[["RPFs"]][["coverage"]]
  gr <- coverage[["RPFs"]][["granges"]]
  if(any(!group1 %in% names(cvg))){
    stop("All the samples should be in coverage.",
         paste(group1[!group1 %in% names(cvg)], collapse = ", "),
         "is not in names of coverage(",
         paste(names(cvg), collapse = ", "),
         ").")
  }
  if(any(!group2 %in% names(cvg))){
    stop("All the samples should be in coverage.",
         paste(group1[!group2 %in% names(cvg)], collapse = ", "),
         "is not in names of coverage(",
         paste(names(cvg), collapse = ", "),
         ").")
  }
  gp1 <- cvg[group1]
  gp2 <- cvg[group2]
  gp1rd <- Reduce(`+`, gp1)
  gp2rd <- Reduce(`+`, gp2)
  rd <- gp1rd + gp2rd
  rds <- vapply(rd, sum, FUN.VALUE = 0)
  keep <- rds>lengths(gr) #reason? average reads number per exon smaller than 1.
  #message("filtered events: ", sum(!keep))
  cvg <- cvg[keep]
  gr <- gr[keep]
  gp1 <- gp1[keep]
  gp2 <- gp2[keep]
  gp1rd <- gp1rd[keep]
  gp2rd <- gp2rd[keep]

  ## get cluster number
  resolution <- 200
  getK <- function(x, y, r){
    x <- log2(as.numeric(x)+1)
    y <- log2(as.numeric(y)+1)
    r1 <- tile(r, width = resolution)
    r1[[1]]$feature_id <- "aTIS"
    start(r1[[1]][1]) <- start(r)[1]
    end(r1[[1]][length(r1[[1]])]) <- end(r)[1]
    r1[[length(r1)]]$feature_id <- "aPAS"
    start(r1[[length(r1)]][1]) <- start(r)[length(r1)]
    end(r1[[length(r1)]][length(r1[[length(r1)]])]) <- end(r)[length(r1)]
    if(length(r)>2){
      r_new <- c(r1[[1]], r[-c(1, length(r))], r1[[length(r1)]])
    }else{
      r_new <- unlist(r1)
    }
    wid <- width(r_new)
    id <- rep(seq_along(wid), wid)
    ## resample
    xs <- rowsum(cbind(x,y), id)
    xs <- 3*xs/wid

    z <- as.numeric(xs)
    n <- length(unique(z))
    if(n==1) return(NULL)
    diss <- dist(xs)
    nc.max <- min(apply(xs, 2, function(.e) length(unique(.e))), 4)
    if(nc.max==1) return(NULL)
    v <- rep(0, nc.max)
    for (i in seq.int(nc.max)[-1]) {
      if(nrow(xs)==i){
        v[i] <- i
      }else{
        clust <- kmeans(xs, i)
        ss <- silhouette(clust$cluster, diss)
        v[i] <- mean(ss[, 3])
      }
    }
    k <- min(which.max(v), n)
    getKm <- function(a){
      if(length(a)==k){
        order(a)
      }else{
        km <- kmeans(a, centers = k)
        oid <- order(km$centers)
        nid <- seq_along(oid)
        names(nid) <- oid
        nid[as.character(km$cluster)]
      }
    }
    km_x <- getKm(xs[, "x"])
    km_y <- getKm(xs[, "y"])
    idx <- which(km_x!=km_y)
    if(length(idx)==0) return(NULL)
    if(length(idx)!=nrow(xs)){
      mu.idx <- xs[-idx, , drop=FALSE]
      mu.idx <- mu.idx[rowSums(mu.idx)!=0, , drop=FALSE]
      if(nrow(mu.idx)>0){
        mu <- colMeans(xs[-idx, , drop=FALSE])
      }else{
        mu <- colMeans(xs)
      }
    }else{
      mu <- colMeans(xs)
    }
    sel <- xs[idx, , drop=FALSE]
    type <- r_new$feature_id[idx]
    xs1 <- xs
    if(any(r_new$feature_id %in% "aTIS")){
      xs1[r_new$feature_id=="aTIS", "x"] <-
        cumsum(rev(xs[r_new$feature_id=="aTIS", "x"]))/
        sum(r_new$feature_id=="aTIS")
      xs1[r_new$feature_id=="aTIS", "y"] <-
        cumsum(rev(xs[r_new$feature_id=="aTIS", "y"]))/
        sum(r_new$feature_id=="aTIS")
    }
    if(any(r_new$feature_id %in% "aPAS")){
      xs1[r_new$feature_id=="aPAS", "x"] <-
        cumsum(xs[r_new$feature_id=="aPAS", "x"])/
        sum(r_new$feature_id=="aPAS")
      xs1[r_new$feature_id=="aPAS", "y"] <-
        cumsum(xs[r_new$feature_id=="aPAS", "y"])/
        sum(r_new$feature_id=="aPAS")
    }
    if(as.character(strand(r_new)[1])!="-") {
      if(any(r_new$feature_id %in% "aTIS"))
        end(r_new[r_new$feature_id=="aTIS"]) <-
          max(end(r_new[r_new$feature_id=="aTIS"]))
      if(any(r_new$feature_id %in% "aPAS"))
        start(r_new[r_new$feature_id=="aPAS"]) <-
          min(start(r_new[r_new$feature_id=="aPAS"]))
    }else{
      if(any(r_new$feature_id %in% "aPAS"))
        end(r_new[r_new$feature_id=="aPAS"]) <-
          max(end(r_new[r_new$feature_id=="aPAS"]))
      if(any(r_new$feature_id %in% "aTIS"))
        start(r_new[r_new$feature_id=="aTIS"]) <-
          min(start(r_new[r_new$feature_id=="aTIS"]))
    }
    wid <- width(r_new)
    pvalue <- vapply(idx, function(i){
      v <- rbind(xs1[i, , drop=FALSE], mu)*wid[i]
      v <- round(2^v)
      tryCatch(fisher.test(v)$p.value,
               error = function(e){
                 1
               })
    }, FUN.VALUE = 0.0)
    out <- r_new[idx]
    mcols(out) <- data.frame(gp1=sel[, 1], gp2=sel[, 2],
                             mu_gp1=mu[1], mu_gp2=mu[2],
                             pvalue, type, stringsAsFactors = FALSE)
    k <- out$type %in% "aTIS"
    if(any(k)){
      k1 <- which.min(out[k]$pvalue)
      k <- which(k)
      k <- k[k!=k1]
      out <- out[-k]
    }
    k <- out$type %in% "aPAS"
    if(any(k)){
      k1 <- which.min(out[k]$pvalue)
      k <- which(k)
      k <- k[k!=k1]
      out <- out[-k]
    }
    out
  }
  kk <- mapply(getK, gp1rd, gp2rd, gr)
  kk <- kk[lengths(kk)>0]
  kk <- unlist(GRangesList(kk))
  kk$FDR <- p.adjust(kk$pvalue, method = "BH")
  kk$feature <- names(kk)
  type <- kk$type
  kk$type <- NULL
  type[!type %in% c("aPAS", "aTIS")] <- "aSE"
  kk$type <- as.factor(type)
  kk[order(kk$FDR)]
}

require("ribosomeProfilingQC") || stop("unable to load Package:ribosomeProfilingQC")
require("GenomicRanges") || stop("unable to load Package::GenomicRanges")
require("GenomicFeatures") || stop("unable to load Package::GenomicFeatures")
require("GenomicAlignments") || stop("unalbe to load Package:GenomicAlignments")
require("utils") || stop("unable to load Package:utils")
require("AnnotationDbi") || stop("unable to load Package:AnnotationDbi")
require("BSgenome.Drerio.UCSC.danRer10") || stop("unable to load Package:BSgenome.Drerio.UCSC.danRer10")
require("Rsamtools") || stop("unable to load Rsamtools")
require("rtracklayer") || stop("unable to load rtracklayer")
require("testthat") || stop("unable to load testthat")
test_check("ribosomeProfilingQC")

#' @importFrom txdbmaker makeTxDbFromGFF
prepareTxDb <- function(gtf, param='gtf', ...){
  txdb <- NULL
  if(is(gtf, "TxDb")){
    txdb <- gtf
  }else{
    if(is.character(gtf)){
      gtf <- gtf[1]
      suppressWarnings(suppressMessages(txdb <- makeTxDbFromGFF(gtf, ...)))
    }
  }
  if(!is(txdb, "TxDb")){
    stop("Can not determine annotations from ", param, " parameter.")
  }
  return(txdb)
}

#' Shift reads by reading frame
#' @description Shift reads P site position by reading frame. After shifting,
#' all reading frame will be set as 0
#' @param reads Output of \link{getPsiteCoordinates}
#' @param txdb A TxDb object.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @return Reads with reading frame information
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' pc <- getPsiteCoordinates(bamfile, bestpsite=11)
#' pc.sub <- pc[pc$qwidth %in% c(29, 30)]
#' library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' txdb <- makeTxDbFromGFF(system.file("extdata",
#'           "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'           package="ribosomeProfilingQC"),
#'           organism = "Danio rerio",
#'           chrominfo = seqinfo(Drerio)["chr1"],
#'           taxonomyId = 7955)
#' pc.sub <- shiftReadsByFrame(pc.sub, txdb)
#'
shiftReadsByFrame <- function(reads, txdb, ignore.seqlevelsStyle=FALSE){
  stopifnot(is(txdb, "TxDb"))
  stopifnot(is(reads, "GRanges"))
  if(length(reads$Psite)!=length(reads)){
    stop("reads must be output of getPsiteCoordinates.")
  }
  reads <- fixSeqlevelsStyle(reads, txdb,
                             ignore.seqlevelsStyle=ignore.seqlevelsStyle)
  reads <- assignReadingFrame(reads, txdb=txdb,
                              ignore.seqlevelsStyle=ignore.seqlevelsStyle)
  nstr <- as.character(strand(reads)) == "-"
  pstr <- !nstr & !is.na(reads$readingFrame)
  nstr <- nstr & !is.na(reads$readingFrame)
  start(reads[pstr]) <- start(reads[pstr]) - reads[pstr]$readingFrame
  reads[pstr]$position <- reads[pstr]$position - reads[pstr]$readingFrame
  reads[pstr]$posToStop <- reads[pstr]$posToStop + reads[pstr]$readingFrame
  reads[pstr]$Psite <- reads[pstr]$Psite - reads[pstr]$readingFrame
  end(reads[nstr]) <- start(reads[nstr]) + reads[nstr]$readingFrame
  start(reads[nstr]) <- end(reads[nstr])
  reads[nstr]$position <- reads[nstr]$position - reads[nstr]$readingFrame
  reads[nstr]$posToStop <- reads[nstr]$posToStop + reads[nstr]$readingFrame
  reads[nstr]$Psite <- reads[nstr]$Psite - reads[nstr]$readingFrame
  width(reads) <- 1
  reads[!is.na(reads$readingFrame)]$readingFrame <- 0
  reads
}

#' Plot reads P site abundance for a specific transcript
#' @description Plot the bundances of P site on a transcript.
#' @param reads Output of \link{assignReadingFrame}
#' @param tx_name Transcript names.
#' @param col Colors for reading frames
#' @return Invisible heights of the barplot.
#' @importFrom methods as is
#' @importFrom graphics barplot legend par
#' @export
#' @examples
#' pcs <- readRDS(system.file("extdata", "samplePc.rds",
#'                package="ribosomeProfilingQC"))
#'
#' plotTranscript(pcs, c("ENSDART00000152562", "ENSDART00000054987"))
plotTranscript <- function(reads, tx_name,
                           col=c("Frame_0" = "#009E73",
                                 "Frame_1" = "#D55E00",
                                 "Frame_2" = "#0072B2")){
  stopifnot(is(reads, "GRanges"))
  if(length(reads$tx_name)!=length(reads) ||
     length(reads$position)!=length(reads) ||
     length(reads$posToStop)!=length(reads) ||
     length(reads$readingFrame)!=length(reads) ||
     length(reads$gene_id)!=length(reads)){
    stop("reads must be a result of assignReadingFrame")
  }
  l <- length(tx_name)
  op <- par(mfrow = c(ceiling(l/floor(sqrt(l))), floor(sqrt(l))))
  on.exit(par(op))
  heights <- list()
  for(i in tx_name){
    x.sub <- reads[reads$tx_name %in% i]
    if(length(x.sub)<1){
      adist <- adist(reads$tx_name, i)
      adist.min <- min(adist, na.rm = TRUE)
      possibleTxName <- 
        unique(reads$tx_name[adist==adist.min & 
                               !is.na(reads$tx_name)])
      warning("No reads in ", i, ".",
              "The closest transcripts are: ",
              paste(possibleTxName, collapse = ", "))
      heights[[i]] <- numeric()
    }else{
      d <- table(mcols(x.sub)[, c("readingFrame", "position")])
      CDS.size <- x.sub[1]$position + x.sub[1]$posToStop + 3
      at <- as.character(seq.int(CDS.size))
      height <- colSums(d)
      height <- height[at]
      height[is.na(height)] <- 0
      names(height) <- at
      cols <- col[apply(d, 2, function(.ele) which(.ele!=0))]
      names(cols) <- colnames(d)
      cols <- cols[at]
      names(cols) <- at
      barplot(xlim=c(0, CDS.size),
              height=height,
              xlab = paste("Base position relative to", i,"CDS"),
              ylab = "Number of reads",
              col = cols, border=cols,  main = i)
      legend("topleft", legend = names(col),
             fill = col, border = col, bg = NA, box.col = NA)
      heights[[i]] <- height
    }
  }
  return(invisible(heights))
}

#' Assign reading frame
#' @description Set reading frame for each reads in CDS region to frame0,
#' frame1 and frame2.
#' @param reads Output of \link{getPsiteCoordinates}
#' @param CDS Output of \link{prepareCDS}
#' @param txdb A TxDb object. If it is set, assign reading frame for all reads.
#' Default missing, only assign rading frame for reads in CDS.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @return An GRanges object of reads with reading frame information.
#' @import GenomicRanges
#' @importFrom methods as is
#' @importFrom S4Vectors subjectHits queryHits
#' @importFrom GenomeInfoDb seqlevelsStyle seqlevelsStyle<-
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' pc <- getPsiteCoordinates(bamfile, bestpsite=13)
#' pc.sub <- pc[pc$qwidth %in% c(29, 30)]
#' #library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' #txdb <- makeTxDbFromGFF(system.file("extdata",
#'  #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'  #         package="ribosomeProfilingQC"),
#'  #         organism = "Danio rerio",
#'  #         chrominfo = seqinfo(Drerio)["chr1"],
#'  #         taxonomyId = 7955)
#' #CDS <- prepareCDS(txdb)
#' CDS <- readRDS(system.file("extdata", "CDS.rds",
#'                            package="ribosomeProfilingQC"))
#' pc.sub <- assignReadingFrame(pc.sub, CDS)

assignReadingFrame <- function(reads, CDS, txdb, ignore.seqlevelsStyle=FALSE){
  if(!missing(txdb)){
    stopifnot(is(txdb, "TxDb"))
    CDS <- prepareCDS(txdb, withUTR=TRUE)
  }
  stopifnot(is(CDS, "GRanges"))
  if(length(CDS$internalPos)!=length(CDS) ||
     length(CDS$isLastExonInCDS)!=length(CDS) ||
     length(CDS$tx_name)!=length(CDS) ||
     length(CDS$gene_id)!=length(CDS)){
    stop("CDS must be output of prepareCDS")
  }
  stopifnot(is(reads, "GRanges"))
  reads <-fixSeqlevelsStyle(reads, CDS, ignore.seqlevelsStyle)
  reads$readingFrame <- NA
  reads$position <- NA
  reads$offsetPercentage <- NA
  reads$posToStop <- NA
  reads$tx_name <- NA
  reads$gene_id <- NA
  CDS.last <- CDS[CDS$isLastExonInCDS]
  names(CDS.last) <- CDS.last$tx_name
  ## check reading frame in CDS
  ol <- findOverlaps(reads, CDS, ignore.strand=FALSE)
  sh <- CDS[subjectHits(ol)]
  qh <- reads[queryHits(ol)]
  dist <- distance(qh, promoters(sh, upstream = 1, downstream = 0),
                   ignore.strand=FALSE)
  if(!missing(txdb)){
    sh.rev <- switch.strand(sh)
    p <- promoters(sh.rev, upstream = 1, downstream = 0)
    p <- switch.strand(p)
    dist2 <- -1 * distance(qh, p, ignore.strand=FALSE)
    dist <- ifelse(sh$wid.cumsum<0, dist2, dist)
  }
  pos <- dist + sh$internalPos
  cvg <- pos/CDS.last[sh$tx_name]$wid.cumsum
  toStop <- CDS.last[sh$tx_name]$wid.cumsum - pos - 3 # stop codon
  tx_name <- sh$tx_name
  gene_id <- sh$gene_id
  pos <- data.frame(id=queryHits(ol), frame=pos %% 3, pos=pos, cvg=cvg,
                    toStop=toStop, tx_name=tx_name, gene_id=gene_id,
                    stringsAsFactors=FALSE)
  pos <- pos[order(pos$id, pos$frame), ]
  pos <- pos[!duplicated(pos$id), ]
  reads$readingFrame[pos$id] <- pos$frame
  reads$position[pos$id] <- pos$pos
  reads$offsetPercentage[pos$id] <- pos$cvg
  reads$posToStop[pos$id] <- pos$toStop
  reads$tx_name[pos$id] <- pos$tx_name
  reads$gene_id[pos$id] <- pos$gene_id
  reads
}

#' Plot density for each reading frame
#' @description Plot density for each reading frame.
#' @param reads Output of \link{assignReadingFrame}
#' @param density Plot density or counts
#' @param col Colors for reading frames
#' @return A ggplot object.
#' @importFrom methods as is
#' @export
#' @examples
#' pcs <- readRDS(system.file("extdata", "samplePc.rds",
#'                package="ribosomeProfilingQC"))
#' plotFrameDensity(pcs)
plotFrameDensity <- function(reads, density=TRUE,
                           col=c("Frame_0" = "#009E73",
                                 "Frame_1" = "#D55E00",
                                 "Frame_2" = "#0072B2")){
  stopifnot(is(reads, "GRanges"))
  if(length(reads$readingFrame)!=length(reads)){
    stop("reads must be a result of assignReadingFrame")
  }
  data <- table(reads$readingFrame)
  if(density) data <- data/sum(data)
  ggBar(height = data*100, xlab="Frame",
        ylab=ifelse(density, "Relative Read Density (%)", "Read Count"),
        fill = col, postfix = ifelse(density, "%", FALSE))
}

#' Normalization by RUVSeq
#' @description Normalization by RUVSeq:RUVs methods
#' @param counts Output of \link{countReads}
#' @param RPFgroup,mRNAgroup Groups for RPF and mRNA files
#' @param k The number of factor of unwanted variation to be estimated from
#' the data. See \link[RUVSeq:RUVs]{RUVs}
#' @return Normalized counts list
#' @importFrom RUVSeq RUVs makeGroups
#' @importFrom EDASeq betweenLaneNormalization newSeqExpressionSet counts
#'  normCounts
#' @export
#' @examples
#' \dontrun{##waiting for EDASeq fix the issue.
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' #RPFs <- dir(path, "RPF.*?.[12].bam$", full.names=TRUE)
#' #RNAs <- dir(path, "mRNA.*?.[12].bam$", full.names=TRUE)
#' #gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' #cnts <- countReads(RPFs, RNAs, gtf, level="gene")
#' cnts <- readRDS(file.path(path, "cnts.rds"))
#' gp <- c("KD1", "KD1", "WT", "WT")
#' norm <- normByRUVs(cnts, gp, gp)
#' }
#'

#### Normalization by RUVSeq
#RUVSeq can be used to remove unwanted variation form
#RNA-Seq data[@risso2014normalization].
#Here we can also use the power of RUVSeq to normalize the count number
#before we calculate translational efficiency.
#
#```{r}
#gp <- c("KD1", "KD1", "WT", "WT")
#norm <- normByRUVs(cnts, gp)
#```

normByRUVs <- function(counts, RPFgroup, mRNAgroup=RPFgroup, k=1){
  if(!any(c("RPFs", "mRNA") %in% names(counts))){
    stop("counts must be output of coutReads.")
  }
  if(!missing(RPFgroup)){
    if("RPFs" %in% names(counts)){
      counts$RPFsRawCounts <- counts$RPFs
      RPFs <- counts$RPFs
      if(length(RPFgroup)!=ncol(RPFs)){
        stop("length of RPFgroup is not identical to number of RPF samples")
      }
      counts$RPFs <- normHelper(RPFs, RPFgroup, k)
    }else{
      warning("RPFgroup is set but can not find RPF reads count.")
    }
  }
  if(!missing(mRNAgroup)){
    if("mRNA" %in% names(counts)){
      counts$mRNARawCounts <- counts$mRNA
      mRNA <- counts$mRNA
      if(length(mRNAgroup)!=ncol(mRNA)){
        stop("length of mRNAgroup is not identical to number of mRNA samples")
      }
      counts$mRNA <- normHelper(mRNA, mRNAgroup, k)
    }else{
      warning("mRNAgroup is set but can not find mRNA reads count.")
    }
  }
  counts
}

normHelper <- function(cnt, gp, k){
  x <- as.factor(gp)
  set <- newSeqExpressionSet(as.matrix(cnt),
                             phenoData = data.frame(x,
                                                    row.names = colnames(cnt)))
  set1 <- betweenLaneNormalization(set, which = "upper")
  differences <- makeGroups(xs = x)
  nc <- normCounts(set1)
  if(!any(is.na(nc) | is.infinite(nc))){
    set <- set1
  }
  set <- RUVs(x = set, cIdx = rownames(cnt), k=k, scIdx=differences)
  normCounts(set)
}

#' Get reads length to keep by cutoff percentage
#' @description Set the percentage to filter the reads.
#' @param readsLengthDensity Output of \link{summaryReadsLength}
#' @param cutoff Cutoff value.
#' @return Reads length to be kept.
#' @importFrom methods as is
#' @export
#' @examples
#' reads <- GRanges("chr1", ranges=IRanges(seq.int(100), width=1),
#'                  qwidth=sample(25:31, size = 100, replace = TRUE,
#'                                prob = c(.01, .01, .05, .1, .77, .05, .01)))
#' readsLenToKeep(summaryReadsLength(reads, plot=FALSE))
readsLenToKeep <- function(readsLengthDensity, cutoff=0.8){
  stopifnot(is.table(readsLengthDensity))
  readsLengthDensity <- sort(readsLengthDensity, decreasing = TRUE)
  x <- cumsum(readsLengthDensity)
  x <- x[seq.int(which(x>cutoff)[1])]
  x <- range(as.numeric(names(x)))
  seq(from=min(x), to=max(x))
}

test_that("readsLenToKeep or summaryReadsLength works not correct", {
  set.seed(1)
  prob <- c(.01, .01, .05, .1, .77, .05, .01)
  reads <- GRanges("chr1", ranges=IRanges(seq.int(10000), width=1),
                   qwidth=sample(25:31, size = 10000, replace = TRUE,
                                 prob = prob))
  sr <- summaryReadsLength(reads, widthRange = 25:31, plot = FALSE)
  expect_equivalent(as.numeric(sr),
                    sort(prob, decreasing=TRUE),
                    tolerance=.01)
  rtk <- readsLenToKeep(sr, cutoff = .8)
  expect_equivalent(rtk, c(28, 29))
  rtk <- readsLenToKeep(sr, cutoff = .7)
  expect_equivalent(rtk, 29)
})

#' Start or Stop codon usage
#' @description Calculate the start or stop codon usage for the identified CDSs.
#' @param reads Output of \link{assignReadingFrame}.
#' @param start Calculate for start codon or stop codon.
#' @param genome A BSgenome object.
#' @return Table of codon usage.
#' @importFrom methods as is
#' @importFrom Biostrings getSeq
#' @export
#' @examples
#' pcs <- readRDS(system.file("extdata", "samplePc.rds",
#'                package="ribosomeProfilingQC"))
#' library(BSgenome.Drerio.UCSC.danRer10)
#' codonUsage(pcs, genome=Drerio)
#' codonUsage(pcs, start=FALSE, genome=Drerio)
codonUsage <- function(reads, start=TRUE, genome){
  stopifnot(is(reads, "GRanges"))
  stopifnot(is.logical(start))
  stopifnot(inherits(genome, c("DNAStringSet", "BSgenome")))
  if(length(reads$tx_name)!=length(reads) ||
     length(reads$position)!=length(reads) ||
     length(reads$posToStop)!=length(reads) ||
     length(reads$readingFrame)!=length(reads) ||
     length(reads$gene_id)!=length(reads)){
    stop("reads must be a result of assignReadingFrame")
  }
  if(start){
    reads <- reads[!is.na(reads$position)]
    reads <- reads[reads$position==0]
  }  else {
    reads <- reads[!is.na(reads$posToStop)]
    reads <- reads[reads$posToStop==0]
  }
  reads <- promoters(reads, upstream = 0, downstream = 3)
  seq <- getSeq(genome, reads)
  sort(table(seq), decreasing = TRUE)
}

#' Plot the distribution of reads in sense and antisense strand
#' @description Plot the distribution of reads in sense and antisense strand to
#' check the mapping is correct.
#' @param reads Output of \link{getPsiteCoordinates}
#' @param CDS Output of \link{prepareCDS}
#' @param col Coloar for sense and antisense strand.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @param ... Parameter passed to barplot
#' @return A ggplot object.
#' @import GenomicRanges
#' @importFrom methods as is
#' @importFrom graphics barplot
#' @importFrom S4Vectors queryHits
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' pc <- getPsiteCoordinates(bamfile, bestpsite=11)
#' pc.sub <- pc[pc$qwidth %in% c(29, 30)]
#' library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' txdb <- makeTxDbFromGFF(system.file("extdata",
#'           "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'           package="ribosomeProfilingQC"),
#'           organism = "Danio rerio",
#'           chrominfo = seqinfo(Drerio)["chr1"],
#'           taxonomyId = 7955)
#' CDS <- prepareCDS(txdb)
#' strandPlot(pc.sub, CDS)
#'
strandPlot <- function(reads, CDS, col=c("#009E73", "#D55E00"),
                       ignore.seqlevelsStyle=FALSE, ...){
  stopifnot(is(reads, "GRanges"))
  stopifnot(is(CDS, "GRanges"))
  reads <- fixSeqlevelsStyle(reads, CDS, ignore.seqlevelsStyle)
  ## reads mapped to sense strand
  ol <- findOverlaps(reads, CDS, ignore.strand=FALSE)
  a <- unique(queryHits(ol))
  ## reads mapped to antisense strand
  reads.rev <- switch.strand(reads)
  ol.anti <- findOverlaps(reads.rev, CDS, ignore.strand=FALSE)
  b <- unique(queryHits(ol.anti))
  b <- b[!b %in% a]
  per <- c(sense=length(a), antisense=length(b))/length(reads)*100
  ggBar(per, ylab="mapping rate (%)", xlab="", fill=col, postfix = "%")
}

switch.strand <- function(x){
  str <- strand(x)
  stopifnot(all(levels(str)==c("+", "-", "*")))
  levels(str) <- c("-", "+", "*")
  strand(x) <- factor(str, levels=c("+", "-", "*"))
  x
}

#' Codon usage bias
#' @description Calculate the codon usage for the reads in the identified CDSs.
#' And then compared to the reference codon usage.
#' @param RPFs Bam file names of RPFs.
#' @param gtf GTF file name for annotation or a TxDb object.
#' @param genome A BSgenome object.
#' @param bestpsite P site postion.
#' @param readsLen Reads length to keep.
#' @param anchor 5end or 3end. Default is 5end.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @param summary Return the summary of codon usage bias or full list.
#' @param removeDuplicates Remove the PCR duplicates or not. Default TRUE.
#' @param ... Parameters pass to
#' \link[txdbmaker:makeTxDbFromGFF]{makeTxDbFromGFF}
#' @return A list of data frame of codon count table if summary is TRUE.
#'  list 'reads' means the counts by raw reads.
#'  list 'reference' means the counts by sequence extracted from reference by
#'  the coordinates of mapped reads.
#'  Otherwise, return the counts (reads/reference) table for each reads.
#' @importFrom txdbmaker makeTxDbFromGFF
#' @importFrom BSgenome getSeq
#' @importFrom Biostrings trinucleotideFrequency GENETIC_CODE AMINO_ACID_CODE
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' library(BSgenome.Drerio.UCSC.danRer10)
#' cb <- codonBias(RPFs[c(1,2)], gtf=gtf, genome=Drerio)
codonBias <- function(RPFs, gtf, genome,
                      bestpsite=13,
                      readsLen=c(28,29),
                      anchor="5end",
                      ignore.seqlevelsStyle=FALSE,
                      summary=TRUE,
                      removeDuplicates = TRUE,
                      ...){
  yieldSize <- 10000000
  stopifnot(is.logical(summary))
  summary <- summary[1]
  stopifnot(is.character(gtf)||is(gtf, "TxDb"))
  stopifnot(inherits(genome, c("DNAStringSet", "BSgenome")))
  anchor <- match.arg(anchor, choices = c("5end", "3end"))
  stopifnot(is.character(RPFs))
  stopifnot(is.numeric(readsLen))
  stopifnot(is.numeric(bestpsite))
  txdb <- prepareTxDb(gtf, 'gtf', ...)
  cds <- cdsBy(txdb, by = 'tx', use.names = TRUE)
  refSeq <- getSeq(genome, cds)
  refSeq <- vapply(refSeq, paste, FUN.VALUE=character(1L), collapse='')
  res <- lapply(RPFs, function(f){
    bamfile <- BamFile(file = f, yieldSize = yieldSize)
    pc <- getPsiteCoordinates(
      bamfile, bestpsite=bestpsite,
      anchor = anchor,
      param = ScanBamParam(what=c("qwidth", "seq"),
                           tag=character(0),
                           flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                            isUnmappedQuery = FALSE,
                                            isNotPassingQualityControls = FALSE,
                                            isSupplementaryAlignment = FALSE)))
    if(removeDuplicates){
      pc <- pc[!duplicated(paste(seqnames(pc), start(pc), pc$qwidth))]
    }
    pc <- pc[pc$qwidth %in% readsLen]
    pc <- shiftReadsByFrame(pc, txdb,
                                ignore.seqlevelsStyle=ignore.seqlevelsStyle)
    pc <- pc[!is.na(pc$tx_name)]
    if(anchor=="5end"){
      ## -3 is docking position, smaller than that should not be ready
      pc <- pc[pc$posToStop>=0 & pc$position + pc$Psite>=-3]
    }else{
      ## P site is stop coden, the transcripts is leaving
      pc <- pc[pc$position>=0 & pc$posToStop + 3 >= pc$Psite]
    }
    
    #the sequence in bam file should be the raw reads, no need to do reverseComplement.
    pc$char <- substring(pc$seq, ifelse(pc$Psite>pc$position, pc$Psite-pc$position, 1))
    pcs <- ifelse(pc$Psite>pc$position, 0, pc$position-pc$Psite+1)
    pc$ref <- substr(refSeq[pc$tx_name],
                     pcs+1,  pcs + nchar(pc$char))
    pc$char <- substr(pc$char, 1, nchar(pc$ref))
    
    ## position, relative position from start codon
    ## posToStop, relative position from stop codon
    seqStart <- pc$position %% 3
    seqWidth <- pc$qwidth - seqStart
    seqWidth <- seqWidth - (seqWidth %% 3)
    
    pc$char <- substr(pc$char, seqStart+1, seqStart + seqWidth)
    pc$ref <- substr(pc$ref, seqStart+1, seqStart + seqWidth)

    seqCodonUsage <- trinucleotideFrequency(DNAStringSet(pc$char), step = 3)
    refCodonUsage <- trinucleotideFrequency(DNAStringSet(pc$ref), step = 3)
    if(summary){
      ## remove the PCR duplicates or not?
      seqCodonUsage <- colSums(seqCodonUsage)
      refCodonUsage <- colSums(refCodonUsage)
      return(data.frame(reads=seqCodonUsage, reference=refCodonUsage))
    }else{
      codonUsage <- paste(seqCodonUsage, refCodonUsage, sep=',')
      dim(codonUsage) <- dim(seqCodonUsage)
      mcols(pc) <- cbind(mcols(pc), codonUsage)
      return(pc)
    }
  })
  names(res) <- basename(RPFs)
  if(summary){
    reshapeData <- function(res, column){
      dat <- do.call(cbind, lapply(res, function(.ele) .ele[, column]))
      rn <- rownames(res[[1]]) 
      dat <- cbind(codon = rn,
                   AAcodon = GENETIC_CODE[rn],
                   Abbreviation = AMINO_ACID_CODE[GENETIC_CODE[rn]],
                   data.frame(dat))
      dat
    }
    reads <- reshapeData(res, 'reads')
    reference <- reshapeData(res, 'reference')
    res <- list(reads=reads, reference=reference)
  }
  res
}

#' Plot reads distribution in genomic elements
#' @description Plot the percentage of reads in CDS, 5'UTR, 3'UTR, introns, and
#'  other elements.
#' @param reads Output of \link{getPsiteCoordinates}
#' @param txdb A TxDb object
#' @param upstreamRegion,downstreamRegion The range for promoter region and
#'  downstream region.
#' @param plot Plot the distribution or not
#' @param precedence If no precedence specified, double count will be enabled,
#' which means that if the reads overlap with both CDS and 5'UTR, both
#' CDS and 5'UTR will be incremented. If a precedence order is specified,
#' for example, if promoter is specified before 5'UTR, then only promoter will
#' be incremented for the same example.  The values could be any combinations
#' of "CDS", "UTR5", "UTR3", "OtherExon", "Intron", "upstream", "downstreama"
#' and "InterGenic", Default=NULL
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @param ... Not use.
#' @return The reads with distribution assignment
#' @importFrom GenomicFeatures cds fiveUTRsByTranscript threeUTRsByTranscript
#' exons genes promoters
#' @import GenomicRanges
#' @importFrom methods as is
#' @importFrom S4Vectors subjectHits queryHits
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' pc <- getPsiteCoordinates(bamfile, bestpsite=11)
#' pc.sub <- pc[pc$qwidth %in% c(29, 30)]
#' library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' txdb <- makeTxDbFromGFF(system.file("extdata",
#'           "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'           package="ribosomeProfilingQC"),
#'           organism = "Danio rerio",
#'           chrominfo = seqinfo(Drerio)["chr1"],
#'           taxonomyId = 7955)
#' pc.sub <- readsDistribution(pc.sub, txdb, las=2)
#' pc.sub <- readsDistribution(pc[pc$qwidth %in% c(29, 30)],
#'               txdb, las=2,
#'               precedence=c(
#'               "CDS", "UTR5", "UTR3", "OtherExon",
#'               "Intron", "upstream", "downstream",
#'               "InterGenic"
#'               ))

readsDistribution <- function(reads, txdb,
                              upstreamRegion=3000,
                              downstreamRegion=3000,
                              plot=TRUE,
                              precedence=NULL,
                              ignore.seqlevelsStyle=FALSE,
                              ...){
  stopifnot(is(txdb, "TxDb"))
  stopifnot(is(reads, "GRanges"))
  if(!is.null(precedence)){
    stopifnot(all(precedence %in% c("CDS", "UTR5", "UTR3", "OtherExon",
                                    "Intron", "upstream", "downstream",
                                    "InterGenic")))
  }
  
  reads <- fixSeqlevelsStyle(reads, txdb, ignore.seqlevelsStyle)
  cdss <- cds(txdb)
  utr5 <- unlist(fiveUTRsByTranscript(txdb))
  utr3 <- unlist(threeUTRsByTranscript(txdb))
  exons <- exons(txdb)
  anno <- GRangesList(CDS=cdss, UTR5=utr5, UTR3=utr3, OtherExon=exons)
  anno.ul <- unlist(anno)
  anno.ul$type <- rep(names(anno), lengths(anno))
  anno.dis <- disjoin(anno.ul, with.revmap=TRUE)
  anno.dis <- anno.dis[lengths(anno.dis$revmap)==1]
  anno.dis$revmap <- NULL
  anno$OtherExon <- anno.dis
  type <- lapply(anno, function(.ele){
    ol <- findOverlaps(reads, .ele, ignore.strand=FALSE)
    seq_along(reads) %in% queryHits(ol)
  })
  genes <- genes(txdb)
  ol <- findOverlaps(reads, genes, ignore.strand=FALSE)
  type <- do.call(cbind, type)
  notInExon <- rowSums(type) == 0
  Intron <- seq_along(reads) %in% queryHits(ol) & notInExon
  Promoters <- promoters(genes, upstream = upstreamRegion, downstream = 0)
  ol <- findOverlaps(reads, Promoters, ignore.strand=FALSE)
  upstream <- seq_along(reads) %in% queryHits(ol) & notInExon
  Downstreams <- promoters(switch.strand(genes),
                           upstream = downstreamRegion,
                           downstream = 0)
  Downstreams <- switch.strand(Downstreams)
  ol <- findOverlaps(reads, Downstreams, ignore.strand=FALSE)
  downstream <- seq_along(reads) %in% queryHits(ol) & notInExon
  type <- cbind(type, Intron)
  InterGenic <- rowSums(type) == 0
  type0 <- type <- cbind(type, upstream, downstream, InterGenic)
  if(!is.null(precedence) && all(precedence %in% colnames(type))){
    cn0 <- colnames(type)
    type0 <- type0[, c(precedence, cn0[!cn0 %in% precedence])]
    for(i in seq_along(cn0)[-1]){
      type0[, i] <- type0[, i] & rowSums(type[, seq.int(i-1), drop=FALSE]) == 0
    }
  }
  per <- 100*colSums(type0)/length(reads)
  if(plot) {
    ggBar(per, ylab="percentage (%)", postfix = "%", xlab="")
  }
  mcols(reads) <- cbind(mcols(reads), type0)
  return(reads)
}

#' Get FPKM values for counts
#' @description Calculate Fragments Per Kilobase of transcript per
#' Million mapped reads (FPKM) for counts.
#' @param counts Output of \link{countReads} or \link{normByRUVs}
#' @param gtf GTF file name for annotation.
#' @param level Transcript or gene level.
#' @return A list with FPKMs
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' #RPFs <- dir(path, "RPF.*?.[12].bam$", full.names=TRUE)
#' #RNAs <- dir(path, "mRNA.*?.[12].bam$", full.names=TRUE)
#' #gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' #cnts <- countReads(RPFs, RNAs, gtf, level="gene")
#' cnts <- readRDS(file.path(path, "cnts.rds"))
#' fpkm <- getFPKM(cnts)
getFPKM <- function(counts, gtf, level=c("gene", "tx")){
  if(!is.list(counts)){
    stop("counts must be output of countReads or normByRUVs")
  }
  if(!all(c("RPFs", "mRNA") %in% names(counts))){
    stop("counts must be output of countReads or normByRUVs")
  }
  if(!"annotation" %in% names(counts)){
    annotation <- getFeatureLen(gtf, level)
  }else{
    annotation <- counts$annotation
  }
  FPKM <- function(cnt, annotation){
    total <- colSums(cnt)
    len <- annotation[match(rownames(cnt), annotation$GeneID), "Length"]
    t(t(cnt)/total)/len*10e9
  }
  fpkm <- list()
  if("RPFs" %in% names(counts)){
    fpkm[["RPFs"]] <- FPKM(counts$RPFs, annotation)
    if(is.null(fpkm$RPFsRawCounts)) fpkm[["RPFsRawCounts"]]=counts$RPFs
  }
  if("mRNA" %in% names(counts)){
    fpkm[["mRNA"]] <- FPKM(counts$mRNA, annotation)
    if(is.null(fpkm$mRNARawCounts)) fpkm[["mRNARawCounts"]]=counts$mRNA
  }
  if(all(c("RPFs", "mRNA") %in% names(fpkm))){
    if(!identical(rownames(fpkm[["RPFs"]]), rownames(fpkm[["RPFs"]]))){
      ids <- intersect(rownames(fpkm[["RPFs"]]), rownames(fpkm[["mRNA"]]))
      fpkm[["RPFs"]] <- 
        fpkm[["RPFs"]][match(ids, rownames(fpkm[["RPFs"]])), , drop=FALSE]
      fpkm[["mRNA"]] <- 
        fpkm[["mRNA"]][match(ids, rownames(fpkm[["mRNA"]])), , drop=FALSE]
      fpkm[["RPFsRawCounts"]] <- 
        fpkm[["RPFsRawCounts"]][match(ids, rownames(fpkm[["RPFsRawCounts"]])), 
                                , drop=FALSE]
      fpkm[["mRNARawCounts"]] <- 
        fpkm[["mRNARawCounts"]][match(ids, rownames(fpkm[["mRNARawCounts"]])),
                                , drop=FALSE]
      fpkm[["RPFs"]][is.na(fpkm[["RPFs"]])] <- 0
      fpkm[["mRNA"]][is.na(fpkm[["mRNA"]])] <- 0
      fpkm[["RPFsRawCounts"]][is.na(fpkm[["RPFsRawCounts"]])] <- 0
      fpkm[["mRNARawCounts"]][is.na(fpkm[["mRNARawCounts"]])] <- 0
      fpkm[["annotation"]] <- 
        fpkm[["annotation"]][match(ids, fpkm[["annotation"]][, 1]), , 
                               drop=FALSE]
    }
  }
  fpkm
}

#' Filter CDS by size
#' @description Filter CDS by CDS size.
#' @param CDS Output of preparedCDS
#' @param sizeCutoff numeric(1). Cutoff size for CDS.
#' If the size of CDS is less than the cutoff, it will be filtered out.
#' @return A GRanges object with filtered CDS.
#' @export
#' @import GenomicRanges
#' @importFrom methods as is
#' @examples
#' #library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' #txdb <- makeTxDbFromGFF(system.file("extdata",
#'  #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'  #         package="ribosomeProfilingQC"),
#'  #         organism = "Danio rerio",
#'  #         chrominfo = seqinfo(Drerio)["chr1"],
#'  #         taxonomyId = 7955)
#' #CDS <- prepareCDS(txdb)
#' CDS <- readRDS(system.file("extdata", "CDS.rds",
#'                            package="ribosomeProfilingQC"))
#' filterCDS(CDS)
filterCDS <- function(CDS, sizeCutoff = 100L){
  sizeCutoff <- sizeCutoff[1]
  stopifnot(is.numeric(sizeCutoff))
  stopifnot(is(CDS, "GRanges"))
  if(length(CDS$internalPos)!=length(CDS) ||
     length(CDS$isLastExonInCDS)!=length(CDS) ||
     length(CDS$tx_name)!=length(CDS) ||
     length(CDS$gene_id)!=length(CDS)){
    stop("CDS must be output of prepareCDS")
  }
  keep <- unique(CDS[CDS$wid.cumsum>=sizeCutoff]$tx_name)
  CDS[CDS$tx_name %in% keep]
}

#' Metaplot of P site distribution
#' @description Metaplot of P site distribution in all the CDS aligned by
#' the start codon or stop codon.
#' @param reads Output of \link{assignReadingFrame} or \link{shiftReadsByFrame}.
#' @param genome A BSgenome object.
#' @param plot Plot the motif or not.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @return A \link[motifStack:pcm-class]{pcm} object
#' @importFrom IRanges promoters
#' @importFrom Rsamtools getSeq
#' @importFrom Biostrings consensusMatrix AA_STANDARD translate
#' @importClassesFrom motifStack pcm
#' @importFrom motifStack plotMotifLogo
#' @importFrom grid grid.draw grid.newpage
#' @export
#' @examples
#' pcs <- readRDS(system.file("extdata", "samplePc.rds",
#'                package="ribosomeProfilingQC"))
#' library(BSgenome.Drerio.UCSC.danRer10)
#' #PAmotif(pcs, Drerio)
#'
PAmotif <- function(reads, genome, plot=TRUE, ignore.seqlevelsStyle=FALSE){
  stopifnot(is(reads, "GRanges"))
  if(length(reads$tx_name)!=length(reads) ||
     length(reads$position)!=length(reads) ||
     length(reads$posToStop)!=length(reads) ||
     length(reads$readingFrame)!=length(reads) ||
     length(reads$gene_id)!=length(reads)){
    stop("reads must be a result of assignReadingFrame or shiftReadsByFrame")
  }
  stopifnot(inherits(genome, c("DNAStringSet", "BSgenome")))
  reads <- fixSeqlevelsStyle(reads, genome, ignore.seqlevelsStyle)
  reads <- promoters(reads, upstream = 6, downstream = 12)
  seq <- getSeq(genome, reads)
  seq <- translate(seq)
  mat <- consensusMatrix(seq, baseOnly=TRUE)
  pcm <- new("pcm", mat=mat[AA_STANDARD, ], name="PAsite motif")
  if(plot){
    p <- plotMotifLogo(pcm, draw = FALSE, ic.scale = FALSE, ylab = "percentage")
    child <- p[[1]]$children
    child[[which(grepl("xaxis", names(child)))]]$label <-
      c("-2", "-1", "P",  "A",  "1",  "2")
    child[[which(grepl("xaxis", names(child)))]]$children$labels$label <-
      c("-2", "-1", "P",  "A",  "1",  "2")
    p[[1]]$children <- child
    grid.newpage()
    grid.draw(p)
    return(invisible(pcm))
  }else{
    return(pcm)
  }
}

#' Estimate P site position
#' @description Estimate P site position from a subset reads.
#' @rdname estimatePsite
#' @param bamfile A BamFile object.
#' @param CDS Output of \link{prepareCDS}
#' @param genome A BSgenome object.
#' @param anchor 5end or 3end. Default is 5end.
#' @param readLen The reads length used to estimate.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @return A best P site position.
#' @references
#' 1: Bazzini AA, Johnstone TG, Christiano R, Mackowiak SD, Obermayer B,
#' Fleming ES, Vejnar CE, Lee MT, Rajewsky N, Walther TC, Giraldez AJ.
#' Identification of small ORFs in vertebrates using ribosome footprinting and
#' evolutionary conservation. EMBO J. 2014 May 2;33(9):981-93.
#' doi: 10.1002/embj.201488411. Epub 2014 Apr 4.
#' PubMed PMID: 24705786; PubMed Central PMCID: PMC4193932.
#' @import GenomicRanges
#' @importFrom BSgenome getSeq
#' @importFrom Rsamtools ScanBamParam scanBamFlag
#' @importFrom GenomicAlignments readGAlignments qwidth njunc narrow
#' @importFrom Biostrings vmatchPattern DNAStringSet
#' @importFrom BiocGenerics table
#' @importFrom methods as is
#' @importFrom XVector subseq
#' @importFrom IRanges subsetByOverlaps
#' @importClassesFrom Rsamtools BamFile
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' #library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' #txdb <- makeTxDbFromGFF(system.file("extdata",
#'  #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'  #         package="ribosomeProfilingQC"),
#'  #         organism = "Danio rerio",
#'  #         chrominfo = seqinfo(Drerio)["chr1"],
#'  #         taxonomyId = 7955)
#' #CDS <- prepareCDS(txdb)
#' CDS <- readRDS(system.file("extdata", "CDS.rds",
#'                            package="ribosomeProfilingQC"))
#' estimatePsite(bamfile, CDS, Drerio)
#'

estimatePsite <- function(bamfile, CDS, genome, anchor='5end',
                          readLen=c(25:30), ignore.seqlevelsStyle=FALSE){
  stopifnot(is(bamfile, "BamFile"))
  anchor <- match.arg(anchor, choices = c("5end", "3end"))
  stopifnot(is(CDS, "GRanges"))
  if(length(CDS$internalPos)!=length(CDS) ||
     length(CDS$isLastExonInCDS)!=length(CDS) ||
     length(CDS$tx_name)!=length(CDS) ||
     length(CDS$gene_id)!=length(CDS)){
    stop("CDS must be output of prepareCDS")
  }
  stopifnot(inherits(genome, c("DNAStringSet", "BSgenome")))
  param <-
    ScanBamParam(what=c("qwidth"),
                 tag=character(0),
                 flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                  isUnmappedQuery=FALSE,
                                  isNotPassingQualityControls = FALSE,
                                  isSupplementaryAlignment = FALSE))

  open(bamfile)
  reads <- readGAlignments(bamfile, param = param)
  close(bamfile)
  
  reads <- reads[njunc(reads)==0] ## remove junctions
  reads <- narrow(reads) ## remove the soft and hard clips
  reads <- reads[qwidth(reads) %in% readLen]
  x <- as(reads, "GRanges")
  x <- fixSeqlevelsStyle(x, CDS, ignore.seqlevelsStyle)
  if(anchor=="3end"){
    x <- switch.strand(x)
    x <- promoters(x, upstream = 0, downstream = 1)
    x <- switch.strand(x)
  }
  x <- assignReadingFrame(promoters(x, upstream = 0, downstream = 1),
                          CDS,
                          ignore.seqlevelsStyle=ignore.seqlevelsStyle)
  x <- table(x$readingFrame)
  x <- names(x)[which.max(x)]
  posMap <- list('5end'=c("0"=13, "1"=12, "2"=14),
                 '3end'=c("0"=-16, "1"=-17, "2"=-15))
  x <- posMap[[anchor]][x]
  as.numeric(x)
}

#' Normalization by edgeR, DESeq2 or RUVSeq
#' @description Normalization by multiple known methods
#' @param counts Output of \link{countReads}
#' @param method Character(1L) to indicate the method for normalization.
#' @param ... parameters will be passed to \link{normByRUVs} or \link{getFPKM}
#' @return Normalized counts list
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' cnts <- readRDS(file.path(path, "cnts.rds"))
#' norm <- normBy(cnts, method = 'edgeR')
#' norm2 <- normBy(cnts, method = 'DESeq2')
#' norm3 <- normBy(cnts, 'vsn')
normBy <- function(counts, method = c('edgeR', 'DESeq2', 'RUVs', 'fpkm', 'vsn'),
                   ...){
  if(!any(c("RPFs", "mRNA") %in% names(counts))){
    stop("counts must be output of coutReads.")
  }
  method <- match.arg(method)
  counts <- switch(method,
         edgeR = normByDETools(counts, FUN=edgeRnormHelper),
         DESeq2 = normByDETools(counts, FUN=DESeq2normHelper),
         RUVs = normByRUVs(counts, ...),
         fpkm = getFPKM(counts, ...),
         vsn = normByDETools(counts, FUN=vsnNormHelper))
  counts
}

normByDETools <- function(counts, FUN){
  stopifnot(is.function(FUN))
  if(all(c("RPFs", 'mRNA') %in% names(counts))){
    if("RPFsRawCounts" %in% names(counts)){
      counts$RPFs <- counts$RPFsRawCounts
    }else{
      counts$RPFsRawCounts <- counts$RPFs
    }
    if("mRNARawCounts" %in% names(counts)){
      counts$mRNA <- counts$mRNARawCounts
    }else{
      counts$mRNARawCounts <- counts$mRNA
    }
    x <- cbind(counts$RPFs, counts$mRNA)
    colnames(x) <- rep(c('RPFs', 'mRNA'), each=4)
    x <- FUN(x)
    RPFs <- x[, seq.int(ncol(counts$RPFs))]
    colnames(RPFs) <- colnames(counts$RPFs)
    counts$RPFs <- RPFs
    mRNA <- x[, -seq.int(ncol(counts$RPFs))]
    colnames(mRNA) <- colnames(counts$mRNA)
    counts$mRNA <- mRNA
    return(counts)
  }
  if("RPFsRawCounts" %in% names(counts)){
    counts$RPFs <- FUN(counts$RPFsRawCounts)
  }else{
    if("mRNA" %in% names(counts)){
      counts$mRNARawCounts <- counts$mRNA
      counts$mRNA <- FUN(counts$mRNA)
    }
  }
  
  if("RPFsRawCounts" %in% names(counts)){
    counts$RPFs <- FUN(counts$RPFsRawCounts)
  }else{
    if("mRNA" %in% names(counts)){
      counts$mRNARawCounts <- counts$mRNA
      counts$mRNA <- FUN(counts$mRNA)
    }
  }
  counts
}

edgeRnormHelper <- function(x){
  if (!requireNamespace("edgeR", quietly=TRUE)) {
    stop("method='edgeR' requires installing the CRAN package 'edgeR'")
  }
  y <- edgeR::DGEList(counts=x)
  y <- edgeR::normLibSizes(y)
  cpm <- edgeR::cpm(y, log = TRUE)
  return(cpm)
}

DESeq2normHelper <- function(x){
  if (!requireNamespace("DESeq2", quietly=TRUE)) {
    stop("method='DESeq2' requires installing the CRAN package 'DESeq2'")
  }
  cd <- data.frame(sample=factor(colnames(x)))
  design <- as.formula('~sample')
  dds <- DESeq2::DESeqDataSetFromMatrix(countData=x,
                                        colData = cd,
                                        design = design)
  dds <- DESeq2::estimateSizeFactors(dds)
  cnt <- DESeq2::counts(dds, normalized=TRUE)
  return(cnt)
}

vsnNormHelper <- function(x){
  if (!requireNamespace("vsn", quietly=TRUE)) {
    stop("method='vsn' requires installing the CRAN package 'vsn'")
  }
  suppressMessages(Biobase::exprs(vsn::vsn2(x)))
}

#' Plot start/stop windows
#' @description Plot the reads shifted from start/stop position of CDS.
#' @param bamfile A BamFile object.
#' @param CDS Output of \link{prepareCDS}
#' @param toStartCodon What to search: start or end codon
#' @param fiveEnd Search from five or three ends of the reads.
#' @param shift number(1). Search from 5' end or 3' end of given number.
#' if fiveEnd set to false, please set the shift as a negative number.
#' @param window The window of CDS region to plot
#' @param readLen The reads length used to plot
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @return The invisible list with counts numbers and reads in GRanges.
#' @importFrom Rsamtools ScanBamParam scanBamFlag scanBamHeader
#' @importFrom GenomicAlignments readGAlignments qwidth njunc
#' @importFrom methods as is
#' @importFrom graphics barplot abline
#' @importFrom IRanges Views viewApply
#' @importFrom S4Vectors metadata `metadata<-`
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' #library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' #txdb <- makeTxDbFromGFF(system.file("extdata",
#'  #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'  #         package="ribosomeProfilingQC"),
#'  #         organism = "Danio rerio",
#'  #         chrominfo = seqinfo(Drerio)["chr1"],
#'  #         taxonomyId = 7955)
#' #CDS <- prepareCDS(txdb)
#' CDS <- readRDS(system.file("extdata", "CDS.rds",
#'                            package="ribosomeProfilingQC"))
#' re <- readsEndPlot(bamfile, CDS, toStartCodon=TRUE)
#' readsEndPlot(re$reads, CDS, toStartCodon=TRUE, fiveEnd=FALSE)
#' #re <- readsEndPlot(bamfile, CDS, toStartCodon=FALSE)
#' #readsEndPlot(re$reads, CDS, toStartCodon=FALSE, fiveEnd=FALSE)
#' readsEndPlot(bamfile, CDS, shift=13)
#' #readsEndPlot(bamfile, CDS, fiveEnd=FALSE, shift=-16)
readsEndPlot <- function(bamfile, CDS, toStartCodon=TRUE,
                         fiveEnd=TRUE, shift=0, window=c(-29, 30),
                         readLen=25:30, ignore.seqlevelsStyle=FALSE){
  stopifnot(is(fiveEnd, "logical"))
  stopifnot(is(shift, "numeric"))
  stopifnot(is(window, "numeric"))
  stopifnot(is(readLen, "numeric"))
  stopifnot(is(CDS, "GRanges"))
  if(length(CDS$internalPos)!=length(CDS) ||
     length(CDS$isFirstExonInCDS)!=length(CDS) ||
     length(CDS$isLastExonInCDS)!=length(CDS) ||
     length(CDS$tx_name)!=length(CDS) ||
     length(CDS$gene_id)!=length(CDS)){
    stop("CDS must be output of prepareCDS")
  }
  
  stopifnot(inherits(bamfile, c("BamFile", "GRanges")))
  argg <- as.list(match.call())
  argg$fiveEnd <- NULL
  if(is(bamfile, "GRanges")){
    metadata <- metadata(bamfile)
    which <- metadata$which
    metadata$which <- NULL
    argg$bamfile <- metadata$bamfile
    if(!identical(argg, metadata)){
      stop("The reads are not ready for current parameter set. ",
           "Please try the BamFile again.")
    }
    reads <- bamfile
  }else{
    if(toStartCodon){
      CDS <- CDS[CDS$isFirstExonInCDS]
      which <- promoters(CDS, upstream=abs(window)[1],
                         downstream=abs(window)[2])
    }else{
      CDS <- CDS[CDS$isLastExonInCDS]
      CDS <- switch.strand(CDS)
      which <- promoters(CDS, upstream=abs(window)[1],
                         downstream=abs(window)[2])
      which <- switch.strand(which)
    }
    
    h <- scanBamHeader(bamfile)
    seqs <- h$targets
    which <- fixSeqlevelsStyle(which, names(seqs), ignore.seqlevelsStyle)
    which <- which[as.character(seqnames(which)) %in% names(seqs)]
    seqlevels(which) <-
      seqlevels(which)[seqlevels(which) %in% names(seqs)]
    param <-
      ScanBamParam(what=c("qwidth"),
                   tag=character(0),
                   flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                    isUnmappedQuery=FALSE,
                                    isNotPassingQualityControls = FALSE,
                                    isSupplementaryAlignment = FALSE),
                   which = which
      )
    
    open(bamfile)
    on.exit(close(bamfile))
    reads <- readGAlignments(bamfile, param = param)
    close(bamfile)
    on.exit()
    
    reads <- reads[njunc(reads)==0]
    reads <- narrow(reads) ## remove the soft and hard clips
    reads <- reads[qwidth(reads) %in% readLen]
    reads <- as(reads, "GRanges")
    reads <- fixSeqlevelsStyle(reads, CDS, ignore.seqlevelsStyle)
    which <- fixSeqlevelsStyle(which, CDS, ignore.seqlevelsStyle)
    argg$which <- which
    metadata(reads) <- argg
  }
  
  if(fiveEnd[1]){
    x <- promoters(reads, upstream = 0, downstream = 1)
    if(shift[1] != 0){
      x <- shift(x, shift = shift[1]-1)
    }
  }else{
    x <- switch.strand(reads)
    x <- promoters(x, upstream = 0, downstream = 1)
    x <- switch.strand(x)
    if(shift[1] != 0){
      x <- shift(x, shift = shift[1]+1)
    }
  }
  x <- split(x, strand(x))
  which <- split(which, strand(which))
  heights <- mapply(x, which[names(x)], names(x),
                    FUN=function(.x, .which, .n){
    if(length(.x)==0){
      return(NULL)
    }
    cvg <- coverage(.x)
    w <- split(.which, seqnames(.which))
    cvg.sub <- unlist(lapply(cvg, sum))
    cvg <- cvg[cvg.sub>0]
    seq <- intersect(names(cvg), names(w))
    vws <- Views(cvg[seq], w[seq])
    vws <- lapply(vws, function(.ele) {
      viewApply(.ele[width(.ele)==sum(abs(window)[c(1, 2)])], as.numeric)
    })
    vws <- do.call(cbind, vws)
    at <- seq(-abs(window[1]), abs(window[2]))
    at <- at[at!=0]
    if(.n=='-'){
      at <- rev(at)
    }
    if(length(dim(vws))!=2){
      stop("Not enough data available.")
    }
    height <- rowSums(vws)
    names(height) <- at
    height[order(at)]
  })
  heights <- do.call(cbind, heights)
  heights <- rowSums(heights)
  at <- as.numeric(names(heights))
  barplot(heights, las=3, space = .5, ylab = "counts",
          xlab = paste("distance from", ifelse(fiveEnd, "5'", "3'"),
                       "of reads to",
                       ifelse(toStartCodon, "start", "stop"),
                       "codon"))
  at1 <- which(at==-1)
  abline(v=at1*1.5+.25, lty=4)
  at <- seq((at1 %% 3), to = length(at), by = 3)
  at <- at[at!=at1]
  at <- at * 1.5 + .25
  ymax <- max(heights)
  segments(x0 = at, y0 = 0, x1 = at, y1 = ymax * .9,
           lty = 3, col = "gray80")
  return(invisible(list(reads=reads, heights=heights)))
}

#' Simulation function
#' @description Simulate the RPFs reads in CDS, 5'UTR and 3'UTR
#' @param txdb A TxDb object
#' @param outPath Output folder for the bam files
#' @param genome A BSgenome object
#' @param samples Total samples to simulate.
#' @param group1,group2 Numeric to index the sample groups.
#' @param readsPerSample Total reads number per sample.
#' @param readsLen Reads length, default 100bp.
#' @param psite P-site position. default 13.
#' @param frame0,frame1,frame2 Percentage of reads distribution in
#' frame0, frame1 and frame2
#' @param DEregions The regions with differential reads in exon,
#' utr5 and utr3.
#' @param size Dispersion parameter. Must be strictly positive.
#' @param sd Standard deviations.
#' @param minDElevel Minimal differential level. default: log2(2).
#' @param includeReadsSeq logical(1). Include reads sequence or not.
#' @return An invisible list of GAlignments.
#' @importFrom rtracklayer export
#' @importFrom GenomicAlignments sequenceLayer cigar GAlignments
#' @importFrom BSgenome getSeq
#' @importFrom S4Vectors runLength
#' @importFrom stats rnbinom rnorm runif
#' @importFrom Biostrings DNAStringSet reverseComplement
#' @importFrom Seqinfo seqlengths `seqlengths<-`
#' @export
#' @examples
#' library(GenomicFeatures)
#' txdb_file <- system.file("extdata", "Biomart_Ensembl_sample.sqlite",
#'                          package="GenomicFeatures")
#' txdb <- loadDb(txdb_file)
#' simulateRPF(txdb, samples=1, readsPerSample = 1e3)
#' \dontrun{
#' cds <- prepareCDS(txdb, withUTR = TRUE)
#' cds <- cds[width(cds)>200]
#' DEregions <- cds[sample(seq_along(cds), 10)]
#' simulateRPF(txdb, samples=6, readsPerSample = 1e5, DEregions=DEregions)
#' }

simulateRPF <- function(txdb, outPath, genome, samples = 6,
                        group1 = c(1, 2, 3), group2 = c(4, 5, 6),
                        readsPerSample = 1e6, readsLen = 28,
                        psite = 13,
                        frame0=.90, frame1=.05, frame2=.05,
                        DEregions=GRanges(),
                        size = 1, sd = .02, minDElevel=log2(2),
                        includeReadsSeq = FALSE){
  cds <- prepareCDS(txdb, withUTR = TRUE)
  stopifnot(sum(c(frame0, frame1, frame2))==1)
  stopifnot(psite<readsLen)
  stopifnot(size>0)
  mis_genome <- missing(genome)
  if(!mis_genome) stopifnot(inherits(genome, c("DNAStringSet", "BSgenome")))
  stopifnot(is(DEregions, "GRanges"))
  ol_DE <- findOverlaps(DEregions, cds, type = "within")
  if(any(!seq_along(DEregions) %in% queryHits(ol_DE))){
    stop('Not all DEregions within exon regions.')
  }
  if(is.numeric(samples)){
    samples <- paste0("sample", seq.int(samples[1]))
  }
  stopifnot(is(group1, "numeric"))
  stopifnot(is(group2, "numeric"))
  if(length(DEregions)>0){
    stopifnot(length(group1)==length(group2))
    if(any(!group1 %in% seq_along(samples)) ||
       any(!group2 %in% seq_along(samples))){
      stop("index of group1 and group2 must within sample numbers.")
    }
    if(!all(seq_along(samples) %in% c(group1, group2))){
      stop("index of group1 and group2 must cover all samples.")
    }
  }
  ## set reads in CDS
  CDS <- cds[cds$feature=="CDS"]
  ## get all cds cumsum
  CDS.length <- CDS$wid.cumsum[CDS$isLastExonInCDS]
  names(CDS.length) <- CDS$tx_name[CDS$isLastExonInCDS]
  ## check all cds length mod by 3
  check_CDS <- (CDS.length %% 3) != 0
  if(any(check_CDS)){
    warning("There are ", sum(check_CDS), "(",
            round(100*(sum(check_CDS)/length(check_CDS)), 2), "%) ",
            "not mudulo3 CDSs (which length can not by divided by 3):",
            paste(names(CDS.length)[check_CDS], collapse = ", "))
  }
  CDS.length.3 <- CDS.length %/% 3
  ### utr5 and utr3
  u5 <- cds[cds$isFirstExonInTx & !cds$isFirstExonInCDS]
  u5Len <- rep(0, length(unique(cds$tx_name)))
  names(u5Len) <- unique(cds$tx_name)
  u5Len[u5$tx_name] <- abs(u5$wid.cumsum)
  fullLen <- split(cds, cds$tx_name)
  fullLen <- lapply(fullLen, function(.ele) sum(width(.ele)))
  fullLen <- unlist(fullLen)
  fullLen <- fullLen - readsLen

  ## random model, negative binomial distribution
  n <- length(CDS.length.3)
  x <- rnbinom(n, mu=readsPerSample/n, size = size)
  ## normal distribution for samples
  y <- lapply(x, function(mu)
    round(rnorm(n=length(samples), mean = mu, sd=sd*mu)))

  ## assign position
  p <- mapply(CDS.length.3, y,
              u5Len[names(CDS.length.3)],
              fullLen[names(CDS.length.3)],
              FUN = function(m, n, ups, dws){
    lapply(n, function(.n){
      ## if there is no utr5, it should leave the space for p0 to psite
      .min <- max(0, ceiling((psite-1-ups)/3))
      ## if there is no utr3, it should leave the space from psite to end
      .max <- min(m-1, max(1, floor((dws+psite-1-ups)/3)))
      if(.min>.max) return(NULL)
      3*round(runif(n=.n,
                    min=.min,
                    max=.max))
    })
  }, SIMPLIFY = FALSE)


  ## swap list by sample in level 1
  p <- lapply(seq_along(samples), function(i){
    lapply(p, function(.ele) .ele[[i]])
  })
  names(p) <- samples
  ## sample for frame0, 1, 2
  ## and then thift to p0
  p <- lapply(p, function(.sample){
    pos <- GRanges(rep(names(.sample), lengths(.sample)),
                       IRanges(unlist(.sample), width = 1))
    offset <- sample(x = c(0, 1, 2),
                     size = length(pos),
                     replace = TRUE,
                     prob = c(frame0, frame1, frame2))
    pos <- shift(pos, shift = offset-psite+1)
  })

  real_de_evt <- NULL
  if(length(samples)>1){
    cds_de <- cds[subjectHits(ol_DE)]
    cds_de <- split(cds_de, cds_de$feature)
    ## add de 5'UTR and 3'UTRs
    ## sample the reads from CDS region and shift it into
    ## 5'UTR or 3'UTR for up group
    ## all psite is in CDS now
    ## 1. get the length of 5'UTR and 3'UTR > readsLen
    ## 2. split it into two group up and down
    ## 3. get total reads for each txs,
    ##    and reditribute the reads in 5'UTR (or 3'UTR) + CDS
    if(length(cds_de$UTR3)>0 || length(cds_de$UTR5)>0){
      de_evt <- c(cds_de$UTR3, cds_de$UTR5)
      execpt <- width(de_evt)< readsLen
      if(any(execpt)){
        message("There are ", sum(execpt),
                " DE UTRs width smaller than readsLen.")
      }
      de_evt <- de_evt[!execpt]
      pp <- unlist(GRangesList(p))
      pp$group <- rep(names(p), lengths(p))
      tx_avg_exp <- lengths(split(pp, seqnames(pp)))
      tx_avg_full <- tx_avg_exp/fullLen[names(tx_avg_exp)]
      de_times <- sign(rnorm(length(de_evt), sd = sd)) *
        (rnbinom(length(de_evt), size=size, prob = .5) + minDElevel) +
        rnorm(length(de_evt), sd = sd)
      de_evt$score <- de_times
      real_de_evt <- de_evt
      ## low value
      de_aliq <- abs(de_times) + 1
      de_aliq <- tx_avg_full[de_evt$tx_name]*width(de_evt)/de_aliq
      ## high value
      de_high <- de_aliq * abs(de_times)
      de_to_move <- round(de_aliq + de_high)
      de_aliq <- round(de_aliq)
      de_high <- de_to_move - de_aliq
      ## sample which one to move
      pp <- pp[order(seqnames(pp))]
      pp$id <- paste(as.character(seqnames(pp)),
                     unlist(lapply(runLength(seqnames(pp)), seq.int)))
      de_to_mv_id <- mapply(tx_avg_exp[de_evt$tx_name], de_to_move,
                            FUN=function(n, size){
                              sample.int(n, size)
                            }, SIMPLIFY = FALSE)
      de_to_mv_id <- paste(rep(de_evt$tx_name, de_to_move),
                           unlist(de_to_mv_id))
      ## reasign group
      de_to_mv_gp <- mapply(de_high, de_aliq, de_to_move, sign(de_times),
                            FUN=function(a, b, c, d){
                              x <- samples[c(group2, group1)]
                              if(d<0) x <- samples[c(group1, group2)]
                              sample(x, size=c, replace=TRUE,
                                     prob=rep(c(a, b), each=length(group1)))
                            }, SIMPLIFY = FALSE)
      de_to_mv_gp <- unlist(de_to_mv_gp)
      pp[match(de_to_mv_id, pp$id)]$group <- de_to_mv_gp
      ## move to where?
      ## 3'UTR: internalPos + width
      ## 5'UTR: internalPos - width
      de_to_mv_pos <- mapply(de_to_move,
                             de_evt$internalPos,
                             width(de_evt),
                             de_evt$isLastExonInTx,
                             de_evt$isFirstExonInTx,
                             de_evt$feature,
                             FUN = function(n, m, w, isLast, isFirst, feature){
                               if(isLast) w <- w - readsLen + psite
                               s <- sample.int(w, size = n, replace = TRUE)
                               if(feature=="UTR3"){
                                 return(m + s)
                               }else{
                                 return(m - s)
                               }
                             }, SIMPLIFY = FALSE)
      de_to_mv_pos <- unlist(de_to_mv_pos)
      ranges(pp[match(de_to_mv_id, pp$id)]) <- IRanges(de_to_mv_pos, width = 1)
      gp <- pp$group
      mcols(pp) <- NULL
      pp <- unname(pp)
      p <- split(pp, gp)
    }
    ## add de exons
    ## move the reads from down group to up group
    if(length(cds_de$CDS)>0){
      de_evt <- cds_de$CDS
      de_evt_rg <- GRanges(de_evt$tx_name,
                           IRanges(de_evt$internalPos+1, de_evt$wid.cumsum))
      pp <- unlist(GRangesList(p))
      pp$group <- rep(names(p), lengths(p))
      pp$gp <- pp$group %in% samples[group1]
      pp$id <- seq_along(pp)
      de_evt_ol <- suppressWarnings(findOverlaps(de_evt_rg, pp))
      execpt <- !seq_along(de_evt_rg) %in% queryHits(de_evt_ol)
      if(any(execpt)){
        message("There are ", sum(execpt),
                " DE GRanges does not contain any simulated reads.")
      }
      de_evt <- de_evt[!execpt]
      de_evt_rg <- de_evt_rg[!execpt]
      de_cnt <- suppressWarnings(countOverlaps(de_evt_rg, pp)/2)
      de_times <- sign(rnorm(length(de_cnt), sd = sd)) *
        (rnbinom(length(de_cnt), size=size, prob = .5) + minDElevel) +
        rnorm(length(de_cnt), sd = sd)
      de_evt$score <- de_times
      de_aliq <- abs(de_times) + 1
      de_aliq <- 2*de_cnt/de_aliq
      de_to_move <- round((de_aliq*abs(de_times)-de_cnt)*sign(de_times))
      de_evt_ol <- suppressWarnings(findOverlaps(de_evt_rg, pp))
      ## split the all reads in the event and
      ## to be moved reads to by de_evt index
      de_evt_reads <- split(pp[subjectHits(de_evt_ol)], queryHits(de_evt_ol))
      de_to_move <- de_to_move[as.numeric(names(de_evt_reads))]
      notsig <- abs(de_to_move) > lengths(de_evt_reads) | de_to_move == 0
      if(any(notsig)){
        message("There are ", sum(notsig),
                " DE GRanges does not contain enough
                simulated reads to show difference.")
      }
      renameM <- samples[c(group1, group2)]
      names(renameM) <- samples[c(group2, group1)]
      de_evt_reads <- de_evt_reads[!notsig]
      real_de_evt <- c(real_de_evt, de_evt[!notsig])
      de_evt_reads <- mapply(de_to_move[!notsig], de_evt_reads,
                             FUN=function(.n, .reads){
                               .size <- abs(.n)
                               x <- seq_along(.reads)
                               x <- if(sign(.n)>0){
                                 x[!.reads$gp]
                               }else{
                                 x[.reads$gp]
                               }
                               if(length(x)>0){
                                 .id <- sample(x = x, size = .size,
                                               replace = TRUE)
                                 .id <- unique(.id)
                                 .reads$group[.id] <- renameM[.reads$group[.id]]
                               }
                               .reads
                             })
      de_evt_reads <- unlist(GRangesList(de_evt_reads))
      pp[match(de_evt_reads$id, pp$id)]$group <- de_evt_reads$group
      gp <- pp$group
      mcols(pp) <- NULL
      pp <- unname(pp)
      p <- split(pp, gp)
    }
  }


  ## add 5'UTR and 3'UTR info
  p <- lapply(p, function(.sample){
    .sample <- shift(.sample, shift = u5Len[as.character(seqnames(.sample))])
    start(.sample)[start(.sample)<0] <- 0 ## no need, but keep
    ## shift 1, why not move to assign position step?
    .sample <- shift(.sample, shift = 1)
    .sample[start(.sample)>fullLen[as.character(seqnames(.sample))]] <-
      shift(.sample[start(.sample)>fullLen[as.character(seqnames(.sample))]],
            shift = -3)
    start(.sample[start(.sample)>fullLen[as.character(seqnames(.sample))]]) <-
      fullLen[as.character(seqnames(.sample))[## no need, but keep
        start(.sample)>fullLen[as.character(seqnames(.sample))]]]
    .sample
  })

  #relative2realLoc
  cds.wid.cumsum <- cumsum(width(cds))
  cds$w_cumsum <- cds.wid.cumsum - c(0, cds.wid.cumsum)[cds$idFirstExonInTx]
  cds$i_cumsum <- 0
  cds$i_cumsum[!cds$isFirstExonInTx] <- cds$w_cumsum[!cds$isLastExonInTx]
  cds$i_id <- seq_along(cds)
  cds_rel <- GRanges(cds$tx_name, IRanges(cds$i_cumsum+1, cds$w_cumsum))

  gl <- lapply(p, function(.sample){
    ## convert p to real genomic locations
    getPosInReal <- function(.re){
      ol <- findOverlaps(.re, cds_rel)
      stopifnot(all(queryHits(ol)==seq_along(.re)))
      .pos <- cds[subjectHits(ol)]
      .shift <- start(.re[queryHits(ol)]) - .pos$i_cumsum - 1
      .pos <- promoters(.pos, upstream = 0, downstream = 1)
      .pos <- shift(.pos,
                    shift = ifelse(as.character(strand(.pos))=="-",
                                   -1*.shift,
                                   .shift))
    }
    pos_start <- getPosInReal(.sample)
    pos_stop <- getPosInReal(shift(.sample, shift = readsLen-1))
    ## prepare cigar
    ## most reads only in exon: M28
    ## reads in multple exons: MxNyMz...
    ## i_id_range is the start and end position or the reads
    sw <- start(pos_start)>start(pos_stop)
    st <- ifelse(sw, start(pos_stop), start(pos_start))
    se <- ifelse(sw, start(pos_start), start(pos_stop))
    i_id_range <- rbind(st, se)
    stopifnot(all(i_id_range[1, ] < i_id_range[2, ]))
    i_mult_id <- pos_start$i_id != pos_stop$i_id & ## different feature
      pos_start$exon_rank != pos_stop$exon_rank ## different exon
    i_id_range <- as.list(as.data.frame(i_id_range[, i_mult_id]))
    ## insert covered intron into i_id_range
    ss <- start(cds)
    es <- end(cds)
    std <- as.character(strand(cds))=="-"
    i_id_range <- mapply(i_id_range,
                         pos_start$i_id[i_mult_id],
                         pos_stop$i_id[i_mult_id],
                         FUN=function(ir, id1, id2){
                           .ir <- c(ss[id1:id2], es[id1:id2])
                           .ir <- .ir[.ir>ir[1] & .ir<ir[2]]
                           if(std[id1]){
                             .ir <- c(.ir, es[id2][es[id2] %in% ir],
                                      ss[id1][ss[id1] %in% ir])
                           }else{
                             .ir <- c(.ir, es[id1][es[id1] %in% ir],
                                      ss[id2][ss[id2] %in% ir])
                           }
                           sort(c(ir, .ir))
                         }, SIMPLIFY = FALSE)
    ## genoimc location to cigar
    MN <- rep(c("M", "N"), readsLen)
    one_zero <- rep(c(1, -1), readsLen)
    cigar <- rep(paste0(readsLen, "M"), length(pos_start))
    dif <- lapply(i_id_range, diff)
    len <- lengths(dif)
    cigar[i_mult_id] <- mapply(dif, len, FUN=function(.ele, l){
      id <- seq.int(l)
      paste(abs(.ele)+one_zero[id], MN[id],
            sep="", collapse = "")
    })
    #njunc <- abs(pos_start$i_id - pos_stop$i_id)
    reads <-
      GAlignments(seqnames = seqnames(pos_start),
                  strand = strand(pos_start),
                  cigar = cigar,
                  pos = st,
                  names = paste(as.character(seqnames(.sample)),
                                unlist(lapply(runLength(seqnames(.sample)),
                                              seq.int)),
                                sep = "_"),
                  tx = as.character(seqnames(.sample)))
    seqinfo(reads) <- seqinfo(txdb)[seqlevels(reads)]

    if(!mis_genome){
      seqinfo(reads) <- seqinfo(genome)[seqlevels(reads)]
      if(includeReadsSeq){
        kgr1 <- kgr <- as(reads, "GRanges")
        strand(kgr) <- "*"
        seqs <- getSeq(genome, kgr)
        seqs <- sequenceLayer(seqs, cigar(reads),
                              from = "reference",
                              to="query-after-soft-clipping")
        seqs[strand(kgr1)=="-"] <- reverseComplement(seqs[strand(kgr1)=="-"])
        mcols(reads)$seq <- seqs
      }
    }else{
      if(any(is.na(seqlengths(reads)))){
        xl <- seqlengths(reads)
        max_reads <- max(end(reads))
        xl[is.na(xl)] <- max_reads
        seqlengths(reads) <- xl
      }
    }
    reads
  })
  ## validation
  # tx <- cds[cds$tx_name %in% "ENSDART00000166393"]
  # re <- start(p[[1]][seqnames(p[[1]]) %in% "ENSDART00000166393"])
  # seq <- getSeq(genome, tx)
  # seq0 <- paste(as.character(seq), collapse="")
  # seq01 <- unlist(lapply(re, function(.re)
  #       substr(seq0, start = .re, stop = .re+readsLen-1)))
  # grn <- gl[[1]]
  # seq2 <-as.character(mcols(grn[mcols(grn)$tx %in% "ENSDART00000166393"])$seq)
  # all(seq01==seq2)
  # ENSDART00000164359, ENSDART00000159144
  # tx <- cds[cds$tx_name %in% "ENSDART00000159144"]
  # re <- start(p[[1]][seqnames(p[[1]]) %in% "ENSDART00000159144"])
  # seq <- getSeq(genome, tx)
  # seq0 <- paste(as.character(seq), collapse="")
  # seq01 <- unlist(lapply(re, function(.re)
  #          substr(seq0, start = .re, stop = .re+readsLen-1)))
  # seq2 <-as.character(mcols(grn[mcols(grn)$tx %in% "ENSDART00000159144"])$seq)
  # all(seq01==seq2)
  if(!missing(outPath)){
    dir.create(outPath, recursive = TRUE, showWarnings = FALSE)
    mapply(gl, samples, FUN=function(dat, name){
      tryCatch(
        export(dat, file.path(outPath, paste0(name, ".bam"))),
        error = function(e){
          message("Got error when export the reads.")
          message(e)
        }
      )
    })
    if(length(real_de_evt)>0){
      tryCatch(
        export(real_de_evt, file.path(outPath, paste0("DEregions.bed"))),
        error = function(e){
          message("Got error when export the DEregions.")
          message(e)
        }
      )
    }
  }
  return(invisible(gl))
}

#' Calculate coverage rate
#' @description Coverage is a measure as percentage of position
#' with reads along the CDS.
#' Coverage rate calculate coverage rate for RPFs and mRNAs in gene level.
#' Coverage will be calculated based on best P sites
#' for RPFs and 5'end for RNA-seq.
#' @param cvgs Output of \link{coverageDepth}
#' @param RPFsampleOrder,mRNAsampleOrder Sample order of RPFs and mRNAs.
#' The parameters are used to make sure that the order of RPFs and mRNAs
#' in cvgs is corresponding samples.
#' @return A list with coverage rate.
#' @export
#' @examples
#' path <- system.file("extdata", package="ribosomeProfilingQC")
#' RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#' gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#' cvgs <- coverageDepth(RPFs[1], gtf=gtf, level="gene")
#' cr <- coverageRates(cvgs)
coverageRates <- function(cvgs, RPFsampleOrder, mRNAsampleOrder){
  if(!is.list(cvgs)){
    stop("cvgs must be output of coverageDepth.")
  }
  if(!any(c("RPFs", "mRNA") %in% names(cvgs))){
    stop("cvgs must be output of coverageDepth.")
  }
  cr <- lapply(cvgs, function(.ele){
    .ele <- .ele[["coverage"]]
    covered <- lapply(.ele, function(.e){
      vapply(.e>0, sum, FUN.VALUE = 0)/lengths(.e)
    })
    ids <- unique(unlist(lapply(covered, names)))
    covered <- lapply(covered, function(.e){
      .e[ids]
    })
    covered <- do.call(cbind, covered)
    covered[is.na(covered)] <- 0
    rownames(covered) <- ids
    covered
  })

  if("RPFs" %in% names(cr)) cr[["RPFs"]] <- cr[["RPFs"]]*3
  if(all(c("RPFs", "mRNA") %in% names(cr))){
    if(missing(RPFsampleOrder))
      RPFsampleOrder <- seq.int(ncol(cr[["RPFs"]]))
    if(missing(mRNAsampleOrder))
      mRNAsampleOrder <- seq.int(ncol(cr[["mRNA"]]))
    ids <- intersect(rownames(cr[["RPFs"]]),
                     rownames(cr[["mRNA"]]))
    cr[["coverageRatio"]] <-
      cr[["RPFs"]][ids,
                   RPFsampleOrder]/cr[["mRNA"]][ids,
                                                mRNAsampleOrder]
  }
  cr
}

#' Summary the reads lengths
#' @description Plot the reads length distribution
#' @param reads Output of getPsiteCoordinates
#' @param widthRange The reads range to be plot
#' @param plot Do plot or not
#' @param ... Not use.
#' @return The reads length distribution
#' @importFrom methods as is
#' @importFrom graphics barplot
#' @export
#' @examples
#' reads <- GRanges("chr1", ranges=IRanges(seq.int(100), width=1),
#'                  qwidth=sample(25:31, size = 100, replace = TRUE,
#'                                prob = c(.01, .01, .05, .1, .77, .05, .01)))
#' summaryReadsLength(reads)
summaryReadsLength <- function(reads, widthRange=c(20:35), plot=TRUE, ...){
  stopifnot(is(reads, "GRanges"))
  stopifnot(length(reads$qwidth)==length(reads))
  distribution <- table(reads$qwidth)/sum(table(reads$qwidth))
  per <- distribution[names(distribution) %in% as.character(widthRange)]*100
  ggBar(per, ylab="percentage (%)", xlab="reads length", draw = plot)
  return(sort(distribution, decreasing = TRUE))
}

#' Extract counts for gene level or transcript level
#' @description Calculate the reads counts or coverage rate for gene level or
#' transcript level.
#' Coverage is determined by measuring the proportion of in-frame CDS
#'  positions with >= 1 reads.
#' @param reads Output of \link{assignReadingFrame}.
#' @param level Transcript or gene level
#' @param frame0only Only count for reading frame 0 or not
#' @param coverageRate Calculate for coverage or not
#' @return A numeric vector with reads counts.
#' @importFrom methods as is
#' @export
#' @examples
#' pcs <- readRDS(system.file("extdata", "samplePc.rds",
#'                package="ribosomeProfilingQC"))
#' cnts <- frameCounts(pcs)
#' cnts.gene <- frameCounts(pcs, level="gene")
#' cvg <- frameCounts(pcs, coverageRate=TRUE)
frameCounts <- function(reads, level=c("tx", "gene"),
                        frame0only=TRUE, coverageRate=FALSE){
  level <- match.arg(level)
  stopifnot(is(reads, "GRanges"))
  if(length(reads$tx_name)!=length(reads) ||
     length(reads$position)!=length(reads) ||
     length(reads$posToStop)!=length(reads) ||
     length(reads$readingFrame)!=length(reads) ||
     length(reads$gene_id)!=length(reads)){
    stop("reads must be a result of assignReadingFrame")
  }

  if(frame0only){
    reads <- reads[reads$readingFrame %in% 0]
  }
  if(coverageRate){
    reads$CDSwidth <- reads$position + reads$posToStop + 2 # stop codon
    if(frame0only){
      reads$CDSwidth <- reads$CDSwidth/3
    }
    cnt <- split(reads$position, reads$tx_name)
    cnt <- lapply(cnt, unique)
    cnt <- lengths(cnt)
    cnt <- cnt/reads$CDSwidth[match(names(cnt), reads$tx_name)]
    if(level=="gene"){# get mean for each gene
      #cnt <- split(cnt, reads$gene_id[match(names(cnt), reads$tx_name)])
      #cnt <- sapply(cnt, mean)
      stop("gene level coverage rate is not supported by frameCounts!")
    }
  }else{
    if(level=="tx"){
      cnt <- table(reads$tx_name)
    }else{
      cnt <- table(reads$gene_id)
    }
  }
  cnt
}

#' Fragment Length Organization Similarity Score (FLOSS)
#' @description The FLOSS will be calculated from a histogram of
#' read lengths for footprints on a transcript or reading frame.
#' @references 1: Ingolia NT, Brar GA, Stern-Ginossar N, Harris MS,
#' Talhouarne GJ, Jackson SE, Wills MR, Weissman JS. Ribosome profiling
#' reveals pervasive translation outside
#' of annotated protein-coding genes. Cell Rep. 2014 Sep 11;8(5):1365-79. doi:
#' 10.1016/j.celrep.2014.07.045. Epub 2014 Aug 21. PubMed PMID: 25159147; PubMed
#' Central PMCID: PMC4216110.
#' @param reads Output of \link{getPsiteCoordinates}
#' @param ref Refercence id list. If level is set to tx, the id should be
#' transcript names. If level is set to gene, the id should be gene id.
#' @param CDS Output of \link{prepareCDS}
#' @param readLengths Read length used for calculation
#' @param level Transcript or gene level
#' @param draw Plot FLOSS vs total reads or not.
#' @param ignore.seqlevelsStyle Ignore the sequence name style detection or not.
#' @return A data frame with colnames as id, FLOSS, totalReads,
#' wilcox.test.pval, cook's distance.
#' @importFrom IRanges findOverlaps
#' @importFrom S4Vectors queryHits subjectHits
#' @importFrom stats cooks.distance lm wilcox.test
#' @importFrom ggplot2 geom_point geom_smooth scale_x_log10 scale_y_log10
#' annotation_logticks
#' @importFrom ggrepel geom_label_repel
#' @importFrom scales trans_breaks trans_format math_format
#' @export
#' @examples
#' library(Rsamtools)
#' bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#'                            package="ribosomeProfilingQC")
#' yieldSize <- 10000000
#' bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#' pc <- getPsiteCoordinates(bamfile, bestpsite=13)
#' #library(txdbmaker)
#' library(BSgenome.Drerio.UCSC.danRer10)
#' #txdb <- makeTxDbFromGFF(system.file("extdata",
#'  #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#'  #         package="ribosomeProfilingQC"),
#'  #         organism = "Danio rerio",
#'  #         chrominfo = seqinfo(Drerio)["chr1"],
#'  #         taxonomyId = 7955)
#' #CDS <- prepareCDS(txdb)
#' CDS <- readRDS(system.file("extdata", "CDS.rds",
#'                            package="ribosomeProfilingQC"))
#' set.seed(123)
#' ref <- sample(unique(CDS$gene_id), 100)
#' fl <- FLOSS(pc, ref, CDS, level="gene")

FLOSS <- function(reads, ref, CDS, readLengths=c(26:34),
                  level=c("tx", "gene"), draw=FALSE,
                  ignore.seqlevelsStyle=FALSE){
  stopifnot(is(reads, "GRanges"))
  stopifnot(length(reads$qwidth)==length(reads))
  level <- match.arg(level)
  level <- c("tx"="tx_name", "gene"="gene_id")[level]
  stopifnot(is(CDS, "GRanges"))
  if(length(CDS$tx_name)!=length(CDS) ||
     length(CDS$gene_id)!=length(CDS)){
    stop("CDS must be output of prepareCDS")
  }
  reads <- fixSeqlevelsStyle(reads, CDS, ignore.seqlevelsStyle)
  stopifnot(is.numeric(readLengths))
  readLengths <- as.integer(readLengths)
  reads <- reads[reads$qwidth>=min(readLengths) &
                   reads$qwidth<=max(readLengths)]
  if(length(reads)<1){
    stop("No reads is in given readLengths.")
  }
  ol <- findOverlaps(CDS, reads)
  qh <- mcols(CDS[queryHits(ol)])[, level]
  sh <- reads[subjectHits(ol)]
  sh$ID <- qh
  sh <- sh[(!duplicated(sh)) | (!duplicated(qh))]
  cnt <- data.frame(len=sh$qwidth, ID=sh$ID)
  cnt.ref <- cnt[cnt$ID %in% ref, "len"]
  cnt.tab <- table(cnt)
  cnt.ref <- table(cnt.ref)
  cnt.ref <- cnt.ref[match(as.character(readLengths), names(cnt.ref))]
  cnt.ref[is.na(cnt.ref)] <- 0
  names(cnt.ref) <- as.character(readLengths)
  cnt.ref.sum <- sum(cnt.ref)
  if(cnt.ref.sum<1){
    stop("No reads is in ref.")
  }
  f.ref <- cnt.ref/cnt.ref.sum
  cnt.tab <- cnt.tab[match(as.character(readLengths), rownames(cnt.tab)), ]
  rownames(cnt.tab) <- as.character(readLengths)
  cnt.tab[is.na(cnt.tab)] <- 0
  cnt.tab <- cnt.tab[, colSums(cnt.tab)>0, drop=FALSE]
  cnt.tab.sum <- colSums(cnt.tab)
  f.tab <- t(cnt.tab)/cnt.tab.sum

  fl <- apply(f.tab, 1, function(.ele) .ele-f.ref)
  fl <- .5 * colSums(abs(fl))
  pval <- apply(f.tab, 1,
                function(.ele){
                  .id <- (.ele - f.ref)!=0
                  if(sum(.id)==0){
                    1
                  }else{
                    wilcox.test(x = .ele[.id],
                                y = f.ref[.id], paired = TRUE)$p.value
                  }
                })
  id <- names(fl)
  df <- data.frame(id=id, FLOSS=fl, totalReads=cnt.tab.sum[id],
                   p.value=pval[id], stringsAsFactors = FALSE)
  fit.data <- log2(df[df$FLOSS!=0, c("totalReads", "FLOSS")])
  fit <- lm(FLOSS~0+totalReads,
            log2(df[df$FLOSS!=0, c("totalReads", "FLOSS")]))
  cooksd <- cooks.distance(fit)
  df$cooks.distance <- 0
  df$cooks.distance[df$FLOSS!=0] <- cooksd
  if(draw){
    ggdf <- df[df$FLOSS!=0,
               c("id", "totalReads", "FLOSS", "cooks.distance"),
               drop=FALSE]
    ggdf$highlight <- ggdf$cooks.distance>4*mean(cooksd, na.rm=TRUE)
    colnames(ggdf) <- c("ggid", "ggx", "ggy", "ggcd", "gghighlight")
    ggid <- ggx <- ggy <- ggcd <- gghighlight <- .x <- NULL
    plot <- ggplot(ggdf, aes(x=ggx, y=ggy)) +
      geom_point(pch = 16, cex = .5) +
      geom_smooth(method = "lm", formula = y~0+x, color="red", lty=3) +
      xlab("total reads") +
      ylab("FLOSS") +
      geom_label_repel(data = subset(ggdf, gghighlight), aes(label=ggid)) +
      geom_point(data = subset(ggdf, gghighlight), pch=21, color="red") +
      scale_x_log10(breaks = trans_breaks("log10", function(x) 10^x),
                    labels = trans_format("log10", math_format(10^.x))) +
      scale_y_log10(breaks = trans_breaks("log10", function(x) 10^x),
                    labels = trans_format("log10", math_format(10^.x))) +
      annotation_logticks() +
      theme_classic()
    print(plot)
  }
  df <- cbind(df,
              matrix(as.numeric(f.tab[id, ]),
                     ncol=ncol(f.tab),
                     dimnames = list(ID=id, len=colnames(f.tab))))
  df.ref=data.frame(id="ref", FLOSS=0, totalReads=cnt.ref.sum,
                 p.value=1, cooks.distance=0,
                 t(unlist(as.list(f.ref))), row.names = "ref",
                 stringsAsFactors = FALSE, check.names = FALSE)
  df <- rbind(df.ref, df)
  return(df)
}

## ----echo=FALSE, results="hide", warning=FALSE, message=FALSE-----------------
suppressPackageStartupMessages({
  library(ribosomeProfilingQC)
  library(BSgenome.Drerio.UCSC.danRer10)
  library(txdbmaker)
  library(Rsamtools)
  library(AnnotationDbi)
  library(motifStack)
})
knitr::opts_chunk$set(warning=FALSE, message=FALSE, fig.width=5, fig.height=3.5)

## ----eval=FALSE---------------------------------------------------------------
# library(BiocManager)
# BiocManager::install(c("ribosomeProfilingQC",
#                        "AnnotationDbi", "Rsamtools",
#                        "BSgenome.Drerio.UCSC.danRer10",
#                        "TxDb.Drerio.UCSC.danRer10.refGene",
#                        "motifStack"))

## -----------------------------------------------------------------------------
R.version

## ----loadLibrary, class.source='vig'------------------------------------------
## load library
library(ribosomeProfilingQC)
library(AnnotationDbi)
library(Rsamtools)
library(ggplot2)

## ----loadGenome, class.source='vig'-------------------------------------------
library(BSgenome.Drerio.UCSC.danRer10)
## set genome, Drerio is a shortname for BSgenome.Drerio.UCSC.danRer10
genome <- Drerio

## ----eval=FALSE---------------------------------------------------------------
# library(BSgenome.Hsapiens.UCSC.hg38)
# genome <- Hsapiens

## ----eval=FALSE---------------------------------------------------------------
# library(BSgenome.Mmusculus.UCSC.mm10)
# genome <- Mmusculus

## ----eval=FALSE---------------------------------------------------------------
# genome <- Biostrings::readDNAStringSet('filepath/to/the/genome/fasta/file')

## ----eval=FALSE---------------------------------------------------------------
# ## which is corresponding to BSgenome.Drerio.UCSC.danRer10
# library(TxDb.Drerio.UCSC.danRer10.refGene)
# txdb <- TxDb.Drerio.UCSC.danRer10.refGene ## give it a short name
# CDS <- prepareCDS(txdb)

## ----eval=FALSE---------------------------------------------------------------
# library(TxDb.Hsapiens.UCSC.hg38.knownGene)
# txdb <- TxDb.Hsapiens.UCSC.hg38.knownGene ## give it a short name
# CDS <- prepareCDS(txdb)

## ----eval=FALSE---------------------------------------------------------------
# library(TxDb.Mmusculus.UCSC.mm10.knownGene)
# txdb <- TxDb.Mmusculus.UCSC.mm10.knownGene ## give it a short name
# CDS <- prepareCDS(txdb)

## ----loadTxDb, class.source='vig'---------------------------------------------
## Create a small TxDb object which only contain chr1 information.
library(txdbmaker)
txdb <- makeTxDbFromGFF(system.file("extdata",
                                    "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                    package="ribosomeProfilingQC"),
                        organism = "Danio rerio",
                        chrominfo = seqinfo(Drerio)["chr1"],
                        taxonomyId = 7955)
CDS <- prepareCDS(txdb)

## ----filter, eval=FALSE-------------------------------------------------------
# bamfilename <- system.file("extdata", "RPF.WT.1.bam",
#                            package="ribosomeProfilingQC")
# bamHeader <- Rsamtools::scanBamHeader(bamfilename)
# (chromsomeNameStyle <- GenomeInfoDb::seqlevelsStyle(names(bamHeader[[1]]$targets)))
# library(rtracklayer)
# ## the gtf could be downloaded from https://www.ensembl.org/info/data/ftp/index.html
# ## Please make sure the version number are correct.
# ## check the version number at https://www.ensembl.org/info/website/archives/index.html
# gtf <- import(system.file("extdata",
#                           "Danio_rerio.GRCz10.91.chr1.gtf.gz",
#                           package="ribosomeProfilingQC"))
# gtf <- gtf[gtf$transcript_biotype %in%
#              c('rRNA', 'tRNA', 'snRNA', 'snoRNA', 'misc_RNA')]
# mcols(gtf) <- NULL
# annotation <- 'danRer10' ## must be UCSC style, eg, GRCm38 should be mm10, GRCh38 should be hg38
# rmsk <- data.table::fread(paste0('https://hgdownload.soe.ucsc.edu/goldenPath/',
#                                 annotation, '/database/rmsk.txt.gz'),
#                           header=FALSE)
# colnames(rmsk) <- c('bin', 'swScore', 'milliDiv', 'milliDel', 'milliIns',
#                     'genoName', 'genoStart', 'genoEnd', 'genoLeft', 'strand',
#                     'repName', 'repClass', 'repFamily', 'repStart', 'repEnd',
#                     'repLeft', 'id')
# rmsk_gr <- with(rmsk, GRanges(genoName, IRanges(genoStart+1, genoEnd),
#                               strand = strand))
# # 'UCSC' or 'ensembl', keep same as it in the bam file
# GenomeInfoDb::seqlevelsStyle(gtf) <- seqlevelsStyle(rmsk_gr) <-
#   chromsomeNameStyle[1]
# gr <- reduce(sort(c(gtf, rmsk_gr)))
# seqlevels(gr, pruning.mode="coarse") <-
#   intersect(seqlevels(gr), names(bamHeader[[1]]$targets))
# outputBed <- 'unused_regions.bed'
# export(gr, outputBed)
# filteredBamfileName <- sub('.bam$', '.fil.bam', bamfilename)
# unusedBamfileName <- sub('.bam$', '.no_use.bam', bamfilename)
# ## run the cmd in terminal or by system/system2
# ## please make sure the samtools is available in PATH
# ## see more about samtools at https://www.htslib.org/
# (cmd <- paste('samtools view -b -L', outputBed,
#               '-U', filteredBamfileName,
#               '-o', unusedBamfileName,
#               bamfilename))
# system2('samtools',
#   args = c('view', '-b',
#            '-L', outputBed,
#            '-U', filteredBamfileName,
#            '-o', unusedBamfileName,
#            bamfilename))
# (cmd2 <- paste('samtools bam2fq', filteredBamfileName,
#                '| gzip >', sub('.bam$', '.fq.gz', filteredBamfileName)))
# system2('samtools',
#         args = c('bam2fq', filteredBamfileName,
#                '|', 'gzip', '>', sub('.bam$', '.fq.gz', filteredBamfileName)))

## ----inputBamFile, class.source='vig'-----------------------------------------
library(Rsamtools)
## input the bamFile from the ribosomeProfilingQC package 
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
## For your own data, please set bamfilename as your file path.
## For example, your bam file is located at C:\mydata\a.bam
## you want to set bamfilename = "C:\\mydata\\a.bam"
## or you can change your working directory by
## setwd("C:\\mydata")
## and then set bamfilename = "a.bam"
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)

## ----estimatePsite, class.source='vig'----------------------------------------
estimatePsite(bamfile, CDS, genome)

## ----estimatePsite3end, class.source='vig'------------------------------------
estimatePsite(bamfile, CDS, genome, anchor = "3end")

## ----readsEndPlot, fig.height=4, fig.width=6, class.source='vig'--------------
re <- readsEndPlot(bamfile, CDS, toStartCodon=TRUE)
readsEndPlot(re$reads, CDS, toStartCodon=TRUE, fiveEnd=FALSE)

## ----getPsiteCoordinates, class.source='vig'----------------------------------
pc <- getPsiteCoordinates(bamfile, bestpsite = 13)

## ----readsLen, class.source='vig'---------------------------------------------
readsLen <- summaryReadsLength(pc)

## ----filterSize, class.source='vig'-------------------------------------------
## for this QC demo, we will only use reads length of 28-29 nt.
pc.sub <- pc[pc$qwidth %in% c(28, 29)]

## ----strandPlot, fig.width=2,fig.height=3, class.source='vig'-----------------
strandPlot(pc.sub, CDS)

## ----readsDistribution, fig.width=7, fig.height=4, class.source='vig'---------
pc.sub <- readsDistribution(pc.sub, txdb, las=2)

## ----metaPlotUTR5cdsUTR3, fig.width=5, fig.height=4, class.source='vig'-------
cvgs.utr5 <- coverageDepth(RPFs = bamfilename, gtf = txdb, region="utr5")
cvgs.CDS <- coverageDepth(RPFs = bamfilename, gtf = txdb, region="cds")
cvgs.utr3 <- coverageDepth(RPFs = bamfilename, gtf = txdb, region="utr3")
metaPlot(cvgs.utr5, cvgs.CDS, cvgs.utr3, sample=1)

## ----assignReadingFrame, fig.width=5, fig.height=3, class.source='vig'--------
pc.sub <- assignReadingFrame(pc.sub, CDS)
plotDistance2Codon(pc.sub)

## ----plotFrameDensity, fig.width=2.5,fig.height=3, class.source='vig'---------
plotFrameDensity(pc.sub)

## ----allReadFrame, fig.width=2.5,fig.height=3, class.source='vig'-------------
pc <- assignReadingFrame(pc, CDS)
plotFrameDensity(pc)

## ----plotTranscript, fig.width=8, fig.height=6, class.source='vig'------------
plotTranscript(pc.sub, c("ENSDART00000161781", "ENSDART00000166968",
                         "ENSDART00000040204", "ENSDART00000124837"))

## ----ORFscore, eval=FALSE, class.source='vig'---------------------------------
# cvg <- frameCounts(pc.sub, coverageRate=TRUE)
# ORFscore <- getORFscore(pc.sub)
# ## Following code will plot the ORFscores vs coverage.
# ## Try it by removing the '#'.
# #plot(cvg[names(ORFscore)], ORFscore,
# #     xlab="coverage ORF1", ylab="ORF score",
# #     type="p", pch=16, cex=.5, xlim=c(0, 1))

## ----badStrandPlot, fig.width=2,fig.height=3, class.source='vig'--------------
bamfilename <- system.file("extdata", "RPF.chr1.bad.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite = 13)
pc.sub <- pc[pc$qwidth %in% c(27, 28, 29)]
## in this example, most of the reads mapped to the antisense strand
## which may indicate that there are some issues in the mapping step
strandPlot(pc.sub, CDS)

## ----badReadsDistribution, fig.width=7, fig.height=4, class.source='vig'------
## in this exaple, most of the reads mapped to inter-genic regions
## rather than the CDS, which could indicate that ribosome protected
## fragments are not being properly isolated/selected
pc.sub <- readsDistribution(pc.sub, txdb, las=2)

## ----badAssignReadingFrame, fig.width=5, fig.height=4, class.source='vig'-----
## Selection of the proper P site is also critical.
## If we assign the wrong P site position the frame mapping will 
## likely be impacted. 
pc <- getPsiteCoordinates(bamfile, 12)
pc.sub <- pc[pc$qwidth %in% c(27, 28, 29)]
pc.sub <- assignReadingFrame(pc.sub, CDS)
plotDistance2Codon(pc.sub)

## ----badPlotFrameDensity, fig.width=2.5,fig.height=3, class.source='vig'------
plotFrameDensity(pc.sub)

## ----countReads, class.source='vig'-------------------------------------------
library(ribosomeProfilingQC)
library(AnnotationDbi)
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
cnts <- countReads(RPFs, gtf=gtf, level="gene",
                   bestpsite=13, readsLen=c(28,29))
head(cnts$RPFs)
## To save the cnts, please try following codes by removing '#'
# write.csv(cbind(cnts$annotation[rownames(cnts$RPFs), ], cnts$RPFs),
#           "counts.csv")

## ----prePareGTF, eval=FALSE---------------------------------------------------
# BiocManager::install("AnnotationHub")
# library(AnnotationHub)
# ah = AnnotationHub()
# ## for human hg38
# hg38 <- query(ah, c("Ensembl", "GRCh38", "gtf"))
# hg38 <- hg38[length(hg38)]
# gtf <- mcols(hg38)$sourceurl
# ## for mouse mm10
# mm10 <- query(ah, c("Ensembl", "GRCm38", "gtf"))
# mm10 <- mm10[length(mm10)]
# gtf <- mcols(mm10)$sourceurl

## ----differentialByEdgeR, class.source='vig'----------------------------------
library(edgeR)  ## install edgeR by BiocManager::install("edgeR")
gp <- c("KD", "KD", "CTL", "CTL") ## sample groups: KD:knockdown; CTL:Control
y <- DGEList(counts = cnts$RPFs, group = gp)
y <- calcNormFactors(y)
design <- model.matrix(~0+gp)
colnames(design) <- sub("gp", "", colnames(design))
y <- estimateDisp(y, design)
## To perform quasi-likelihood F-tests:
fit <- glmQLFit(y, design)
qlf <- glmQLFTest(fit)
topTags(qlf, n=3) # set n=nrow(qlf) to pull all results.
## To perform likelihood ratio tests:
fit <- glmFit(y, design)
lrt <- glmLRT(fit)
topTags(lrt, n=3) # set n=nrow(lrt) to pull all results.

## ----alternativeSplicing, fig.width=6, fig.height=4, class.source='vig'-------
coverage <- coverageDepth(RPFs[grepl("KD1|WT", RPFs)], 
                          gtf=txdb, 
                          level="gene",
                          region="feature with extension")
group1 <- c("RPF.KD1.1", "RPF.KD1.2")
group2 <- c("RPF.WT.1", "RPF.WT.2")
## subset the data, for sample run only
coverage <- lapply(coverage, function(.ele){##do not run this for real data
  .ele$coverage <- lapply(.ele$coverage, `[`, i=seq.int(50))
  .ele$granges <- .ele$granges[seq.int(50)]
  .ele
})
se <- spliceEvent(coverage, group1, group2)
table(se$type)
plotSpliceEvent(se, se$feature[1], coverage, group1, group2)

## ----countRPFandRNA, class.source='vig'---------------------------------------
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
RNAs <- dir(path, "mRNA.*?\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")

## ----countReadsRPFandRNA,eval=FALSE, class.source='vig'-----------------------
# ## make sure that the order of the genes listed in the bam files for RPFs
# ## and RNAseq data is the same.
# cnts <- countReads(RPFs, RNAs, gtf, level="tx")
# ## To save the cnts, please try following codes by removing '#'
# # rn <- cnts$annotation$GeneID
# # write.csv(cbind(cnts$annotation,
# #                 cnts$RPFs[match(rn, rownames(cnts$RPFs)), ],
# #                 cnts$mRNA[match(rn, rownames(cnts$mRNA)), ]),
# #           "counts.csv")

## ----include=FALSE------------------------------------------------------------
cnts <- readRDS(file.path(path, "cnts.rds"))

## ----translationalEfficiency, class.source='vig'------------------------------
fpkm <- getFPKM(cnts)
TE <- translationalEfficiency(fpkm)

## ----differentialTEbyLimma, class.source='vig'--------------------------------
library(limma)
gp <- c("KD", "KD", "CTL", "CTL") ## sample groups: KD:knockdown; CTL:Control
TE.log2 <- log2(TE$TE + 1)
#plot(TE.log2[, 1], TE.log2[, 3], 
#     xlab=colnames(TE.log2)[1], ylab=colnames(TE.log2)[3],
#     main="Translational Efficiency", pch=16, cex=.5)
design <- model.matrix(~0+gp)
colnames(design) <- sub("gp", "", colnames(design))
fit <- lmFit(TE.log2, design)
fit2 <- eBayes(fit)
topTable(fit2, number=3) ## set number=nrow(fit2) to pull all results

## ----class.source='vig'-------------------------------------------------------
library(edgeR)
gp <- c("KD", "KD", "CTL", "CTL")
design <- model.matrix(~0+gp)
colnames(design) <- sub("gp", "", colnames(design))
y <- lapply(cnts[c("RPFs", "mRNA")], function(.cnt){
  .y <- DGEList(counts = .cnt, 
             samples = data.frame(gp=gp))
  .y <- calcNormFactors(.y)
  .y <- estimateDisp(.y, design)
  .y
})

## To perform likelihood ratio tests:
fit <- lapply(y, glmFit, design = design)
lrt <- lapply(fit, glmLRT)
topTags(lrt[["RPFs"]], n=3) # difference between CTL and KD for RPFs
topTags(lrt[["mRNA"]], n=3) # difference between CTL and KD for mRNA
results <- lapply(lrt, topTags, p.value = 0.05, n = nrow(lrt[[1]]))
RPFs_unique <- setdiff(rownames(results[["RPFs"]]),
                       rownames(results[["mRNA"]]))
mRNA_zero <- rownames(cnts[["mRNA"]])[rowSums(cnts[["mRNA"]]) == 0]
RPFs_unique <- RPFs_unique[!RPFs_unique %in% mRNA_zero]
head(results[["RPFs"]][RPFs_unique, ], n=3) ## top 3 events for translation level

## ----plotTE, class.source='vig'-----------------------------------------------
plotTE(TE, sample=2, xaxis="mRNA", log2=TRUE)
#plotTE(TE, sample=2, xaxis="RPFs", log2=TRUE)

## ----plotTE90, class.source='vig'---------------------------------------------
cvgs <- coverageDepth(RPFs, RNAs, txdb)
TE90 <- translationalEfficiency(cvgs, window = 90, normByLibSize=TRUE)
plotTE(TE90, sample=2, xaxis="mRNA", log2=TRUE)

## ----include=FALSE------------------------------------------------------------
cvgs.utr3 <- coverageDepth(RPFs, RNAs, txdb, region="utr3")

## ----eval=FALSE, class.source='vig'-------------------------------------------
# cvgs.utr3 <- coverageDepth(RPFs, RNAs, txdb, region="utr3")
# TE90.utr3 <- translationalEfficiency(cvgs.utr3, window = 90)
# ## Following code will plot the TE90 for 3'UTR regions.
# ## Try it by removing the '#'.
# #plotTE(TE90.utr3, sample=2, xaxis="mRNA", log2=TRUE)
# #plotTE(TE90.utr3, sample=2, xaxis="RPFs", log2=TRUE)

## ----class.source='vig'-------------------------------------------------------
cnts_normByEdgeR <- normBy(cnts, method = 'edgeR')
TE_edgeR <- translationalEfficiency(cnts_normByEdgeR)
plotTE(TE_edgeR)

## ----class.source='vig'-------------------------------------------------------
TE.log2_norm <- normalizeTEbyLoess(TE)
## please note that output is log2 transformed TE.
plotTE(TE.log2_norm, log2 = FALSE)

## ----eval=FALSE, class.source='vig'-------------------------------------------
# RRS <- ribosomeReleaseScore(TE90, TE90.utr3, log2 = TRUE)
# ## Following code will compare RSS for 2 samples.
# ## Try it by removing the '#'.
# #plot(RRS[, 1], RRS[, 3],
# #     xlab="log2 transformed RRS of KD1",
# #     ylab="log2 transformed RRS of WT1")
# ## Following code will show RSS along TE90.
# ## Try it by removing the '#'.
# #plot(RRS[, 1], log2(TE90$TE[rownames(RRS), 1]),
# #     xlab="log2 transformed RSS of KD1",
# #     ylab="log2 transformed TE of KD1")

## ----metaPlot, class.source='vig'---------------------------------------------
cvgs.utr5 <- coverageDepth(RPFs, RNAs, txdb, region="utr5")
## set sample to different number to plot metagene analysis 
## for different samples
#metaPlot(cvgs.utr5, cvgs, cvgs.utr3, sample=2, xaxis = "RPFs")
metaPlot(cvgs.utr5, cvgs, cvgs.utr3, sample=2, xaxis = "mRNA")

## ----eval=FALSE---------------------------------------------------------------
# ## documentation: https://useast.ensembl.org/Help/Faq?id=468
# gtf <- import("Danio_rerio.GRCz10.91.gtf.gz")

## ----eval=FALSE---------------------------------------------------------------
# BiocManager::install("AnnotationHub")
# library(AnnotationHub)
# ah = AnnotationHub()
# ## for human hg38
# hg38 <- query(ah, c("Ensembl", "GRCh38", "gtf"))
# hg38 <- hg38[[length(hg38)]]
# ## for mouse mm10
# mm10 <- query(ah, c("Ensembl", "GRCm38", "gtf"))
# mm10 <- mm10[[length(mm10)]]
# ## because the gene ids in TxDb.Mmusculus.UCSC.mm10.knownGene and
# ## TxDb.Hsapiens.UCSC.hg38.knownGene
# ## are entriz_id, the gene_id in mm10 or hg38 need to changed to entriz_id.
# library(ChIPpeakAnno)
# library(org.Mm.eg.db)
# mm10$gene_id <- ChIPpeakAnno::xget(mm10$gene_id, org.Mm.egENSEMBL2EG)
# library(org.Hg.eg.db)
# hg38$gene_id <- ChIPpeakAnno::xget(hg38$gene_id, org.Mm.egENSEMBL2EG)

## ----eval=FALSE---------------------------------------------------------------
# gtf <- gtf[!is.na(gtf$gene_id)]
# gtf <- gtf[gtf$gene_id!=""]
# ## protein coding
# protein <-
#   gtf$gene_id[gtf$transcript_biotype %in%
#                   c("IG_C_gene", "IG_D_gene", "IG_J_gene", "IG_LV_gene",
#                     "IG_M_gene", "IG_V_gene", "IG_Z_gene",
#                     "nonsense_mediated_decay", "nontranslating_CDS",
#                     "non_stop_decay",
#                     "protein_coding", "TR_C_gene", "TR_D_gene", "TR_gene",
#                     "TR_J_gene", "TR_V_gene")]
# ## mitochondrial genes
# mito <- gtf$gene_id[grepl("^mt\\-", gtf$gene_name) |
#                         gtf$transcript_biotype %in% c("Mt_tRNA", "Mt_rRNA")]
# ## long noncoding
# lincRNA <-
#   gtf$gene_id[gtf$transcript_biotype %in%
#                   c("3prime_overlapping_ncrna", "lincRNA",
#                     "ncrna_host", "non_coding")]
# ## short noncoding
# sncRNA <-
#   gtf$gene_id[gtf$transcript_biotype %in%
#                   c("miRNA", "miRNA_pseudogene", "misc_RNA",
#                     "misc_RNA_pseudogene", "Mt_rRNA", "Mt_tRNA",
#                     "Mt_tRNA_pseudogene", "ncRNA", "pre_miRNA",
#                     "RNase_MRP_RNA", "RNase_P_RNA", "rRNA", "rRNA_pseudogene",
#                     "scRNA_pseudogene", "snlRNA", "snoRNA",
#                     "snRNA_pseudogene", "SRP_RNA", "tmRNA", "tRNA",
#                     "tRNA_pseudogene", "ribozyme", "scaRNA", "sRNA")]
# ## pseudogene
# pseudogene <-
#   gtf$gene_id[gtf$transcript_biotype %in%
#                   c("disrupted_domain", "IG_C_pseudogene", "IG_J_pseudogene",
#                     "IG_pseudogene", "IG_V_pseudogene", "processed_pseudogene",
#                     "pseudogene", "transcribed_processed_pseudogene",
#                     "transcribed_unprocessed_pseudogene",
#                     "translated_processed_pseudogene",
#                     "translated_unprocessed_pseudogene", "TR_J_pseudogene",
#                     "TR_V_pseudogene", "unitary_pseudogene",
#                     "unprocessed_pseudogene")]
# danrer10.annotations <- list(protein=unique(protein),
#                              mito=unique(mito),
#                              lincRNA=unique(lincRNA),
#                              pseudogene=unique(pseudogene))

## ----loadPresavedAnnotations, class.source='vig'------------------------------
danrer10.annotations <- 
  readRDS(system.file("extdata",
                      "danrer10.annotations.rds",
                      package = "ribosomeProfilingQC"))

## ----fig.width=4, fig.height=4, class.source='vig'----------------------------
library(ribosomeProfilingQC)
library(txdbmaker)
## prepare CDS annotation
txdb <- makeTxDbFromGFF(system.file("extdata",
                                    "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                    package="ribosomeProfilingQC"),
                        organism = "Danio rerio",
                        chrominfo = seqinfo(Drerio)["chr1"],
                        taxonomyId = 7955)
CDS <- prepareCDS(txdb)

library(Rsamtools)
## input the bamFile from the ribosomeProfilingQC package 
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
## For your own data, please set bamfilename as your file path.
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)

pc <- getPsiteCoordinates(bamfile, bestpsite = 13)
readsLengths <- 20:34
fl <- FLOSS(pc, ref = danrer10.annotations$protein, 
            CDS = CDS, readLengths=readsLengths, level="gene", draw = FALSE)
fl.max <- t(fl[c(1, which.max(fl$cooks.distance)), as.character(readsLengths)])
matplot(fl.max, type = "l", x=readsLengths, 
        xlab="Fragment Length", ylab="Fraction of Reads", 
        col = c("gray", "red"), lwd = 2, lty = 1)
legend("topright",  legend = c("ref", "selected gene"), 
       col = c("gray", "red"), lwd = 2, lty = 1, cex=.5)

---
title: "ribosomeProfilingQC Guide"
author: "Jianhong Ou, Mariah Hoye"
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('ribosomeProfilingQC')`"
bibliography: bibliography.bib
csl: nature.csl
vignette: >
  %\VignetteIndexEntry{ribosomeProfilingQC Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document
---

<style>
    pre.vig {
        background-color: #FEFBF5!important;
        border: 1px solid #FFE4AD!important;
    }
</style>

```{r, echo=FALSE, results="hide", warning=FALSE, message=FALSE}
suppressPackageStartupMessages({
  library(ribosomeProfilingQC)
  library(BSgenome.Drerio.UCSC.danRer10)
  library(txdbmaker)
  library(Rsamtools)
  library(AnnotationDbi)
  library(motifStack)
})
knitr::opts_chunk$set(warning=FALSE, message=FALSE, fig.width=5, fig.height=3.5)
```

#Introduction

Ribosome footprinting, developed by Jonathan Weissman and 
Nicholas Ingolia[@ingolia2014ribosome],
measures translation by direct quantification of the coding sequence 
currently bound by the 80S ribosome 
(ribosome-protected fragments, RPFs) [@bazzini2014identification]. 
In eukaryotes, the size of RPFs is around 28-nt, 
where the P-site of the ribosome is typically in position 13 from the 5' end of reads.
In bacteria, Allen et. al. were able to more accurately identify the P-site 
from 3' end of reads[@mohammad2019systematically].

![Schematic representation of ribosome profiling.](schematic.ribosome.prof.jpg)

There are several packages available in Bioconductor already, including,
_riboSeqR_ [@chung2015use], _RiboProfiling_ [@popa2016riboprofiling] and
_ORFik_[@tjeldnes2018atlas].
These packages are powerful in analyzing the ribosome footprinting data. 
The _ORFik_ package can also be used to find new transcription start sites using 
CageSeq data. 
_RiboWaltz_[@lauria2018ribowaltz] is another popular package which is based on 
R and Bioconductor.

To help researchers quickly assess the quality of their ribosome profiling data,
we have developed the ribosomeProfilingQC package. 
The _ribosomeProfilingQC_ package can be used to easily make diagnostic plots 
to check the mapping quality and frameshifts. In addition, it can preprocess 
ribosome profiling data for subsequent differential analysis. 
We have tried to make this package as user-friendly as possible and 
the only input needed is a bam file of your ribosome footprinting and 
RNAseq data mapped to the genome.

Please note that all following analyses are based on known Open Reading Frame 
(ORF) annotation. 
The sample data provided in the package is mapped to Zebrafish UCSC danRer10 assembly; 
all code related to this assembly will be **highlighted in 
light yellow background** for clarity.

# Quick start

Here is an example using _ribosomeProfilingQC_ with a subset of ribo-seq data.

First install _ribosomeProfilingQC_ and other packages required to run 
the examples.
Please note that the example dataset used here is from zebrafish. 
To run analysis with dataset from a different species or different assembly, 
please install the corresponding BSgenome and TxDb.
For example, to analyze mouse data aligned to mm10, 
please install BSgenome.Mmusculus.UCSC.mm10, 
and TxDb.Mmusculus.UCSC.mm10.knownGene. 
You can also generate a TxDb object by 
functions `makeTxDbFromGFF` from a local gff file,
or `makeTxDbFromUCSC`, `makeTxDbFromBiomart`, and `makeTxDbFromEnsembl`, 
from online resources in _txdbmaker_ package.

```{r, eval=FALSE}
library(BiocManager)
BiocManager::install(c("ribosomeProfilingQC", 
                       "AnnotationDbi", "Rsamtools",
                       "BSgenome.Drerio.UCSC.danRer10",
                       "TxDb.Drerio.UCSC.danRer10.refGene",
                       "motifStack"))
```

If you have trouble in install _ribosomeProfilingQC_, please check your R
version first. The _ribosomeProfilingQC_ package require R >= 4.0.
```{r}
R.version
```

```{r loadLibrary, class.source='vig'}
## load library
library(ribosomeProfilingQC)
library(AnnotationDbi)
library(Rsamtools)
library(ggplot2)
```
## Load genome

In this manual, we will use the fish genome.

```{r loadGenome, class.source='vig'}
library(BSgenome.Drerio.UCSC.danRer10)
## set genome, Drerio is a shortname for BSgenome.Drerio.UCSC.danRer10
genome <- Drerio
```

If your assembly is Human hg38 please load the human library,

```{r, eval=FALSE}
library(BSgenome.Hsapiens.UCSC.hg38)
genome <- Hsapiens
```

If your assembly is Mouse mm10 please load the mouse library,

```{r, eval=FALSE}
library(BSgenome.Mmusculus.UCSC.mm10)
genome <- Mmusculus
```

If you are having trouble creating or retrieving a `BSgenome`,
a `DNAStringSet` object has also been acceptable since version 1.17.1.

```{r, eval=FALSE}
genome <- Biostrings::readDNAStringSet('filepath/to/the/genome/fasta/file')
```

## Prepare annotaiton CDS

The function `prepareCDS` is used to prepare the information for downstream 
analysis from a `TxDb` object.

```{r, eval=FALSE}
## which is corresponding to BSgenome.Drerio.UCSC.danRer10
library(TxDb.Drerio.UCSC.danRer10.refGene)
txdb <- TxDb.Drerio.UCSC.danRer10.refGene ## give it a short name
CDS <- prepareCDS(txdb)
```

If your assembly is Human hg38 please try to load the library,

```{r, eval=FALSE}
library(TxDb.Hsapiens.UCSC.hg38.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg38.knownGene ## give it a short name
CDS <- prepareCDS(txdb)
```

If your assembly is Mouse mm10 please try to load the library,

```{r, eval=FALSE}
library(TxDb.Mmusculus.UCSC.mm10.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm10.knownGene ## give it a short name
CDS <- prepareCDS(txdb)
```

You can also create a TxDb object from a gtf file by _txdbmaker::makeTxDbFromGFF_ function.
To get GTF file, you can download it from [ensembl](http://useast.ensembl.org/info/data/ftp/index.html)
or get the online file info via [_AnnotationHub_](#count-for-rpfs).
Here we use a prepared TxDb object for testing.

```{r loadTxDb, class.source='vig'}
## Create a small TxDb object which only contain chr1 information.
library(txdbmaker)
txdb <- makeTxDbFromGFF(system.file("extdata",
                                    "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                    package="ribosomeProfilingQC"),
                        organism = "Danio rerio",
                        chrominfo = seqinfo(Drerio)["chr1"],
                        taxonomyId = 7955)
CDS <- prepareCDS(txdb)
```

## Inputs

The input of _ribosomeProfilingQC_ is bam file. To prepare bam file,
different from _riboSeqR_ package which ask reads mapped to transcriptome, 
_ribosomeProfilingQC_ use the bam file mapped to whole genome. 
To get correctly mapped reads, first try to map adaptor trimmed sequences to 
genome assembly by bowtie2 with following parameters: 
--local --ma 5 --mp 8,4 --rdg 7,7 --rfg 7,7 --fr --nofw
and then filter the reads mapped to rRNA, tRNA, snRNA, snoRNA and misc_RNA 
from Ensembl and Repeatmasker annotations. _samtools_ will be a great method to filter the reads with following pheudoCode (only works for annotations with `transcript_biotype`).

```{r filter, eval=FALSE}
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
bamHeader <- Rsamtools::scanBamHeader(bamfilename)
(chromsomeNameStyle <- GenomeInfoDb::seqlevelsStyle(names(bamHeader[[1]]$targets)))
library(rtracklayer)
## the gtf could be downloaded from https://www.ensembl.org/info/data/ftp/index.html
## Please make sure the version number are correct.
## check the version number at https://www.ensembl.org/info/website/archives/index.html
gtf <- import(system.file("extdata",
                          "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                          package="ribosomeProfilingQC"))
gtf <- gtf[gtf$transcript_biotype %in%
             c('rRNA', 'tRNA', 'snRNA', 'snoRNA', 'misc_RNA')]
mcols(gtf) <- NULL
annotation <- 'danRer10' ## must be UCSC style, eg, GRCm38 should be mm10, GRCh38 should be hg38
rmsk <- data.table::fread(paste0('https://hgdownload.soe.ucsc.edu/goldenPath/',
                                annotation, '/database/rmsk.txt.gz'),
                          header=FALSE)
colnames(rmsk) <- c('bin', 'swScore', 'milliDiv', 'milliDel', 'milliIns',
                    'genoName', 'genoStart', 'genoEnd', 'genoLeft', 'strand',
                    'repName', 'repClass', 'repFamily', 'repStart', 'repEnd',
                    'repLeft', 'id')
rmsk_gr <- with(rmsk, GRanges(genoName, IRanges(genoStart+1, genoEnd),
                              strand = strand))
# 'UCSC' or 'ensembl', keep same as it in the bam file
GenomeInfoDb::seqlevelsStyle(gtf) <- seqlevelsStyle(rmsk_gr) <- 
  chromsomeNameStyle[1]
gr <- reduce(sort(c(gtf, rmsk_gr)))
seqlevels(gr, pruning.mode="coarse") <- 
  intersect(seqlevels(gr), names(bamHeader[[1]]$targets))
outputBed <- 'unused_regions.bed'
export(gr, outputBed)
filteredBamfileName <- sub('.bam$', '.fil.bam', bamfilename)
unusedBamfileName <- sub('.bam$', '.no_use.bam', bamfilename)
## run the cmd in terminal or by system/system2
## please make sure the samtools is available in PATH
## see more about samtools at https://www.htslib.org/
(cmd <- paste('samtools view -b -L', outputBed,
              '-U', filteredBamfileName, 
              '-o', unusedBamfileName,
              bamfilename))
system2('samtools',
  args = c('view', '-b',
           '-L', outputBed,
           '-U', filteredBamfileName,
           '-o', unusedBamfileName,
           bamfilename))
(cmd2 <- paste('samtools bam2fq', filteredBamfileName,
               '| gzip >', sub('.bam$', '.fq.gz', filteredBamfileName)))
system2('samtools',
        args = c('bam2fq', filteredBamfileName,
               '|', 'gzip', '>', sub('.bam$', '.fq.gz', filteredBamfileName)))
```


After that, map the clean reads to 
genome assembly by tophat2 with following parameters: 
--library-type fr-firststrand --transcriptome-index=Transcriptome_data/genome.
Because the library type of ribo-seq is usally strand-specific, 
please make sure to map the reads with correct library type.

```{r inputBamFile, class.source='vig'}
library(Rsamtools)
## input the bamFile from the ribosomeProfilingQC package 
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
## For your own data, please set bamfilename as your file path.
## For example, your bam file is located at C:\mydata\a.bam
## you want to set bamfilename = "C:\\mydata\\a.bam"
## or you can change your working directory by
## setwd("C:\\mydata")
## and then set bamfilename = "a.bam"
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
```

## Estimate P site

As it shown in the above figure, P site of the ribosome is in position 13 
(if using RNase I).
However, in different experiments, the P site may be shifted due to various 
experimental conditions such as the choice of enzyme and the cell type.
The `estimatePsite` function can be used to check the P site. 
The `estimatePsite` function will search start/stop codons that occur in the 
reads.
The `estimatePsite` will only use 12, 13 or 14 as best P site candidates 
when searching from the 5' end.


```{r estimatePsite, class.source='vig'}
estimatePsite(bamfile, CDS, genome)
```

It has been shown that for certain enzymes, such as MNase, 
estimating the P site from the 3’ end works much better[@mohammad2019systematically].
The `estimatePsite` will use 15, 16 or 17 as best P site candidates 
when searching from the 3' end.

```{r estimatePsite3end, class.source='vig'}
estimatePsite(bamfile, CDS, genome, anchor = "3end")
```


## Plot start/stop windows

The `readsEndPlot` function will plot the 5' end or 3' end reads shifted 
from the start/stop position of CDS.
There is no difference when assign the reading frame for most of the reads 
if you set best P site to 13 or 10 or 16 (from 5' end). 
The `readsEndPlot`
can help users to determine the real best Psite. 
In the example below, the start codon is enriched in position -9 from 
the 5' end of reads and in position 19 from the 3' end of reads. 
This means there are a lot of ribosome that are docking at the translation 
start position and most of the reads length are 28 nt.

![Ribosome docking at TSS](TSSdocking.png)


```{r readsEndPlot, fig.height=4, fig.width=6, class.source='vig'}
re <- readsEndPlot(bamfile, CDS, toStartCodon=TRUE)
readsEndPlot(re$reads, CDS, toStartCodon=TRUE, fiveEnd=FALSE)
```

If you see following distribution, that means lots of gene are in
active expression.

![Active expression](activeExpression.jpg)

If you see a warning or error message complaining about the disagreement of
chromosome sequences, please verify you are using the TxDb object with
correct genome assembly. 
If this warning message is for the patch chromosomes you are not interested,
you can ignore the warning messages.

## Read all P site coordinates

The `getPsiteCoordinates` function is used to read all P site coordinates. 
Ideally, the bestpsite should be 13. 
To test the data quality, we set bestpsite = 13.

```{r getPsiteCoordinates, class.source='vig'}
pc <- getPsiteCoordinates(bamfile, bestpsite = 13)
```

## Fragment size distribution

Ribosome-protected fragments should ideally be 27 to 29-nt long. 
To check the fragment size distribution, use the following function:

```{r readsLen, class.source='vig'}
readsLen <- summaryReadsLength(pc)
```

### Filter the reads by fragment size

To filter reads by their length for downstream analysis, 
use the following script:

```{r filterSize, class.source='vig'}
## for this QC demo, we will only use reads length of 28-29 nt.
pc.sub <- pc[pc$qwidth %in% c(28, 29)]
```


## Sense/antisense strand plot

Most of the reads should be mapped to sense strand 
because the ribo-seq library is strand-specific.

```{r strandPlot, fig.width=2,fig.height=3, class.source='vig'}
strandPlot(pc.sub, CDS)
```

## Genomic element distribution

For ribosome footprinting, most of the reads should map to the CDS region. 
The `readsDistribution` function will show the P site locations 
in different genomic elements: CDS, 5'UTR, 3'UTR, other type exon,
intron, promoter, downstream or intergenic region.
A high downstream percentage indicates that there is a high percentage 
of alternative polyAdenylation sites usage from annotation data.
A high percentage in intronic regions indicates the possibility of 
intron-retaining transcripts.

```{r readsDistribution, fig.width=7, fig.height=4, class.source='vig'}
pc.sub <- readsDistribution(pc.sub, txdb, las=2)
```

## Metagene analysis plot for 5'UTR/CDS/3'UTR

A metagene plot can indicate the reads distribution in 5'UTR, CDS and
3'UTR region.

```{r metaPlotUTR5cdsUTR3, fig.width=5, fig.height=4, class.source='vig'}
cvgs.utr5 <- coverageDepth(RPFs = bamfilename, gtf = txdb, region="utr5")
cvgs.CDS <- coverageDepth(RPFs = bamfilename, gtf = txdb, region="cds")
cvgs.utr3 <- coverageDepth(RPFs = bamfilename, gtf = txdb, region="utr3")
metaPlot(cvgs.utr5, cvgs.CDS, cvgs.utr3, sample=1)
```


## Reading frame

Function `assignReadingFrame` is used to set the reading frame for the P sites
located within the known annotated CDS.
The `plotDistance2Codon` function can be used to plot the reading frame usage 
in transcription initiation or termination sites.
Function `plotFrameDensity` can be used to collapse all the RPFs in each frame.
These plots can help you to double check if the p-site position is correct 
or not. 
If it is correct, most of the reads should be assigned to frame0.


```{r assignReadingFrame, fig.width=5, fig.height=3, class.source='vig'}
pc.sub <- assignReadingFrame(pc.sub, CDS)
plotDistance2Codon(pc.sub)
```
```{r plotFrameDensity, fig.width=2.5,fig.height=3, class.source='vig'}
plotFrameDensity(pc.sub)
```

To determine how many of raw reads are mapping with P sites in frame 0.

```{r allReadFrame, fig.width=2.5,fig.height=3, class.source='vig'}
pc <- assignReadingFrame(pc, CDS)
plotFrameDensity(pc)
```



Function `plotTranscript` can be used to view the reading frame distribution
for given transcripts.

```{r plotTranscript, fig.width=8, fig.height=6, class.source='vig'}
plotTranscript(pc.sub, c("ENSDART00000161781", "ENSDART00000166968",
                         "ENSDART00000040204", "ENSDART00000124837"))
```

## ORFscore vs coverageRate

ORFscore[@bazzini2014identification] can be used to quantify the biased 
distribution of RPFs toward the first frame of a given CDS. 
Coverage rate for whole CDS can help researchers to check the RPFs distribution
along whole CDS. 
Coverage is determined by measuring the proportion of in-frame CDS positions 
with >= 1 reads.
If coverage is about 1, the whole CDS is covered by active ribosomes.

```{r ORFscore, eval=FALSE, class.source='vig'}
cvg <- frameCounts(pc.sub, coverageRate=TRUE)
ORFscore <- getORFscore(pc.sub)
## Following code will plot the ORFscores vs coverage.
## Try it by removing the '#'. 
#plot(cvg[names(ORFscore)], ORFscore,
#     xlab="coverage ORF1", ylab="ORF score",
#     type="p", pch=16, cex=.5, xlim=c(0, 1))
```

# Bad case

Here, we show ribosome footprinting data that is poor quality data and 
should not be used for downstream analyses. 

```{r badStrandPlot, fig.width=2,fig.height=3, class.source='vig'}
bamfilename <- system.file("extdata", "RPF.chr1.bad.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite = 13)
pc.sub <- pc[pc$qwidth %in% c(27, 28, 29)]
## in this example, most of the reads mapped to the antisense strand
## which may indicate that there are some issues in the mapping step
strandPlot(pc.sub, CDS)
```
```{r badReadsDistribution, fig.width=7, fig.height=4, class.source='vig'}
## in this exaple, most of the reads mapped to inter-genic regions
## rather than the CDS, which could indicate that ribosome protected
## fragments are not being properly isolated/selected
pc.sub <- readsDistribution(pc.sub, txdb, las=2)
```
```{r badAssignReadingFrame, fig.width=5, fig.height=4, class.source='vig'}
## Selection of the proper P site is also critical.
## If we assign the wrong P site position the frame mapping will 
## likely be impacted. 
pc <- getPsiteCoordinates(bamfile, 12)
pc.sub <- pc[pc$qwidth %in% c(27, 28, 29)]
pc.sub <- assignReadingFrame(pc.sub, CDS)
plotDistance2Codon(pc.sub)
```
```{r badPlotFrameDensity, fig.width=2.5,fig.height=3, class.source='vig'}
plotFrameDensity(pc.sub)
```


# Prepare for downstream analysis

## RPFs only

### Count for RPFs

Downstream analysis including differential analysis, comparison with RNAseq,
and so on. 
Function `frameCounts` will generate a count vector for each transcript or gene, 
which can be used for differential analysis.
`countReads` can be used for count multiple files of ribo-seq.

```{r countReads, class.source='vig'}
library(ribosomeProfilingQC)
library(AnnotationDbi)
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
cnts <- countReads(RPFs, gtf=gtf, level="gene",
                   bestpsite=13, readsLen=c(28,29))
head(cnts$RPFs)
## To save the cnts, please try following codes by removing '#'
# write.csv(cbind(cnts$annotation[rownames(cnts$RPFs), ], cnts$RPFs),
#           "counts.csv")
```

To get GTF file, you can download it from [ensembl](http://useast.ensembl.org/info/data/ftp/index.html)
or get the online file info via `AnnotationHub`.

```{r prePareGTF, eval=FALSE}
BiocManager::install("AnnotationHub")
library(AnnotationHub)
ah = AnnotationHub()
## for human hg38
hg38 <- query(ah, c("Ensembl", "GRCh38", "gtf"))
hg38 <- hg38[length(hg38)]
gtf <- mcols(hg38)$sourceurl
## for mouse mm10
mm10 <- query(ah, c("Ensembl", "GRCm38", "gtf"))
mm10 <- mm10[length(mm10)]
gtf <- mcols(mm10)$sourceurl
```


### Differential analysis only for RPFs

```{r differentialByEdgeR, class.source='vig'}
library(edgeR)  ## install edgeR by BiocManager::install("edgeR")
gp <- c("KD", "KD", "CTL", "CTL") ## sample groups: KD:knockdown; CTL:Control
y <- DGEList(counts = cnts$RPFs, group = gp)
y <- calcNormFactors(y)
design <- model.matrix(~0+gp)
colnames(design) <- sub("gp", "", colnames(design))
y <- estimateDisp(y, design)
## To perform quasi-likelihood F-tests:
fit <- glmQLFit(y, design)
qlf <- glmQLFTest(fit)
topTags(qlf, n=3) # set n=nrow(qlf) to pull all results.
## To perform likelihood ratio tests:
fit <- glmFit(y, design)
lrt <- glmLRT(fit)
topTags(lrt, n=3) # set n=nrow(lrt) to pull all results.
```

### Alternative splicing, translation initiation and polyadenylation


```{r alternativeSplicing, fig.width=6, fig.height=4, class.source='vig'}
coverage <- coverageDepth(RPFs[grepl("KD1|WT", RPFs)], 
                          gtf=txdb, 
                          level="gene",
                          region="feature with extension")
group1 <- c("RPF.KD1.1", "RPF.KD1.2")
group2 <- c("RPF.WT.1", "RPF.WT.2")
## subset the data, for sample run only
coverage <- lapply(coverage, function(.ele){##do not run this for real data
  .ele$coverage <- lapply(.ele$coverage, `[`, i=seq.int(50))
  .ele$granges <- .ele$granges[seq.int(50)]
  .ele
})
se <- spliceEvent(coverage, group1, group2)
table(se$type)
plotSpliceEvent(se, se$feature[1], coverage, group1, group2)
```


## RPFs and RNA-seq

### By counts

#### Count for RPFs and RNA-seq

The `countReads` function can be used to count multiple files of ribo-seq and 
RNA-seq data.

```{r countRPFandRNA, class.source='vig'}
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
RNAs <- dir(path, "mRNA.*?\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
```
```{r countReadsRPFandRNA,eval=FALSE, class.source='vig'}
## make sure that the order of the genes listed in the bam files for RPFs
## and RNAseq data is the same.
cnts <- countReads(RPFs, RNAs, gtf, level="tx")
## To save the cnts, please try following codes by removing '#'
# rn <- cnts$annotation$GeneID
# write.csv(cbind(cnts$annotation, 
#                 cnts$RPFs[match(rn, rownames(cnts$RPFs)), ],
#                 cnts$mRNA[match(rn, rownames(cnts$mRNA)), ]),
#           "counts.csv")
```
```{r,include=FALSE}
cnts <- readRDS(file.path(path, "cnts.rds"))
```


#### Translational Efficiency (TE)

The absolute level of ribosome occupancy is strongly correlated with RNA levels 
for both coding and noncoding transcripts.
Translational efficiency is introduced[@ingolia2009genome] 
to show the correlation.
TE is the ratio of normalized ribosome footprint abundance to mRNA density.
A common normalization method is using 
Fragments Per Kilobase of transcript per Million mapped reads (FPKM).


```{r translationalEfficiency, class.source='vig'}
fpkm <- getFPKM(cnts)
TE <- translationalEfficiency(fpkm)
```

#### Differential analysis for TE

We suppose that the log2 transformed translational efficiency that 
we calculated by the ratios of RPFs to mRNAs 
has a linear correlation with real translational efficiency. 
We then use the _limma_ package to test the differential 
translational efficiency.

```{r differentialTEbyLimma, class.source='vig'}
library(limma)
gp <- c("KD", "KD", "CTL", "CTL") ## sample groups: KD:knockdown; CTL:Control
TE.log2 <- log2(TE$TE + 1)
#plot(TE.log2[, 1], TE.log2[, 3], 
#     xlab=colnames(TE.log2)[1], ylab=colnames(TE.log2)[3],
#     main="Translational Efficiency", pch=16, cex=.5)
design <- model.matrix(~0+gp)
colnames(design) <- sub("gp", "", colnames(design))
fit <- lmFit(TE.log2, design)
fit2 <- eBayes(fit)
topTable(fit2, number=3) ## set number=nrow(fit2) to pull all results
```

A different way is that we can use raw counts to test whether the 
change is coming from translation level but not transcription level.

```{r, class.source='vig'}
library(edgeR)
gp <- c("KD", "KD", "CTL", "CTL")
design <- model.matrix(~0+gp)
colnames(design) <- sub("gp", "", colnames(design))
y <- lapply(cnts[c("RPFs", "mRNA")], function(.cnt){
  .y <- DGEList(counts = .cnt, 
             samples = data.frame(gp=gp))
  .y <- calcNormFactors(.y)
  .y <- estimateDisp(.y, design)
  .y
})

## To perform likelihood ratio tests:
fit <- lapply(y, glmFit, design = design)
lrt <- lapply(fit, glmLRT)
topTags(lrt[["RPFs"]], n=3) # difference between CTL and KD for RPFs
topTags(lrt[["mRNA"]], n=3) # difference between CTL and KD for mRNA
results <- lapply(lrt, topTags, p.value = 0.05, n = nrow(lrt[[1]]))
RPFs_unique <- setdiff(rownames(results[["RPFs"]]),
                       rownames(results[["mRNA"]]))
mRNA_zero <- rownames(cnts[["mRNA"]])[rowSums(cnts[["mRNA"]]) == 0]
RPFs_unique <- RPFs_unique[!RPFs_unique %in% mRNA_zero]
head(results[["RPFs"]][RPFs_unique, ], n=3) ## top 3 events for translation level
```


### By coverage

#### Maximum N-mer translational efficiency

If we plot the correlation mRNAs or RPFs levels to translational efficiency  
calculated by all counts within a transcript,
we will find that TE is not well normalized. 
It shows a higher value in lowly expressed transcripts 
and a low value in highly expressed transcripts.

```{r plotTE, class.source='vig'}
plotTE(TE, sample=2, xaxis="mRNA", log2=TRUE)
#plotTE(TE, sample=2, xaxis="RPFs", log2=TRUE)
```

This issue can be fixed by calculating the maximum value (TE max) in the most
highly ribosome-occupied 90 nt window within a feature[@ingolia2009genome]. 
Please note that the normalization method for TE max is not FPKM any more.

```{r plotTE90, class.source='vig'}
cvgs <- coverageDepth(RPFs, RNAs, txdb)
TE90 <- translationalEfficiency(cvgs, window = 90, normByLibSize=TRUE)
plotTE(TE90, sample=2, xaxis="mRNA", log2=TRUE)
```

Above examples are TE90 for CDS region. Following codes show how to 
calculate TE90 for 3'UTR regions.

```{r, include=FALSE}
cvgs.utr3 <- coverageDepth(RPFs, RNAs, txdb, region="utr3")
```

```{r, eval=FALSE, class.source='vig'}
cvgs.utr3 <- coverageDepth(RPFs, RNAs, txdb, region="utr3")
TE90.utr3 <- translationalEfficiency(cvgs.utr3, window = 90)
## Following code will plot the TE90 for 3'UTR regions.
## Try it by removing the '#'. 
#plotTE(TE90.utr3, sample=2, xaxis="mRNA", log2=TRUE)
#plotTE(TE90.utr3, sample=2, xaxis="RPFs", log2=TRUE)
```

We can also try a different method to fix that issue by normalization the counts
of RPFs and RNAs by different methods but not FPKM.

```{r, class.source='vig'}
cnts_normByEdgeR <- normBy(cnts, method = 'edgeR')
TE_edgeR <- translationalEfficiency(cnts_normByEdgeR)
plotTE(TE_edgeR)
```

Additional method is that normalize the log2 transformed TE with mRNA counts.
```{r, class.source='vig'}
TE.log2_norm <- normalizeTEbyLoess(TE)
## please note that output is log2 transformed TE.
plotTE(TE.log2_norm, log2 = FALSE)
```

#### Ribosome Release Score (RRS)

RRS is calculated as the ratio of RPFs (normalized by RNA-seq reads) in 
the CDS to RPFs in the 3'UTR.
Because it is hard to define the CDS region for non-coding RNAs, 
RRS of non-coding RNAs can not be calculated by Function `ribosomeReleaseScore`.

```{r, eval=FALSE, class.source='vig'}
RRS <- ribosomeReleaseScore(TE90, TE90.utr3, log2 = TRUE)
## Following code will compare RSS for 2 samples.
## Try it by removing the '#'. 
#plot(RRS[, 1], RRS[, 3],
#     xlab="log2 transformed RRS of KD1", 
#     ylab="log2 transformed RRS of WT1")
## Following code will show RSS along TE90.
## Try it by removing the '#'. 
#plot(RRS[, 1], log2(TE90$TE[rownames(RRS), 1]),
#     xlab="log2 transformed RSS of KD1", 
#     ylab="log2 transformed TE of KD1")
```

#### Metagene analysis plot

Plot metagene coverage for CDS, 5'UTR and 3'UTR.
You will notice that the coverage for the RPF data is 
much more enriched in the CDS as compared to the 
corresponding RNAseq data

```{r metaPlot, class.source='vig'}
cvgs.utr5 <- coverageDepth(RPFs, RNAs, txdb, region="utr5")
## set sample to different number to plot metagene analysis 
## for different samples
#metaPlot(cvgs.utr5, cvgs, cvgs.utr3, sample=2, xaxis = "RPFs")
metaPlot(cvgs.utr5, cvgs, cvgs.utr3, sample=2, xaxis = "mRNA")
```

# Fragment Length Organization Similarity Score (FLOSS) [@ingolia2014ribosome]

FLOSS can be used to compare the distribution of reads length to
a background such as a cluster of genes.
The gene cluster could be extracted from gtf/gff files downloaded from [ensembl](http://useast.ensembl.org/info/data/ftp/index.html).

```{r eval=FALSE}
## documentation: https://useast.ensembl.org/Help/Faq?id=468
gtf <- import("Danio_rerio.GRCz10.91.gtf.gz")
```
The gtf files can be also download via `AnnotationHub`

```{r eval=FALSE}
BiocManager::install("AnnotationHub")
library(AnnotationHub)
ah = AnnotationHub()
## for human hg38
hg38 <- query(ah, c("Ensembl", "GRCh38", "gtf"))
hg38 <- hg38[[length(hg38)]]
## for mouse mm10
mm10 <- query(ah, c("Ensembl", "GRCm38", "gtf"))
mm10 <- mm10[[length(mm10)]]
## because the gene ids in TxDb.Mmusculus.UCSC.mm10.knownGene and
## TxDb.Hsapiens.UCSC.hg38.knownGene
## are entriz_id, the gene_id in mm10 or hg38 need to changed to entriz_id.
library(ChIPpeakAnno)
library(org.Mm.eg.db)
mm10$gene_id <- ChIPpeakAnno::xget(mm10$gene_id, org.Mm.egENSEMBL2EG)
library(org.Hg.eg.db)
hg38$gene_id <- ChIPpeakAnno::xget(hg38$gene_id, org.Mm.egENSEMBL2EG)
```

```{r eval=FALSE}
gtf <- gtf[!is.na(gtf$gene_id)]
gtf <- gtf[gtf$gene_id!=""]
## protein coding
protein <- 
  gtf$gene_id[gtf$transcript_biotype %in% 
                  c("IG_C_gene", "IG_D_gene", "IG_J_gene", "IG_LV_gene", 
                    "IG_M_gene", "IG_V_gene", "IG_Z_gene", 
                    "nonsense_mediated_decay", "nontranslating_CDS", 
                    "non_stop_decay", 
                    "protein_coding", "TR_C_gene", "TR_D_gene", "TR_gene", 
                    "TR_J_gene", "TR_V_gene")]
## mitochondrial genes
mito <- gtf$gene_id[grepl("^mt\\-", gtf$gene_name) | 
                        gtf$transcript_biotype %in% c("Mt_tRNA", "Mt_rRNA")]
## long noncoding
lincRNA <- 
  gtf$gene_id[gtf$transcript_biotype %in% 
                  c("3prime_overlapping_ncrna", "lincRNA", 
                    "ncrna_host", "non_coding")]
## short noncoding
sncRNA <- 
  gtf$gene_id[gtf$transcript_biotype %in% 
                  c("miRNA", "miRNA_pseudogene", "misc_RNA", 
                    "misc_RNA_pseudogene", "Mt_rRNA", "Mt_tRNA", 
                    "Mt_tRNA_pseudogene", "ncRNA", "pre_miRNA", 
                    "RNase_MRP_RNA", "RNase_P_RNA", "rRNA", "rRNA_pseudogene", 
                    "scRNA_pseudogene", "snlRNA", "snoRNA", 
                    "snRNA_pseudogene", "SRP_RNA", "tmRNA", "tRNA",
                    "tRNA_pseudogene", "ribozyme", "scaRNA", "sRNA")]
## pseudogene
pseudogene <- 
  gtf$gene_id[gtf$transcript_biotype %in% 
                  c("disrupted_domain", "IG_C_pseudogene", "IG_J_pseudogene", 
                    "IG_pseudogene", "IG_V_pseudogene", "processed_pseudogene", 
                    "pseudogene", "transcribed_processed_pseudogene",
                    "transcribed_unprocessed_pseudogene", 
                    "translated_processed_pseudogene", 
                    "translated_unprocessed_pseudogene", "TR_J_pseudogene", 
                    "TR_V_pseudogene", "unitary_pseudogene", 
                    "unprocessed_pseudogene")]
danrer10.annotations <- list(protein=unique(protein), 
                             mito=unique(mito),
                             lincRNA=unique(lincRNA),
                             pseudogene=unique(pseudogene))
```

Here we load the pre-saved chr1 annotations for sample codes.
```{r loadPresavedAnnotations, class.source='vig'}
danrer10.annotations <- 
  readRDS(system.file("extdata",
                      "danrer10.annotations.rds",
                      package = "ribosomeProfilingQC"))
```

```{r, fig.width=4, fig.height=4, class.source='vig'}
library(ribosomeProfilingQC)
library(txdbmaker)
## prepare CDS annotation
txdb <- makeTxDbFromGFF(system.file("extdata",
                                    "Danio_rerio.GRCz10.91.chr1.gtf.gz",
                                    package="ribosomeProfilingQC"),
                        organism = "Danio rerio",
                        chrominfo = seqinfo(Drerio)["chr1"],
                        taxonomyId = 7955)
CDS <- prepareCDS(txdb)

library(Rsamtools)
## input the bamFile from the ribosomeProfilingQC package 
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
## For your own data, please set bamfilename as your file path.
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)

pc <- getPsiteCoordinates(bamfile, bestpsite = 13)
readsLengths <- 20:34
fl <- FLOSS(pc, ref = danrer10.annotations$protein, 
            CDS = CDS, readLengths=readsLengths, level="gene", draw = FALSE)
fl.max <- t(fl[c(1, which.max(fl$cooks.distance)), as.character(readsLengths)])
matplot(fl.max, type = "l", x=readsLengths, 
        xlab="Fragment Length", ylab="Fraction of Reads", 
        col = c("gray", "red"), lwd = 2, lty = 1)
legend("topright",  legend = c("ref", "selected gene"), 
       col = c("gray", "red"), lwd = 2, lty = 1, cex=.5)
```


# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimatePsite.R
\name{estimatePsite}
\alias{estimatePsite}
\title{Estimate P site position}
\usage{
estimatePsite(
  bamfile,
  CDS,
  genome,
  anchor = "5end",
  readLen = c(25:30),
  ignore.seqlevelsStyle = FALSE
)
}
\arguments{
\item{bamfile}{A BamFile object.}

\item{CDS}{Output of \link{prepareCDS}}

\item{genome}{A BSgenome object.}

\item{anchor}{5end or 3end. Default is 5end.}

\item{readLen}{The reads length used to estimate.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}
}
\value{
A best P site position.
}
\description{
Estimate P site position from a subset reads.
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
#txdb <- makeTxDbFromGFF(system.file("extdata",
 #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
 #         package="ribosomeProfilingQC"),
 #         organism = "Danio rerio",
 #         chrominfo = seqinfo(Drerio)["chr1"],
 #         taxonomyId = 7955)
#CDS <- prepareCDS(txdb)
CDS <- readRDS(system.file("extdata", "CDS.rds",
                           package="ribosomeProfilingQC"))
estimatePsite(bamfile, CDS, Drerio)

}
\references{
1: Bazzini AA, Johnstone TG, Christiano R, Mackowiak SD, Obermayer B,
Fleming ES, Vejnar CE, Lee MT, Rajewsky N, Walther TC, Giraldez AJ.
Identification of small ORFs in vertebrates using ribosome footprinting and
evolutionary conservation. EMBO J. 2014 May 2;33(9):981-93.
doi: 10.1002/embj.201488411. Epub 2014 Apr 4.
PubMed PMID: 24705786; PubMed Central PMCID: PMC4193932.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normByRUVs.R
\name{normByRUVs}
\alias{normByRUVs}
\title{Normalization by RUVSeq}
\usage{
normByRUVs(counts, RPFgroup, mRNAgroup = RPFgroup, k = 1)
}
\arguments{
\item{counts}{Output of \link{countReads}}

\item{RPFgroup, mRNAgroup}{Groups for RPF and mRNA files}

\item{k}{The number of factor of unwanted variation to be estimated from
the data. See \link[RUVSeq:RUVs]{RUVs}}
}
\value{
Normalized counts list
}
\description{
Normalization by RUVSeq:RUVs methods
}
\examples{
\dontrun{##waiting for EDASeq fix the issue.
path <- system.file("extdata", package="ribosomeProfilingQC")
#RPFs <- dir(path, "RPF.*?.[12].bam$", full.names=TRUE)
#RNAs <- dir(path, "mRNA.*?.[12].bam$", full.names=TRUE)
#gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#cnts <- countReads(RPFs, RNAs, gtf, level="gene")
cnts <- readRDS(file.path(path, "cnts.rds"))
gp <- c("KD1", "KD1", "WT", "WT")
norm <- normByRUVs(cnts, gp, gp)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/codonBias.R
\name{codonBias}
\alias{codonBias}
\title{Codon usage bias}
\usage{
codonBias(
  RPFs,
  gtf,
  genome,
  bestpsite = 13,
  readsLen = c(28, 29),
  anchor = "5end",
  ignore.seqlevelsStyle = FALSE,
  summary = TRUE,
  removeDuplicates = TRUE,
  ...
)
}
\arguments{
\item{RPFs}{Bam file names of RPFs.}

\item{gtf}{GTF file name for annotation or a TxDb object.}

\item{genome}{A BSgenome object.}

\item{bestpsite}{P site postion.}

\item{readsLen}{Reads length to keep.}

\item{anchor}{5end or 3end. Default is 5end.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}

\item{summary}{Return the summary of codon usage bias or full list.}

\item{removeDuplicates}{Remove the PCR duplicates or not. Default TRUE.}

\item{...}{Parameters pass to
\link[txdbmaker:makeTxDbFromGFF]{makeTxDbFromGFF}}
}
\value{
A list of data frame of codon count table if summary is TRUE.
 list 'reads' means the counts by raw reads.
 list 'reference' means the counts by sequence extracted from reference by
 the coordinates of mapped reads.
 Otherwise, return the counts (reads/reference) table for each reads.
}
\description{
Calculate the codon usage for the reads in the identified CDSs.
And then compared to the reference codon usage.
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
library(BSgenome.Drerio.UCSC.danRer10)
cb <- codonBias(RPFs[c(1,2)], gtf=gtf, genome=Drerio)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotTE.R
\name{plotTE}
\alias{plotTE}
\title{Plot translational efficiency}
\usage{
plotTE(
  TE,
  sample,
  xaxis = c("mRNA", "RPFs"),
  removeZero = TRUE,
  log2 = TRUE,
  theme = theme_classic(),
  type = "histogram",
  margins = "y",
  ...
)
}
\arguments{
\item{TE}{Output of \link{translationalEfficiency}}

\item{sample}{Sample names to plot.}

\item{xaxis}{What to plot for x-axis.}

\item{removeZero}{Remove the 0 values from plots.}

\item{log2}{Do log2 transform for TE or not.}

\item{theme}{Theme for ggplot2.}

\item{type, margins, ...}{Parameters pass to ggMarginal}
}
\value{
A ggExtraPlot object.
}
\description{
Scatterplot of RNA/RPFs level compared to the
translational efficiency.
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
#RPFs <- dir(path, "RPF.*?\\.[12].bam$", full.names=TRUE)
#RNAs <- dir(path, "mRNA.*?\\.[12].bam$", full.names=TRUE)
#gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#cnts <- countReads(RPFs, RNAs, gtf, level="gene")
cnts <- readRDS(file.path(path, "cnts.rds"))
fpkm <- getFPKM(cnts)
te <- translationalEfficiency(fpkm)
plotTE(te, 1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDistance2Codon.R
\name{plotDistance2Codon}
\alias{plotDistance2Codon}
\title{Metaplot of P site distribution}
\usage{
plotDistance2Codon(
  reads,
  start = TRUE,
  anchor = 50,
  col = c(Frame_0 = "#009E73", Frame_1 = "#D55E00", Frame_2 = "#0072B2")
)
}
\arguments{
\item{reads}{Output of \link{assignReadingFrame}.}

\item{start}{Plot for start codon or stop codon.}

\item{anchor}{The maximal xlim or (min, max) position for plot.}

\item{col}{Colors for different reading frame.}
}
\value{
Invisible height of the barplot.
}
\description{
Metaplot of P site distribution in all the CDS aligned by
the start codon or stop codon.
}
\examples{
pcs <- readRDS(system.file("extdata", "samplePc.rds",
               package="ribosomeProfilingQC"))
plotDistance2Codon(pcs)
#plotDistance2Codon(pcs, start=FALSE)
#plotDistance2Codon(pcs, anchor=c(-10, 20))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countReads.R
\name{countReads}
\alias{countReads}
\title{Extract counts for RPFs and RNAs}
\usage{
countReads(
  RPFs,
  RNAs,
  gtf,
  level = c("tx", "gene"),
  bestpsite = 13,
  readsLen = c(28, 29),
  anchor = "5end",
  ignore.seqlevelsStyle = FALSE,
  ...
)
}
\arguments{
\item{RPFs}{Bam file names of RPFs.}

\item{RNAs}{Bam file names of RNAseq.}

\item{gtf}{GTF file name for annotation.}

\item{level}{Transcript or gene level.}

\item{bestpsite}{numeric(1). P site postion.}

\item{readsLen}{numeric(1). reads length to keep.}

\item{anchor}{5end or 3end. Default is 5end.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}

\item{...}{Parameters pass to \link[Rsubread:featureCounts]{featureCounts} 
except isGTFAnnotationFile, GTF.attrType, and annot.ext.}
}
\value{
A list with reads counts.
}
\description{
Calculate the reads counts for gene level or transcript level.
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
RNAs <- dir(path, "mRNA.*?.[12].bam$", full.names = TRUE)
cnts <- countReads(RPFs[1], gtf=gtf, level="gene", readsLen=29)
#cnts <- countReads(RPFs[1], RNAs[1], gtf=gtf, level="gene", readsLen=29)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normBy.R
\name{normBy}
\alias{normBy}
\title{Normalization by edgeR, DESeq2 or RUVSeq}
\usage{
normBy(counts, method = c("edgeR", "DESeq2", "RUVs", "fpkm", "vsn"), ...)
}
\arguments{
\item{counts}{Output of \link{countReads}}

\item{method}{Character(1L) to indicate the method for normalization.}

\item{...}{parameters will be passed to \link{normByRUVs} or \link{getFPKM}}
}
\value{
Normalized counts list
}
\description{
Normalization by multiple known methods
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
cnts <- readRDS(file.path(path, "cnts.rds"))
norm <- normBy(cnts, method = 'edgeR')
norm2 <- normBy(cnts, method = 'DESeq2')
norm3 <- normBy(cnts, 'vsn')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readsEndPlot.R
\name{readsEndPlot}
\alias{readsEndPlot}
\title{Plot start/stop windows}
\usage{
readsEndPlot(
  bamfile,
  CDS,
  toStartCodon = TRUE,
  fiveEnd = TRUE,
  shift = 0,
  window = c(-29, 30),
  readLen = 25:30,
  ignore.seqlevelsStyle = FALSE
)
}
\arguments{
\item{bamfile}{A BamFile object.}

\item{CDS}{Output of \link{prepareCDS}}

\item{toStartCodon}{What to search: start or end codon}

\item{fiveEnd}{Search from five or three ends of the reads.}

\item{shift}{number(1). Search from 5' end or 3' end of given number.
if fiveEnd set to false, please set the shift as a negative number.}

\item{window}{The window of CDS region to plot}

\item{readLen}{The reads length used to plot}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}
}
\value{
The invisible list with counts numbers and reads in GRanges.
}
\description{
Plot the reads shifted from start/stop position of CDS.
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
#library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
#txdb <- makeTxDbFromGFF(system.file("extdata",
 #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
 #         package="ribosomeProfilingQC"),
 #         organism = "Danio rerio",
 #         chrominfo = seqinfo(Drerio)["chr1"],
 #         taxonomyId = 7955)
#CDS <- prepareCDS(txdb)
CDS <- readRDS(system.file("extdata", "CDS.rds",
                           package="ribosomeProfilingQC"))
re <- readsEndPlot(bamfile, CDS, toStartCodon=TRUE)
readsEndPlot(re$reads, CDS, toStartCodon=TRUE, fiveEnd=FALSE)
#re <- readsEndPlot(bamfile, CDS, toStartCodon=FALSE)
#readsEndPlot(re$reads, CDS, toStartCodon=FALSE, fiveEnd=FALSE)
readsEndPlot(bamfile, CDS, shift=13)
#readsEndPlot(bamfile, CDS, fiveEnd=FALSE, shift=-16)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulateRPF.R
\name{simulateRPF}
\alias{simulateRPF}
\title{Simulation function}
\usage{
simulateRPF(
  txdb,
  outPath,
  genome,
  samples = 6,
  group1 = c(1, 2, 3),
  group2 = c(4, 5, 6),
  readsPerSample = 1e+06,
  readsLen = 28,
  psite = 13,
  frame0 = 0.9,
  frame1 = 0.05,
  frame2 = 0.05,
  DEregions = GRanges(),
  size = 1,
  sd = 0.02,
  minDElevel = log2(2),
  includeReadsSeq = FALSE
)
}
\arguments{
\item{txdb}{A TxDb object}

\item{outPath}{Output folder for the bam files}

\item{genome}{A BSgenome object}

\item{samples}{Total samples to simulate.}

\item{group1, group2}{Numeric to index the sample groups.}

\item{readsPerSample}{Total reads number per sample.}

\item{readsLen}{Reads length, default 100bp.}

\item{psite}{P-site position. default 13.}

\item{frame0, frame1, frame2}{Percentage of reads distribution in
frame0, frame1 and frame2}

\item{DEregions}{The regions with differential reads in exon,
utr5 and utr3.}

\item{size}{Dispersion parameter. Must be strictly positive.}

\item{sd}{Standard deviations.}

\item{minDElevel}{Minimal differential level. default: log2(2).}

\item{includeReadsSeq}{logical(1). Include reads sequence or not.}
}
\value{
An invisible list of GAlignments.
}
\description{
Simulate the RPFs reads in CDS, 5'UTR and 3'UTR
}
\examples{
library(GenomicFeatures)
txdb_file <- system.file("extdata", "Biomart_Ensembl_sample.sqlite",
                         package="GenomicFeatures")
txdb <- loadDb(txdb_file)
simulateRPF(txdb, samples=1, readsPerSample = 1e3)
\dontrun{
cds <- prepareCDS(txdb, withUTR = TRUE)
cds <- cds[width(cds)>200]
DEregions <- cds[sample(seq_along(cds), 10)]
simulateRPF(txdb, samples=6, readsPerSample = 1e5, DEregions=DEregions)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coverageRates.R
\name{coverageRates}
\alias{coverageRates}
\title{Calculate coverage rate}
\usage{
coverageRates(cvgs, RPFsampleOrder, mRNAsampleOrder)
}
\arguments{
\item{cvgs}{Output of \link{coverageDepth}}

\item{RPFsampleOrder, mRNAsampleOrder}{Sample order of RPFs and mRNAs.
The parameters are used to make sure that the order of RPFs and mRNAs
in cvgs is corresponding samples.}
}
\value{
A list with coverage rate.
}
\description{
Coverage is a measure as percentage of position
with reads along the CDS.
Coverage rate calculate coverage rate for RPFs and mRNAs in gene level.
Coverage will be calculated based on best P sites
for RPFs and 5'end for RNA-seq.
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
cvgs <- coverageDepth(RPFs[1], gtf=gtf, level="gene")
cr <- coverageRates(cvgs)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readsDistribution.R
\name{readsDistribution}
\alias{readsDistribution}
\title{Plot reads distribution in genomic elements}
\usage{
readsDistribution(
  reads,
  txdb,
  upstreamRegion = 3000,
  downstreamRegion = 3000,
  plot = TRUE,
  precedence = NULL,
  ignore.seqlevelsStyle = FALSE,
  ...
)
}
\arguments{
\item{reads}{Output of \link{getPsiteCoordinates}}

\item{txdb}{A TxDb object}

\item{upstreamRegion, downstreamRegion}{The range for promoter region and
downstream region.}

\item{plot}{Plot the distribution or not}

\item{precedence}{If no precedence specified, double count will be enabled,
which means that if the reads overlap with both CDS and 5'UTR, both
CDS and 5'UTR will be incremented. If a precedence order is specified,
for example, if promoter is specified before 5'UTR, then only promoter will
be incremented for the same example.  The values could be any combinations
of "CDS", "UTR5", "UTR3", "OtherExon", "Intron", "upstream", "downstreama"
and "InterGenic", Default=NULL}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}

\item{...}{Not use.}
}
\value{
The reads with distribution assignment
}
\description{
Plot the percentage of reads in CDS, 5'UTR, 3'UTR, introns, and
 other elements.
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite=11)
pc.sub <- pc[pc$qwidth \%in\% c(29, 30)]
library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
txdb <- makeTxDbFromGFF(system.file("extdata",
          "Danio_rerio.GRCz10.91.chr1.gtf.gz",
          package="ribosomeProfilingQC"),
          organism = "Danio rerio",
          chrominfo = seqinfo(Drerio)["chr1"],
          taxonomyId = 7955)
pc.sub <- readsDistribution(pc.sub, txdb, las=2)
pc.sub <- readsDistribution(pc[pc$qwidth \%in\% c(29, 30)],
              txdb, las=2,
              precedence=c(
              "CDS", "UTR5", "UTR3", "OtherExon",
              "Intron", "upstream", "downstream",
              "InterGenic"
              ))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotTranscript.R
\name{plotTranscript}
\alias{plotTranscript}
\title{Plot reads P site abundance for a specific transcript}
\usage{
plotTranscript(
  reads,
  tx_name,
  col = c(Frame_0 = "#009E73", Frame_1 = "#D55E00", Frame_2 = "#0072B2")
)
}
\arguments{
\item{reads}{Output of \link{assignReadingFrame}}

\item{tx_name}{Transcript names.}

\item{col}{Colors for reading frames}
}
\value{
Invisible heights of the barplot.
}
\description{
Plot the bundances of P site on a transcript.
}
\examples{
pcs <- readRDS(system.file("extdata", "samplePc.rds",
               package="ribosomeProfilingQC"))

plotTranscript(pcs, c("ENSDART00000152562", "ENSDART00000054987"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepareCDS.R
\name{prepareCDS}
\alias{prepareCDS}
\title{Prepare CDS}
\usage{
prepareCDS(txdb, withUTR = FALSE)
}
\arguments{
\item{txdb}{A TxDb object.}

\item{withUTR}{Including UTR information or not.}
}
\value{
A GRanges object with metadata which include:
tx_id: transcript id;
tx_name: transcript name;
gene_id: gene id;
isFirstExonInCDS: is first exon in CDS or not;
idFirstExonInCDS: the id for the first exon;
isLastExonInCDS: is last exon in CDS or not;
wid.cumsu: cumulative sums of number of bases in CDS;
internalPos: offset position from 1 base;
}
\description{
Prepare CDS library from a TxDb object.
}
\examples{
library(GenomicFeatures)
txdb_file <- system.file("extdata", "Biomart_Ensembl_sample.sqlite",
                         package="GenomicFeatures")
txdb <- loadDb(txdb_file)
CDS <- prepareCDS(txdb)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggBar.R
\name{ggBar}
\alias{ggBar}
\title{barplot by ggplot2}
\usage{
ggBar(height, fill = "gray80", draw = TRUE, xlab, ylab, postfix)
}
\arguments{
\item{height}{data for plot}

\item{fill, xlab, ylab}{parameters pass to ggplot.}

\item{draw}{plot or not}

\item{postfix}{Postfix of text labled in top of bar.}
}
\value{
ggplot object.
}
\description{
barplot with number in top.
}
\examples{
ribosomeProfilingQC:::ggBar(sample.int(100, 3))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getORFscore.R
\name{getORFscore}
\alias{getORFscore}
\title{Calculate ORFscore}
\usage{
getORFscore(reads)
}
\arguments{
\item{reads}{Output of \link{getPsiteCoordinates}}
}
\value{
A numeric vector with ORFscore.
}
\description{
To calculate the ORFscore, reads were counnted at each position
within the ORF.
\deqn{ORFscore = log_2((\sum_{n=1}^{3}\frac{(F_i-\bar{F})^2}{\bar{F}}) + 1)}
where \eqn{F_n} is the number of reads in reading frame n,
\eqn{\bar{F}} is the total number of reads across all three frames
divided by 3.
If \eqn{F_1} is smaller than \eqn{F_2} or \eqn{F_3},
\eqn{ORFscore = -1 X ORFscore}.
}
\examples{
pcs <- readRDS(system.file("extdata", "samplePc.rds",
               package="ribosomeProfilingQC"))
ORFscore <- getORFscore(pcs)
}
\references{
1: Bazzini AA, Johnstone TG, Christiano R, Mackowiak SD, Obermayer B,
Fleming ES, Vejnar CE, Lee MT, Rajewsky N, Walther TC, Giraldez AJ.
Identification of small ORFs in vertebrates using ribosome footprinting and
evolutionary conservation.
EMBO J. 2014 May 2;33(9):981-93.
doi: 10.1002/embj.201488411. Epub 2014 Apr 4.
PubMed PMID: 24705786; PubMed Central PMCID: PMC4193932.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/codonUsage.R
\name{codonUsage}
\alias{codonUsage}
\title{Start or Stop codon usage}
\usage{
codonUsage(reads, start = TRUE, genome)
}
\arguments{
\item{reads}{Output of \link{assignReadingFrame}.}

\item{start}{Calculate for start codon or stop codon.}

\item{genome}{A BSgenome object.}
}
\value{
Table of codon usage.
}
\description{
Calculate the start or stop codon usage for the identified CDSs.
}
\examples{
pcs <- readRDS(system.file("extdata", "samplePc.rds",
               package="ribosomeProfilingQC"))
library(BSgenome.Drerio.UCSC.danRer10)
codonUsage(pcs, genome=Drerio)
codonUsage(pcs, start=FALSE, genome=Drerio)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cvgd.R
\docType{class}
\name{cvgd-class}
\alias{cvgd-class}
\alias{cvgd}
\alias{$,cvgd-method}
\alias{$<-,cvgd-method}
\alias{[[,cvgd,ANY,ANY-method}
\alias{[[<-,cvgd,ANY,ANY,ANY-method}
\alias{show,cvgd-method}
\title{Class \code{"cvgd"}}
\usage{
cvgd(...)

\S4method{$}{cvgd}(x, name)

\S4method{$}{cvgd}(x, name) <- value

\S4method{[[}{cvgd,ANY,ANY}(x, i, j, ..., exact = TRUE)

\S4method{[[}{cvgd,ANY,ANY,ANY}(x, i, j, ...) <- value

\S4method{show}{cvgd}(object)
}
\arguments{
\item{\dots}{Each argument in \dots becomes an slot in the new
\code{"cvgd"}-class.}

\item{x}{cvgd object.}

\item{name}{A literal character string or a name (possibly backtick quoted).}

\item{value}{value to replace.}

\item{i, j}{indexes specifying elements to extract or replace.}

\item{exact}{see \link[base]{Extract}}

\item{object}{cvgd object.}
}
\value{
A cvgd object.
}
\description{
An object of class \code{"cvgd"}
represents output of \code{coverageDepth}.
}
\section{Slots}{

\describe{
\item{\code{coverage}}{\code{"list"}, list of
\link[IRanges:AtomicList-class]{CompressedRleList},
specify the coverage of features of each sample.}

\item{\code{granges}}{\link[GenomicRanges:GRangesList-class]{CompressedGRangesList},
specify the features.}
}}

\examples{
cvgd()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaryReadsLength.R
\name{summaryReadsLength}
\alias{summaryReadsLength}
\title{Summary the reads lengths}
\usage{
summaryReadsLength(reads, widthRange = c(20:35), plot = TRUE, ...)
}
\arguments{
\item{reads}{Output of getPsiteCoordinates}

\item{widthRange}{The reads range to be plot}

\item{plot}{Do plot or not}

\item{...}{Not use.}
}
\value{
The reads length distribution
}
\description{
Plot the reads length distribution
}
\examples{
reads <- GRanges("chr1", ranges=IRanges(seq.int(100), width=1),
                 qwidth=sample(25:31, size = 100, replace = TRUE,
                               prob = c(.01, .01, .05, .1, .77, .05, .01)))
summaryReadsLength(reads)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readsLenToKeep.R
\name{readsLenToKeep}
\alias{readsLenToKeep}
\title{Get reads length to keep by cutoff percentage}
\usage{
readsLenToKeep(readsLengthDensity, cutoff = 0.8)
}
\arguments{
\item{readsLengthDensity}{Output of \link{summaryReadsLength}}

\item{cutoff}{Cutoff value.}
}
\value{
Reads length to be kept.
}
\description{
Set the percentage to filter the reads.
}
\examples{
reads <- GRanges("chr1", ranges=IRanges(seq.int(100), width=1),
                 qwidth=sample(25:31, size = 100, replace = TRUE,
                               prob = c(.01, .01, .05, .1, .77, .05, .01)))
readsLenToKeep(summaryReadsLength(reads, plot=FALSE))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getPsiteCoordinates.R
\name{getPsiteCoordinates}
\alias{getPsiteCoordinates}
\title{Get P site coordinates}
\usage{
getPsiteCoordinates(
  bamfile,
  bestpsite,
  anchor = "5end",
  param = ScanBamParam(what = c("qwidth"), tag = character(0), flag =
    scanBamFlag(isSecondaryAlignment = FALSE, isUnmappedQuery = FALSE,
    isNotPassingQualityControls = FALSE, isSupplementaryAlignment = FALSE))
)
}
\arguments{
\item{bamfile}{A BamFile object.}

\item{bestpsite}{P site postion. See \link{estimatePsite}}

\item{anchor}{5end or 3end. Default is 5end.}

\item{param}{A ScanBamParam object. Please note the 'qwidth' is required.}
}
\value{
A GRanges object with qwidth metadata which indicates the width
of reads.
}
\description{
Extract P site coordinates from a bam file to a GRanges object.
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite=13)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSpliceEvent.R
\name{plotSpliceEvent}
\alias{plotSpliceEvent}
\title{Plot splice event}
\usage{
plotSpliceEvent(
  se,
  tx_name,
  coverage,
  group1,
  group2,
  cutoffFDR = 0.05,
  resetIntronWidth = TRUE
)
}
\arguments{
\item{se}{Output of \link{spliceEvent}}

\item{tx_name}{Transcript name.}

\item{coverage}{Coverages of feature region with extensions.
Output of \link{coverageDepth}}

\item{group1, group2}{The sample names of group 1 and group 2}

\item{cutoffFDR}{Cutoff of FDR}

\item{resetIntronWidth}{logical(1). If set to true,
reset the region with no read to minimal width.}
}
\value{
A ggplot object.
}
\description{
Plot the splice event
}
\examples{
\dontrun{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
coverage <- coverageDepth(RPFs, gtf=gtf, level="gene",
                          region="feature with extension")
group1 <- c("RPF.KD1.1", "RPF.KD1.2")
group2 <- c("RPF.WT.1", "RPF.WT.2")
se <- spliceEvent(coverage, group1, group2)
plotSpliceEvent(se, se$feature[1], coverage, group1, group2)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coverageDepth.R
\name{coverageDepth}
\alias{coverageDepth}
\title{Extract coverage depth for gene level or transcript level}
\usage{
coverageDepth(
  RPFs,
  RNAs,
  gtf,
  level = c("tx", "gene"),
  bestpsite = 13,
  readsLen = c(28, 29),
  anchor = "5end",
  region = "cds",
  ext = 5000,
  ignore.seqlevelsStyle = FALSE,
  ...
)
}
\arguments{
\item{RPFs}{Bam file names of RPFs.}

\item{RNAs}{Bam file names of RNAseq.}

\item{gtf}{GTF file name for annotation or a TxDb object.}

\item{level}{Transcript or gene level.}

\item{bestpsite}{P site postion.}

\item{readsLen}{Reads length to keep.}

\item{anchor}{5end or 3end. Default is 5end.}

\item{region}{Annotation region. It could be "cds", "utr5", "utr3",
"exon", "transcripts", "feature with extension".}

\item{ext}{Extesion region for "feature with extension".}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}

\item{...}{Parameters pass to
\link[txdbmaker:makeTxDbFromGFF]{makeTxDbFromGFF}}
}
\value{
A cvgd object with coverage depth.
}
\description{
Calculate the coverage depth for gene level or transcript level.
Coverage for RPFs will be the best P site coverage.
Coverage for RNAs will be the coverage for 5'end of reads.
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
cvgs <- coverageDepth(RPFs[1], gtf=gtf, level="gene")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/strandPlot.R
\name{strandPlot}
\alias{strandPlot}
\title{Plot the distribution of reads in sense and antisense strand}
\usage{
strandPlot(
  reads,
  CDS,
  col = c("#009E73", "#D55E00"),
  ignore.seqlevelsStyle = FALSE,
  ...
)
}
\arguments{
\item{reads}{Output of \link{getPsiteCoordinates}}

\item{CDS}{Output of \link{prepareCDS}}

\item{col}{Coloar for sense and antisense strand.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}

\item{...}{Parameter passed to barplot}
}
\value{
A ggplot object.
}
\description{
Plot the distribution of reads in sense and antisense strand to
check the mapping is correct.
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite=11)
pc.sub <- pc[pc$qwidth \%in\% c(29, 30)]
library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
txdb <- makeTxDbFromGFF(system.file("extdata",
          "Danio_rerio.GRCz10.91.chr1.gtf.gz",
          package="ribosomeProfilingQC"),
          organism = "Danio rerio",
          chrominfo = seqinfo(Drerio)["chr1"],
          taxonomyId = 7955)
CDS <- prepareCDS(txdb)
strandPlot(pc.sub, CDS)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getFPKM.R
\name{getFPKM}
\alias{getFPKM}
\title{Get FPKM values for counts}
\usage{
getFPKM(counts, gtf, level = c("gene", "tx"))
}
\arguments{
\item{counts}{Output of \link{countReads} or \link{normByRUVs}}

\item{gtf}{GTF file name for annotation.}

\item{level}{Transcript or gene level.}
}
\value{
A list with FPKMs
}
\description{
Calculate Fragments Per Kilobase of transcript per
Million mapped reads (FPKM) for counts.
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
#RPFs <- dir(path, "RPF.*?.[12].bam$", full.names=TRUE)
#RNAs <- dir(path, "mRNA.*?.[12].bam$", full.names=TRUE)
#gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
#cnts <- countReads(RPFs, RNAs, gtf, level="gene")
cnts <- readRDS(file.path(path, "cnts.rds"))
fpkm <- getFPKM(cnts)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FLOSS.R
\name{FLOSS}
\alias{FLOSS}
\title{Fragment Length Organization Similarity Score (FLOSS)}
\usage{
FLOSS(
  reads,
  ref,
  CDS,
  readLengths = c(26:34),
  level = c("tx", "gene"),
  draw = FALSE,
  ignore.seqlevelsStyle = FALSE
)
}
\arguments{
\item{reads}{Output of \link{getPsiteCoordinates}}

\item{ref}{Refercence id list. If level is set to tx, the id should be
transcript names. If level is set to gene, the id should be gene id.}

\item{CDS}{Output of \link{prepareCDS}}

\item{readLengths}{Read length used for calculation}

\item{level}{Transcript or gene level}

\item{draw}{Plot FLOSS vs total reads or not.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}
}
\value{
A data frame with colnames as id, FLOSS, totalReads,
wilcox.test.pval, cook's distance.
}
\description{
The FLOSS will be calculated from a histogram of
read lengths for footprints on a transcript or reading frame.
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite=13)
#library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
#txdb <- makeTxDbFromGFF(system.file("extdata",
 #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
 #         package="ribosomeProfilingQC"),
 #         organism = "Danio rerio",
 #         chrominfo = seqinfo(Drerio)["chr1"],
 #         taxonomyId = 7955)
#CDS <- prepareCDS(txdb)
CDS <- readRDS(system.file("extdata", "CDS.rds",
                           package="ribosomeProfilingQC"))
set.seed(123)
ref <- sample(unique(CDS$gene_id), 100)
fl <- FLOSS(pc, ref, CDS, level="gene")
}
\references{
1: Ingolia NT, Brar GA, Stern-Ginossar N, Harris MS,
Talhouarne GJ, Jackson SE, Wills MR, Weissman JS. Ribosome profiling
reveals pervasive translation outside
of annotated protein-coding genes. Cell Rep. 2014 Sep 11;8(5):1365-79. doi:
10.1016/j.celrep.2014.07.045. Epub 2014 Aug 21. PubMed PMID: 25159147; PubMed
Central PMCID: PMC4216110.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ribosomeReleaseScore.R
\name{ribosomeReleaseScore}
\alias{ribosomeReleaseScore}
\title{Ribosome Release Score (RRS)}
\usage{
ribosomeReleaseScore(
  cdsTE,
  utr3TE,
  CDSsampleOrder,
  UTR3sampleOrder,
  pseudocount = 0,
  log2 = FALSE
)
}
\arguments{
\item{cdsTE, utr3TE}{Translational efficiency of CDS and UTR3 region.
Output of \link{translationalEfficiency}}

\item{CDSsampleOrder, UTR3sampleOrder}{Sample order of cdsTE and utr3TE.
The parameters are used to make sure that the order of CDS and UTR3 in TE
 is corresponding samples.}

\item{pseudocount}{The number will be add to sum of reads count to avoid X/0.}

\item{log2}{Do log2 transform or not.}
}
\value{
A vector of RRS.
}
\description{
RRS is calculated as the ratio of translational efficiency in
 the CDS with RPFs in the 3'UTR.
}
\examples{

\dontrun{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
RNAs <- dir(path, "mRNA.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
cvgs <- coverageDepth(RPFs, RNAs, gtf)
cvgs.utr3 <- coverageDepth(RPFs, RNAs, gtf, region="utr3")
TE90 <- translationalEfficiency(cvgs, window = 90)
TE90.utr3 <- translationalEfficiency(cvgs.utr3, window = 90)
rrs <- ribosomeReleaseScore(TE90, TE90.utr3)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assignReadingFrame.R
\name{assignReadingFrame}
\alias{assignReadingFrame}
\title{Assign reading frame}
\usage{
assignReadingFrame(reads, CDS, txdb, ignore.seqlevelsStyle = FALSE)
}
\arguments{
\item{reads}{Output of \link{getPsiteCoordinates}}

\item{CDS}{Output of \link{prepareCDS}}

\item{txdb}{A TxDb object. If it is set, assign reading frame for all reads.
Default missing, only assign rading frame for reads in CDS.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}
}
\value{
An GRanges object of reads with reading frame information.
}
\description{
Set reading frame for each reads in CDS region to frame0,
frame1 and frame2.
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite=13)
pc.sub <- pc[pc$qwidth \%in\% c(29, 30)]
#library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
#txdb <- makeTxDbFromGFF(system.file("extdata",
 #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
 #         package="ribosomeProfilingQC"),
 #         organism = "Danio rerio",
 #         chrominfo = seqinfo(Drerio)["chr1"],
 #         taxonomyId = 7955)
#CDS <- prepareCDS(txdb)
CDS <- readRDS(system.file("extdata", "CDS.rds",
                           package="ribosomeProfilingQC"))
pc.sub <- assignReadingFrame(pc.sub, CDS)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PAmotif.R
\name{PAmotif}
\alias{PAmotif}
\title{Metaplot of P site distribution}
\usage{
PAmotif(reads, genome, plot = TRUE, ignore.seqlevelsStyle = FALSE)
}
\arguments{
\item{reads}{Output of \link{assignReadingFrame} or \link{shiftReadsByFrame}.}

\item{genome}{A BSgenome object.}

\item{plot}{Plot the motif or not.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}
}
\value{
A \link[motifStack:pcm-class]{pcm} object
}
\description{
Metaplot of P site distribution in all the CDS aligned by
the start codon or stop codon.
}
\examples{
pcs <- readRDS(system.file("extdata", "samplePc.rds",
               package="ribosomeProfilingQC"))
library(BSgenome.Drerio.UCSC.danRer10)
#PAmotif(pcs, Drerio)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterCDS.R
\name{filterCDS}
\alias{filterCDS}
\title{Filter CDS by size}
\usage{
filterCDS(CDS, sizeCutoff = 100L)
}
\arguments{
\item{CDS}{Output of preparedCDS}

\item{sizeCutoff}{numeric(1). Cutoff size for CDS.
If the size of CDS is less than the cutoff, it will be filtered out.}
}
\value{
A GRanges object with filtered CDS.
}
\description{
Filter CDS by CDS size.
}
\examples{
#library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
#txdb <- makeTxDbFromGFF(system.file("extdata",
 #         "Danio_rerio.GRCz10.91.chr1.gtf.gz",
 #         package="ribosomeProfilingQC"),
 #         organism = "Danio rerio",
 #         chrominfo = seqinfo(Drerio)["chr1"],
 #         taxonomyId = 7955)
#CDS <- prepareCDS(txdb)
CDS <- readRDS(system.file("extdata", "CDS.rds",
                           package="ribosomeProfilingQC"))
filterCDS(CDS)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiftReadsByFrame.R
\name{shiftReadsByFrame}
\alias{shiftReadsByFrame}
\title{Shift reads by reading frame}
\usage{
shiftReadsByFrame(reads, txdb, ignore.seqlevelsStyle = FALSE)
}
\arguments{
\item{reads}{Output of \link{getPsiteCoordinates}}

\item{txdb}{A TxDb object.}

\item{ignore.seqlevelsStyle}{Ignore the sequence name style detection or not.}
}
\value{
Reads with reading frame information
}
\description{
Shift reads P site position by reading frame. After shifting,
all reading frame will be set as 0
}
\examples{
library(Rsamtools)
bamfilename <- system.file("extdata", "RPF.WT.1.bam",
                           package="ribosomeProfilingQC")
yieldSize <- 10000000
bamfile <- BamFile(bamfilename, yieldSize = yieldSize)
pc <- getPsiteCoordinates(bamfile, bestpsite=11)
pc.sub <- pc[pc$qwidth \%in\% c(29, 30)]
library(txdbmaker)
library(BSgenome.Drerio.UCSC.danRer10)
txdb <- makeTxDbFromGFF(system.file("extdata",
          "Danio_rerio.GRCz10.91.chr1.gtf.gz",
          package="ribosomeProfilingQC"),
          organism = "Danio rerio",
          chrominfo = seqinfo(Drerio)["chr1"],
          taxonomyId = 7955)
pc.sub <- shiftReadsByFrame(pc.sub, txdb)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metaPlot.R
\name{metaPlot}
\alias{metaPlot}
\title{Metagene analysis plot}
\usage{
metaPlot(
  UTR5coverage,
  CDScoverage,
  UTR3coverage,
  sample,
  xaxis = c("RPFs", "mRNA"),
  bins = c(UTR5 = 100, CDS = 500, UTR3 = 100),
  ...
)
}
\arguments{
\item{UTR5coverage, CDScoverage, UTR3coverage}{Coverages of UTR5, CDS, and
UTR3 region.
Output of \link{coverageDepth}}

\item{sample}{character(1). Sample name to plot.}

\item{xaxis}{What to plot for x-axis.}

\item{bins}{Bins for UTR5, CDS and UTR3.}

\item{...}{Parameter pass to plot.}
}
\value{
A list contain the data for plot.
}
\description{
Plot the average coverage of UTR5, CDS and UTR3.
}
\examples{

\dontrun{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
RNAs <- dir(path, "mRNA.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
cvgs <- coverageDepth(RPFs[1], RNAs[1], gtf)
cvgs.utr3 <- coverageDepth(RPFs[1], RNAs[1], gtf, region="utr3")
cvgs.utr5 <- coverageDepth(RPFs[1], RNAs[1], gtf, region="utr5")
metaPlot(cvgs.utr5, cvgs, cvgs.utr3, sample=1)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spliceEvent.R
\name{spliceEvent}
\alias{spliceEvent}
\title{Get splicing events}
\usage{
spliceEvent(coverage, group1, group2)
}
\arguments{
\item{coverage}{Coverages of feature region with extensions.
Output of \link{coverageDepth}}

\item{group1, group2}{The sample names of group 1 and group 2}
}
\value{
A GRanges object of splice events.
}
\description{
Get differentical usage of alternative
Translation Initiation Sites,
alternative Polyadenylation Sites or
alternative splicing sites
}
\examples{
\dontrun{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
coverage <- coverageDepth(RPFs, gtf=gtf,
                  level="gene", region="feature with extension")
group1 <- c("RPF.KD1.1", "RPF.KD1.2")
group2 <- c("RPF.WT.1", "RPF.WT.2")
se <- spliceEvent(coverage, group1, group2)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/translationalEfficiency.R
\name{translationalEfficiency}
\alias{translationalEfficiency}
\title{Translational Efficiency}
\usage{
translationalEfficiency(
  x,
  window,
  RPFsampleOrder,
  mRNAsampleOrder,
  pseudocount = 1,
  log2 = FALSE,
  normByLibSize = FALSE,
  shrink = FALSE,
  ...
)
}
\arguments{
\item{x}{Output of \link{getFPKM} or \link{normByRUVs}.
if window is set, it must be output of \link{coverageDepth}.}

\item{window}{numeric(1). window size for maximal counts.}

\item{RPFsampleOrder, mRNAsampleOrder}{Sample order of RPFs and mRNAs.
The parameters are used to make sure that the order of RPFs and mRNAs in
cvgs is corresponding samples.}

\item{pseudocount}{The number will be add to sum of reads count to avoid X/0.}

\item{log2}{Do log2 transform or not.}

\item{normByLibSize}{Normalization by library size or not.
If window size is provided and normByLibSize is set to TRUE,
the coverage will be normalized by library size.}

\item{shrink}{Shrink the TE or not.}

\item{...}{Parameters will be passed to \code{ash} function from \code{ashr}.}
}
\value{
A list with RPFs, mRNA levels and TE as a matrix with
translational efficiency
}
\description{
Calculate Translational Efficiency (TE). TE is defined as
the ratios of the absolute level of ribosome occupancy divided by RNA levels
for transcripts.
}
\examples{
\dontrun{
path <- system.file("extdata", package="ribosomeProfilingQC")
RPFs <- dir(path, "RPF.*?\\\\.[12].bam$", full.names=TRUE)
RNAs <- dir(path, "mRNA.*?\\\\.[12].bam$", full.names=TRUE)
gtf <- file.path(path, "Danio_rerio.GRCz10.91.chr1.gtf.gz")
cnts <- countReads(RPFs, RNAs, gtf, level="gene")
fpkm <- getFPKM(cnts)
te <- translationalEfficiency(fpkm)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotFrameDensity.R
\name{plotFrameDensity}
\alias{plotFrameDensity}
\title{Plot density for each reading frame}
\usage{
plotFrameDensity(
  reads,
  density = TRUE,
  col = c(Frame_0 = "#009E73", Frame_1 = "#D55E00", Frame_2 = "#0072B2")
)
}
\arguments{
\item{reads}{Output of \link{assignReadingFrame}}

\item{density}{Plot density or counts}

\item{col}{Colors for reading frames}
}
\value{
A ggplot object.
}
\description{
Plot density for each reading frame.
}
\examples{
pcs <- readRDS(system.file("extdata", "samplePc.rds",
               package="ribosomeProfilingQC"))
plotFrameDensity(pcs)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalizeTEbyLoess.R
\name{normalizeTEbyLoess}
\alias{normalizeTEbyLoess}
\title{Normalize the TE by Loess}
\usage{
normalizeTEbyLoess(
  TE,
  log2 = TRUE,
  pseudocount = 0.001,
  span = 2/3,
  family.loess = "symmetric"
)
}
\arguments{
\item{TE}{output of \link{translationalEfficiency}.}

\item{log2}{logical(1L). Do log2 transform for TE or not. If TE value is not
log2 transformed, please set it as TRUE.}

\item{pseudocount}{The number will be add to sum of reads count to avoid X/0.}

\item{span, family.loess}{Parameters will be passed to \link[stats]{loess}}
}
\value{
A list with RPFs, mRNA levels and TE as a matrix with
log2 transformed translational efficiency.
}
\description{
Fitting the translational efficiency values with the mRNA value by \link[stats]{loess}.
}
\examples{
path <- system.file("extdata", package="ribosomeProfilingQC")
cnts <- readRDS(file.path(path, "cnts.rds"))
fpkm <- getFPKM(cnts)
te <- translationalEfficiency(fpkm)
te1 <- normalizeTEbyLoess(te)
plotTE(te)
plotTE(te1, log2=FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/frameCounts.R
\name{frameCounts}
\alias{frameCounts}
\title{Extract counts for gene level or transcript level}
\usage{
frameCounts(
  reads,
  level = c("tx", "gene"),
  frame0only = TRUE,
  coverageRate = FALSE
)
}
\arguments{
\item{reads}{Output of \link{assignReadingFrame}.}

\item{level}{Transcript or gene level}

\item{frame0only}{Only count for reading frame 0 or not}

\item{coverageRate}{Calculate for coverage or not}
}
\value{
A numeric vector with reads counts.
}
\description{
Calculate the reads counts or coverage rate for gene level or
transcript level.
Coverage is determined by measuring the proportion of in-frame CDS
 positions with >= 1 reads.
}
\examples{
pcs <- readRDS(system.file("extdata", "samplePc.rds",
               package="ribosomeProfilingQC"))
cnts <- frameCounts(pcs)
cnts.gene <- frameCounts(pcs, level="gene")
cvg <- frameCounts(pcs, coverageRate=TRUE)
}
